import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["disabledTooltip", "disabled"];
import React from 'react';
import { List, Tag } from 'antd';
import styles from "./index.module.less";
import { isVisible, isDisabled, hoc } from "../../utils";
import YwButton from "../YwButton";
var preCssFix = 'yw-card-list';
var BtnWithToolTip = hoc.withToolTip(YwButton);
export var renderCardItem = function renderCardItem(item, config) {
  var _value$itemTags;

  var rowKey = config.rowKey,
      _config$operates = config.operates,
      operates = _config$operates === void 0 ? [] : _config$operates,
      formatValues = config.formatValues,
      toggle = config.toggle,
      renderItemMain = config.renderItemMain;
  var value = formatValues(item);
  return /*#__PURE__*/React.createElement(List.Item, {
    className: styles[preCssFix + "-default-item"] + " " + styles[preCssFix + "-card-item"],
    key: item[rowKey],
    style: value.itemStyle
  }, /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-card-item-main"]
  }, value.renderItemAvatar && /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-card-item-avatar"]
  }, value.renderItemAvatar()), /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-card-item-text"]
  }, value.renderItemMain && value.renderItemMain())), /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-default-item-operates"]
  }, !!((_value$itemTags = value.itemTags) !== null && _value$itemTags !== void 0 && _value$itemTags.length) && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-default-item-tags"]
  }, value.itemTags.filter(function (v) {
    return v.fixed !== 'right';
  }).map(function (v) {
    return /*#__PURE__*/React.createElement(Tag, {
      color: v.color,
      style: v.style,
      visible: isVisible(v.visible, item)
    }, v.value);
  })), /*#__PURE__*/React.createElement("div", {
    className: "" + styles[preCssFix + "-default-item-tags-right"]
  }, value.itemTags.filter(function (v) {
    return v.fixed === 'right';
  }).map(function (v) {
    return /*#__PURE__*/React.createElement(Tag, {
      style: v.style,
      color: v.color,
      visible: isVisible(v.visible, item)
    }, v.value);
  }))), value.operates && value.operates.map(function (_ref) {
    var disabledTooltip = _ref.disabledTooltip,
        disabled = _ref.disabled,
        v = _objectWithoutPropertiesLoose(_ref, _excluded);

    return /*#__PURE__*/React.createElement(BtnWithToolTip, _extends({}, v, {
      tooltip: disabled && disabledTooltip ? {
        title: disabledTooltip,
        placement: 'top'
      } : false,
      visible: isVisible(v.visible, item),
      disabled: isDisabled(disabled, item)
    }));
  })));
};