import _extends from "@babel/runtime/helpers/extends";
import React from 'react';
import { List, Checkbox, Tag } from 'antd';
import styles from "./index.module.less";
import { isVisible, isDisabled, isFunction } from "../../utils";
import { TagsInfo } from "../YwTable/components/detailInfo";
import YwButton from "../YwButton";
var preCssFix = 'yw-card-list';
export var renderDefaultItem = function renderDefaultItem(item, config) {
  var _value$itemTags;

  var isSelected = config.isSelected,
      rowKey = config.rowKey,
      formatValues = config.formatValues,
      toggle = config.toggle,
      _config$rowSelection = config.rowSelection,
      rowSelection = _config$rowSelection === void 0 ? {} : _config$rowSelection;
  var value = formatValues(item);

  var checkboxProps = _extends({
    disabled: false
  }, isFunction(rowSelection.getCheckboxProps) ? rowSelection.getCheckboxProps(item) : {}, {
    checked: isSelected(item[rowKey]),
    onClick: function onClick() {
      toggle(item[rowKey]);
      isFunction(rowSelection.onSelect) && rowSelection.onSelect(item, isSelected(item[rowKey]));
    }
  });

  return /*#__PURE__*/React.createElement(List.Item, {
    className: styles[preCssFix + "-default-item"],
    style: value.itemStyle,
    key: item[rowKey]
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'flex-start',
      flex: '1'
    }
  }, !value.hideSelect && /*#__PURE__*/React.createElement(Checkbox, checkboxProps), /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-default-item-main"]
  }, value !== null && value !== void 0 && value.renderItemImg ? /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-default-item-img"]
  }, value.renderItemImg()) : value.imgUrl && /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-default-item-img"]
  }, /*#__PURE__*/React.createElement("img", {
    src: value.imgUrl,
    alt: ""
  })), /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-default-item-text"]
  }, value.renderItemMain && value.renderItemMain(item), /*#__PURE__*/React.createElement(TagsInfo, {
    tags: value.tags,
    record: item
  }), value.renderItemShop && value.renderItemShop(item), value.renderItemFooter ? /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-default-item-footer"]
  }, value.renderItemFooter(item)) : ''))), /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-default-item-operates"]
  }, !!((_value$itemTags = value.itemTags) !== null && _value$itemTags !== void 0 && _value$itemTags.length) && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-default-item-tags"]
  }, value.itemTags.filter(function (v) {
    return v.fixed !== 'right';
  }).map(function (v) {
    return /*#__PURE__*/React.createElement(Tag, {
      style: v.style,
      color: v.color,
      visible: isVisible(v.visible, item)
    }, v.value);
  })), /*#__PURE__*/React.createElement("div", {
    className: "" + styles[preCssFix + "-default-item-tags-right"]
  }, value.itemTags.filter(function (v) {
    return v.fixed === 'right';
  }).map(function (v) {
    return /*#__PURE__*/React.createElement(Tag, {
      style: v.style,
      color: v.color,
      visible: isVisible(v.visible, item)
    }, v.value);
  }))), value.operates && value.operates.map(function (v, i) {
    if (v.render) {
      return /*#__PURE__*/React.createElement("span", {
        key: i,
        style: {
          marginRight: '8px',
          marginBottom: '12px'
        }
      }, v.render(item, config.reload));
    }

    return /*#__PURE__*/React.createElement(YwButton, _extends({}, v, {
      visible: isVisible(v.visible, item),
      disabled: isDisabled(v.disabled, item),
      onClick: function onClick() {
        v.onClick(item[rowKey], config.reload);
      }
    }));
  })));
};