import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/extends";
var _excluded = ["dataSource", "pagination", "rowKey", "operates", "rowSelection"],
    _excluded2 = ["dataSource"];
import React, { useState, useEffect, useMemo, useImperativeHandle } from 'react';
import { List, Checkbox, Spin, ConfigProvider } from 'antd';
import { isVisible, isDisabled, isObject, isFunction } from "../../utils/index";
import zhCN from 'antd/es/locale/zh_CN';
import { useSelections } from 'ahooks';
import styles from "./index.module.less";
import YwButton from "../YwButton";
import usePagination from "../YwTable/usePagination";
import { renderDefaultItem } from "./defaultItem";
import { renderCardItem } from "./cardItem";

var formatFilter = function formatFilter(buttons, _ref) {
  if (buttons === void 0) {
    buttons = [];
  }

  var reload = _ref.reload,
      _ref$innerFilter = _ref.innerFilter,
      innerFilter = _ref$innerFilter === void 0 ? {} : _ref$innerFilter,
      updateInnerFilter = _ref.updateInnerFilter;
  return buttons.filter(function (v) {
    return v.type === 'filter' && isVisible(v.visible, null);
  }).map(function (v, i) {
    return v.children || /*#__PURE__*/React.createElement(Checkbox, {
      disabled: isDisabled(v.disabled, null),
      defaultChecked: v.defaultValue || false,
      checked: innerFilter[v.name],
      onChange: function onChange(e) {
        var _updateInnerFilter;

        v.name && updateInnerFilter((_updateInnerFilter = {}, _updateInnerFilter[v.name] = e.target.checked, _updateInnerFilter)); // v.onChange && v.onChange(e.target.checked);
        // v.onClick(selectedRowKeys, selectedData, reload);
      }
    }, v.btnText);
  });
};

var formatBatchBtn = function formatBatchBtn(buttons, _ref2) {
  if (buttons === void 0) {
    buttons = [];
  }

  var hasSelect = _ref2.hasSelect,
      selectedRowKeys = _ref2.selectedRowKeys,
      selectedData = _ref2.selectedData,
      reload = _ref2.reload;
  return buttons.filter(function (v) {
    return v.type === 'batch';
  }).map(function (v, i) {
    return v.children || /*#__PURE__*/React.createElement(YwButton, _extends({}, v, {
      btnType: "link",
      visible: isVisible(v.visible, null),
      disabled: !hasSelect || isDisabled(v.disabled, null),
      onClick: function onClick() {
        v.onClick(selectedRowKeys, selectedData, reload);
      }
    }));
  });
};

var CheckableList = function CheckableList(_ref3) {
  var dataSource = _ref3.dataSource,
      pagination = _ref3.pagination,
      rowKey = _ref3.rowKey,
      operates = _ref3.operates,
      _ref3$rowSelection = _ref3.rowSelection,
      rowSelection = _ref3$rowSelection === void 0 ? {} : _ref3$rowSelection,
      props = _objectWithoutPropertiesLoose(_ref3, _excluded);

  var _useSelections = useSelections(dataSource.map(function (v) {
    return v[rowKey];
  }), (rowSelection === null || rowSelection === void 0 ? void 0 : rowSelection.selectedRowKeys) || []),
      selected = _useSelections.selected,
      allSelected = _useSelections.allSelected,
      isSelected = _useSelections.isSelected,
      toggle = _useSelections.toggle,
      toggleAll = _useSelections.toggleAll,
      setSelected = _useSelections.setSelected,
      noneSelected = _useSelections.noneSelected,
      unSelect = _useSelections.unSelect,
      select = _useSelections.select,
      partiallySelected = _useSelections.partiallySelected;

  var reload = function reload(_ref4) {
    var _ref4$unSelectKeys = _ref4.unSelectKeys,
        unSelectKeys = _ref4$unSelectKeys === void 0 ? [] : _ref4$unSelectKeys;
    unSelectKeys === null || unSelectKeys === void 0 ? void 0 : unSelectKeys.forEach(function (v) {
      unSelect(v);
    });
    props.reload();
  };

  useEffect(function () {
    rowSelection.onChange && rowSelection.onChange(selected); // props.rowSelection.onSelect && props.rowSelection.onSelect()
  }, [selected]);
  useEffect(function () {
    setSelected((rowSelection === null || rowSelection === void 0 ? void 0 : rowSelection.selectedRowKeys) || []);
  }, [rowSelection.selectedRowKeys]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(List, {
    header: props.renderHeader,
    footer: props.renderFooter // footer={renderFooter({
    //   selected,
    //   allSelected,
    //   toggleAll,
    //   partiallySelected,
    //   renderFooter: props.renderFooter,
    // })}
    ,
    rowSelection: rowSelection,
    dataSource: dataSource,
    pagination: pagination,
    renderItem: function renderItem(item) {
      return props.renderItem ? props.renderItem(item, _extends({
        isSelected: isSelected,
        rowKey: rowKey,
        operates: operates,
        toggle: toggle
      }, props, {
        reload: reload
      })) : renderDefaultItem(item, _extends({
        isSelected: isSelected,
        unSelect: unSelect,
        rowKey: rowKey,
        operates: operates,
        toggle: toggle,
        rowSelection: rowSelection
      }, props, {
        reload: reload
      }));
    }
  }), props.renderFooter && props.renderFooter({
    selected: selected,
    allSelected: allSelected,
    toggleAll: toggleAll,
    partiallySelected: partiallySelected,
    dataSource: dataSource
  }), !props.renderFooter && /*#__PURE__*/React.createElement("div", {
    className: styles['yw-card-list-footer'],
    style: props.footerStyle
  }, /*#__PURE__*/React.createElement("div", null, rowSelection.hideSelectAll !== true && /*#__PURE__*/React.createElement(Checkbox, {
    checked: !noneSelected,
    onClick: function onClick(e) {
      var _data = dataSource.filter(function (record) {
        var checkboxProps = _extends({
          disabled: false
        }, isFunction(rowSelection.getCheckboxProps) ? rowSelection.getCheckboxProps(record) : {}, {
          checked: isSelected(record[rowKey])
        });

        return !(checkboxProps.disabled && !checkboxProps.checked);
      });

      if (e.target.checked) {
        // setSelected(_data.map((v) => v[rowKey]));
        _data === null || _data === void 0 ? void 0 : _data.forEach(function (v) {
          v[rowKey] && select(v[rowKey]);
        });
      } else {
        _data === null || _data === void 0 ? void 0 : _data.forEach(function (v) {
          v[rowKey] && unSelect(v[rowKey]);
        });
      }
    },
    indeterminate: partiallySelected
  }, "\u5171\u9009\u4E2D ", selected.length, " \u6761"), formatBatchBtn(props.buttons, {
    hasSelect: !!selected.length,
    selectedRowKeys: selected,
    selectedData: [],
    reload: reload
  })), /*#__PURE__*/React.createElement(YwButton, {
    type: "primary",
    onClick: function onClick() {
      props.onSubmit(selected, reload);
    },
    loading: props.confirmLoading,
    disabled: !selected.length || props.confirmDisabled
  }, props.confirmText)));
};

var CardList = function CardList(_ref5) {
  var dataSource = _ref5.dataSource,
      props = _objectWithoutPropertiesLoose(_ref5, _excluded2);

  return /*#__PURE__*/React.createElement(List, {
    header: props.renderHeader,
    footer: props.renderFooter,
    style: props.listItemStyle,
    dataSource: dataSource,
    renderItem: function renderItem(item) {
      return props.renderItem ? props.renderItem(item, _extends({}, props)) : renderCardItem(item, _extends({}, props));
    }
  });
};

var getDefaultInnerFilter = function getDefaultInnerFilter(data) {
  var _data2, _data2$filter;

  if (data === void 0) {
    data = [];
  }

  var _inner = {};
  (_data2 = data) === null || _data2 === void 0 ? void 0 : (_data2$filter = _data2.filter(function (v) {
    return v.type === 'filter' && isVisible(v.visible, null);
  })) === null || _data2$filter === void 0 ? void 0 : _data2$filter.forEach(function (v) {
    v.name && (_inner[v.name] = v.defaultValue);
  });
  return _inner;
};

var YwCardList = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$pagination;

  var getDataSource = props.getDataSource,
      filterProps = props.filterProps,
      rowKey = props.rowKey,
      rowSelection = props.rowSelection;

  var _useState = useState((rowSelection === null || rowSelection === void 0 ? void 0 : rowSelection.selectedRowKeys) || []),
      selectedRowKeys = _useState[0],
      setSelectedRowKeys = _useState[1];

  var _useState2 = useState(getDefaultInnerFilter(props.buttons)),
      innerFilter = _useState2[0],
      setInnerFilter = _useState2[1];

  var updateInnerFilter = function updateInnerFilter(_props) {
    setInnerFilter(_extends({}, innerFilter, _props));
  };

  var hasPagination = useMemo(function () {
    return props.pagination !== false;
  }, [props.pagination]);

  var _usePagination = usePagination(function (_ref6, params) {
    var pageIndex = _ref6.pageIndex,
        pageSize = _ref6.pageSize;
    return getDataSource(_extends({}, hasPagination ? {
      pageIndex: pageIndex
    } : {}, hasPagination ? {
      pageSize: pageSize
    } : {}, params));
  }, _extends({}, hasPagination ? {
    defaultPageSize: ((_props$pagination = props.pagination) === null || _props$pagination === void 0 ? void 0 : _props$pagination.pageSize) || 20
  } : {}, {
    manual: true
  })),
      data = _usePagination.data,
      loading = _usePagination.loading,
      pagination = _usePagination.pagination,
      run = _usePagination.run,
      params = _usePagination.params;

  useEffect(function () {
    _refresh();
  }, [filterProps, innerFilter]);

  var _reload = function reload() {
    run(params[0] || {}, params[1] || {});
  };

  var _refresh = function refresh() {
    var _params$, _props$pagination2;

    run({
      pageIndex: 1,
      pageSize: ((_params$ = params[0]) === null || _params$ === void 0 ? void 0 : _params$.pageSize) || ((_props$pagination2 = props.pagination) === null || _props$pagination2 === void 0 ? void 0 : _props$pagination2.pageSize) || 20
    }, _extends({}, filterProps, innerFilter));
    rowSelection && setSelectedRowKeys([]);
  };

  useImperativeHandle(ref, function () {
    return {
      reload: function reload() {
        _reload();
      },
      refresh: function refresh() {
        _refresh();
      }
    };
  });
  var dataSource = (data === null || data === void 0 ? void 0 : data.list) || props.dataSource || [];
  return /*#__PURE__*/React.createElement(ConfigProvider, {
    locale: zhCN
  }, /*#__PURE__*/React.createElement(Spin, {
    spinning: loading
  }, /*#__PURE__*/React.createElement("div", {
    className: styles['yw-card-list'] + " " + props.className,
    style: props.style
  }, /*#__PURE__*/React.createElement("div", null, props.showTotal || props.renderTotal && pagination ? /*#__PURE__*/React.createElement("span", {
    className: styles.total
  }, props.renderTotal ? props.renderTotal(pagination === null || pagination === void 0 ? void 0 : pagination.total) : "\u5171 " + ((pagination === null || pagination === void 0 ? void 0 : pagination.total) || 0) + " \u6761 ") : null, props.buttons && formatFilter(props.buttons, {
    reload: _reload,
    updateInnerFilter: updateInnerFilter,
    innerFilter: innerFilter
  })), rowSelection && !!dataSource.length && /*#__PURE__*/React.createElement(CheckableList, _extends({}, props, {
    reload: _reload,
    dataSource: dataSource,
    rowSelection: _extends({
      selectedRowKeys: selectedRowKeys
    }, rowSelection),
    pagination: isObject(pagination) ? _extends({
      size: 'small'
    }, pagination) : pagination
  })), !rowSelection && !!dataSource.length && /*#__PURE__*/React.createElement(CardList, _extends({}, props, {
    reload: _reload,
    dataSource: dataSource,
    pagination: isObject(pagination) ? _extends({
      size: 'small'
    }, pagination) : pagination
  })))));
});
YwCardList.defaultProps = {
  dataSource: [],
  showTotal: true,
  confirmText: '提 交',
  onSubmit: function onSubmit(value) {},
  filterProps: {},
  // renderHeader: () => {},
  // renderFooter: () => {},
  // listItemStyle: { height: 500 },
  rowKey: 'id'
};
export default YwCardList;