import * as React from 'react';
import { Spin } from 'antd';
import { LinkProvider, LinkBlock } from '@ywfe/yw-linkage';
import styles from "./index.module.less";
import Error from "./components/error";
import Empty from "./components/empty";

var YwContainer = function YwContainer(props) {
  var className = props.className,
      style = props.style,
      children = props.children,
      linkages = props.linkages,
      loading = props.loading,
      error = props.error,
      empty = props.empty,
      title = props.title;
  return /*#__PURE__*/React.createElement(LinkProvider, null, /*#__PURE__*/React.createElement(LinkBlock, {
    linkages: linkages
  }, /*#__PURE__*/React.createElement("div", {
    className: styles["yw-container"] + " " + className,
    style: style
  }, /*#__PURE__*/React.createElement(Spin, {
    size: "large",
    spinning: loading
  }, error && /*#__PURE__*/React.createElement(Error, null), empty && /*#__PURE__*/React.createElement(Empty, null), children))));
};

YwContainer.defaultProps = {
  linkages: []
};
export default YwContainer;