import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["getUserListForOrg", "getOrgList", "visible", "dataSourceForUser", "getDataSource"],
    _excluded2 = ["value"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React, { useEffect, useState, useMemo } from 'react';
import styles from "./index.module.less";
import { Tag, Checkbox, Col, Row, Breadcrumb, Spin, message } from 'antd';
import { get, last, unionBy, keyBy, xorBy } from 'lodash';
import ModalSelector from "../common/modalSelector";
import commonStyles from "../common/index.module.less";
import { formatOptionsList } from "../../utils/index";

var renderUser = function renderUser(userItem) {
  return /*#__PURE__*/React.createElement("div", {
    className: styles['emp-item']
  }, /*#__PURE__*/React.createElement("div", {
    className: styles['avatar']
  }, /*#__PURE__*/React.createElement("img", {
    src: userItem.headIconUrl,
    alt: ""
  })), /*#__PURE__*/React.createElement("div", {
    className: styles['item-info']
  }, /*#__PURE__*/React.createElement("span", {
    className: styles['item-info-name']
  }, userItem.userName, " (", userItem.realName, ")"), /*#__PURE__*/React.createElement("span", null, userItem.position), /*#__PURE__*/React.createElement("span", {
    className: styles['row-1']
  }, userItem.orgPathDesc)));
};

var YwEmpSelector = function YwEmpSelector(_ref) {
  var getUserListForOrg = _ref.getUserListForOrg,
      getOrgList = _ref.getOrgList,
      visible = _ref.visible,
      dataSourceForUser = _ref.dataSourceForUser,
      getDataSource = _ref.getDataSource,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var defaultValue = useMemo(function () {
    return formatOptionsList(props.defaultValue || [], {
      label: 'userId',
      value: 'userName'
    }) || [];
  }, [props.defaultValue]);
  useEffect(function () {
    if (!props.value) return;

    var _v = formatOptionsList(props.value || [], {
      label: 'userId',
      value: 'userName'
    }) || [];

    setSelectValue(_v);
    setCheckedList(_v.map(function (v) {
      return v.value;
    }));
  }, [props.value]);

  var _useState = useState(defaultValue.map(function (v) {
    return v.value;
  })),
      checkedList = _useState[0],
      setCheckedList = _useState[1];

  var _useState2 = useState(false),
      indeterminate = _useState2[0],
      setIndeterminate = _useState2[1];

  var _useState3 = useState(false),
      checkAll = _useState3[0],
      setCheckAll = _useState3[1];

  var _useState4 = useState([]),
      orgList = _useState4[0],
      setOrgList = _useState4[1];

  var _useState5 = useState(defaultValue),
      selectValue = _useState5[0],
      setSelectValue = _useState5[1];

  var _useState6 = useState([]),
      userList = _useState6[0],
      setUserList = _useState6[1];

  var _useState7 = useState(false),
      loading = _useState7[0],
      setLoading = _useState7[1];

  var _useState8 = useState(['[0]']),
      orgPathList = _useState8[0],
      setOrgPathList = _useState8[1];

  var currentOrg = useMemo(function () {
    return get(orgList, last(orgPathList));
  }, [orgPathList, orgList]);
  var orgPath = useMemo(function () {
    return last(orgPathList);
  }, [orgPathList]);
  useEffect(function () {
    if (!dataSourceForUser) return;
    setUserList(formatOptionsList(dataSourceForUser, {
      label: 'userId',
      value: 'userName'
    }));
  }, [dataSourceForUser]);

  var _onChange = function onChange(e, record) {
    if (e.target.checked) {
      var _selectData = unionBy([record], selectValue, 'value');

      if (props.maxItems && (_selectData === null || _selectData === void 0 ? void 0 : _selectData.length) > props.maxItems) {
        message.error('超过数量限制');
        return;
      }

      setCheckedList([].concat(checkedList, [e.target.value]));
      setSelectValue(_selectData);
    } else {
      setCheckedList(checkedList.filter(function (v) {
        return v !== record.value;
      }));
      setSelectValue(xorBy(selectValue, [record], 'value'));
    }
  };

  useEffect(function () {
    var isAll = !!userList.length && userList.every(function (item) {
      return checkedList.includes(item.value);
    });
    setIndeterminate(userList.some(function (item) {
      return checkedList.includes(item.value);
    }) && !isAll);
    setCheckAll(isAll);
  }, [userList, checkedList]);

  var onCheckAllChange = function onCheckAllChange(e) {
    if (e.target.checked) {
      var _selectData = unionBy(userList, selectValue, 'value');

      if (props.maxItems && (_selectData === null || _selectData === void 0 ? void 0 : _selectData.length) > props.maxItems) {
        message.error('超过数量限制');
        return;
      }

      setSelectValue(_selectData);
    } else {
      setSelectValue(xorBy(selectValue, userList, 'value'));
    }

    setCheckedList(e.target.checked ? userList.map(function (v) {
      return v.value;
    }) : []);
  };

  useEffect(function () {
    getOrgList && getOrgList().then(function (orgList) {
      var res = formatOptionsList(orgList, {
        label: 'orgName',
        value: 'orgId',
        children: 'subOrgList'
      });
      setOrgList(res);
    });
  }, []);

  var getDeptUser = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(org) {
      var res;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setLoading(true);
              _context.next = 3;
              return getUserListForOrg({
                orgId: org.value
              });

            case 3:
              res = _context.sent;
              setUserList(formatOptionsList(res, {
                label: 'userId',
                value: 'userName'
              }));
              setLoading(false);

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function getDeptUser(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  var onExpandOrg = function onExpandOrg(org, i) {
    setOrgPathList([].concat(orgPathList, [orgPathList[orgPathList.length - 1] + ".children[" + i + "]"]));
  }; // console.log(get(orgList, `${v}.label`));


  var renderDept = function renderDept() {
    var _currentOrg$children, _currentOrg$children2;

    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: commonStyles['title']
    }, /*#__PURE__*/React.createElement("span", null, "\u676D\u5DDE\u9065\u671B\u79D1\u6280\u6709\u9650\u516C\u53F8")), orgPathList && /*#__PURE__*/React.createElement("div", {
      className: commonStyles['dept-list']
    }, /*#__PURE__*/React.createElement(Breadcrumb, null, orgPathList.map(function (v, i) {
      return /*#__PURE__*/React.createElement(Breadcrumb.Item, {
        className: commonStyles['dept-list-path-item'],
        onClick: function onClick() {
          if (i + 1 === orgPathList.length) return;
          setOrgPathList([].concat(orgPathList.slice(0, i + 1)));
          getDeptUser(get(orgList, v));
        }
      }, get(orgList, v + ".label"));
    }))), /*#__PURE__*/React.createElement(Row, {
      style: {
        paddingLeft: '20px',
        height: '32px'
      }
    }, /*#__PURE__*/React.createElement(Col, null, /*#__PURE__*/React.createElement(Checkbox, {
      disabled: !userList.length,
      onChange: onCheckAllChange,
      className: styles['check-all'],
      checked: checkAll
    }, "\u5168\u9009"))), !!(currentOrg !== null && currentOrg !== void 0 && (_currentOrg$children = currentOrg.children) !== null && _currentOrg$children !== void 0 && _currentOrg$children.length) && /*#__PURE__*/React.createElement(React.Fragment, null, currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children2 = currentOrg.children) === null || _currentOrg$children2 === void 0 ? void 0 : _currentOrg$children2.map(function (v, i) {
      return /*#__PURE__*/React.createElement(Row, {
        align: "middle",
        className: commonStyles['item-row']
      }, /*#__PURE__*/React.createElement(Col, {
        span: 2,
        style: {
          cursor: 'pointer'
        }
      }, /*#__PURE__*/React.createElement(Checkbox, {
        disabled: true // onChange={(e) => {
        //   onChange(e, { value: v.label, label: v.value });
        // }}

      })), /*#__PURE__*/React.createElement(Col, {
        span: 17
      }, /*#__PURE__*/React.createElement("span", {
        style: {
          paddingLeft: '6px'
        }
      }, " ", v.label)), /*#__PURE__*/React.createElement(Col, {
        span: 5,
        className: commonStyles['item-row-right'] // data-disabled={!v.children}
        ,
        onClick: function onClick() {
          onExpandOrg(v, i);
          getDeptUser(v);
        }
      }, /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("img", {
        src: "https://yw-fed-static.oss-cn-hangzhou.aliyuncs.com/ywDesign/img/org_icon.png"
      }), /*#__PURE__*/React.createElement("span", {
        style: {
          marginLeft: '6px'
        }
      }, "\u4E0B\u7EA7"))));
    })));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: styles['yw-emp-selector']
  }, /*#__PURE__*/React.createElement(ModalSelector, _extends({}, props, {
    visible: visible,
    labelInValue: true,
    tagRender: function tagRender(_ref3) {
      var value = _ref3.value,
          props = _objectWithoutPropertiesLoose(_ref3, _excluded2);

      return /*#__PURE__*/React.createElement(Tag, props, value);
    },
    value: selectValue,
    onChange: function onChange(value, data) {
      if (data === void 0) {
        data = [];
      }

      var dataMap = keyBy(data, 'userId');

      var _value = value.map(function (v) {
        var _data$find;

        var userId = (_data$find = data.find(function (item) {
          return item.userName === v.value;
        })) === null || _data$find === void 0 ? void 0 : _data$find.userId;
        return _extends({}, dataMap[userId] || {}, v, {
          label: userId
        });
      });

      setCheckedList(_value.map(function (v) {
        return v.value;
      }));
      setSelectValue(_value);
    },
    onCancel: function onCancel() {
      props.onCancel && props.onCancel();
      setCheckedList(defaultValue.map(function (v) {
        return v.value;
      }));
      setSelectValue(defaultValue);
    },
    onOk: function onOk(data) {
      props.onOk(data === null || data === void 0 ? void 0 : data.map(function (v) {
        var _extends2;

        return _extends({}, v, (_extends2 = {}, _extends2[props.fieldNames.label] = v.userName, _extends2[props.fieldNames.value] = v.label, _extends2));
      }));
    },
    fieldNames: {
      label: 'label',
      value: 'userName'
    },
    fetchOptions: /*#__PURE__*/function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(value) {
        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt("return", new Promise( /*#__PURE__*/function () {
                  var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(resolve) {
                    var data, userData;
                    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _context2.next = 2;
                            return getDataSource(value);

                          case 2:
                            _context2.t0 = _context2.sent;

                            if (_context2.t0) {
                              _context2.next = 5;
                              break;
                            }

                            _context2.t0 = [];

                          case 5:
                            data = _context2.t0;
                            userData = data.map(function (user) {
                              return _extends({}, user, {
                                label: renderUser(user),
                                key: user.userId
                              });
                            });
                            resolve(userData);

                          case 8:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }));

                  return function (_x3) {
                    return _ref5.apply(this, arguments);
                  };
                }()));

              case 1:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      return function (_x2) {
        return _ref4.apply(this, arguments);
      };
    }()
  }), renderDept(), /*#__PURE__*/React.createElement(Spin, {
    spinning: loading
  }, !!userList.length && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Checkbox.Group, {
    style: {
      width: '100%'
    },
    value: checkedList
  }, userList.map(function (v) {
    return /*#__PURE__*/React.createElement(Row, {
      align: "middle",
      className: styles['emp-item'] + " " + styles['emp-item-row'],
      onClick: function onClick(e) {
        var target = document.querySelectorAll("[value=" + v.value + "]");

        if (e.target !== target[0]) {
          target && target[0] && target[0].click();
        }
      }
    }, /*#__PURE__*/React.createElement(Col, {
      span: 2
    }, /*#__PURE__*/React.createElement(Checkbox, {
      value: v.value,
      onChange: function onChange(e) {
        _onChange(e, v);
      }
    })), /*#__PURE__*/React.createElement(Col, {
      className: styles['avatar'],
      span: 4
    }, /*#__PURE__*/React.createElement("img", {
      src: v.headIconUrl
    })), /*#__PURE__*/React.createElement(Col, {
      className: styles['item-info']
    }, /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
      className: styles['item-info-name']
    }, v.userName)), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
      className: styles['row-1']
    }, v.position))));
  }))))));
};

YwEmpSelector.defaultProps = {
  title: '请选择联系人',
  fieldNames: {
    label: 'userName',
    value: 'userId'
  }
};
export default YwEmpSelector;