'use strict';

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === 'function') for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

exports.__esModule = true;

var react_1 = require('react');

var antd_1 = require('@formily/antd');

var index_module_less_1 = require("./index.module.less");

var useCollapseGrid_1 = require("./useCollapseGrid");

var reactive_1 = require('@formily/reactive');

var react_2 = require('@formily/react');

var core_1 = require('@formily/core');

var YwJsonForm_1 = require("../YwJsonForm");

var icons_1 = require('@ant-design/icons');

var obs = reactive_1.observable({
  value: true
});
var QueryForm = react_2.observer(function (_a) {
  var maxRows = _a.maxRows,
      itemWidth = _a.itemWidth,
      columnGap = _a.columnGap,
      props = __rest(_a, ['maxRows', 'itemWidth', 'columnGap']);

  var _b = useCollapseGrid_1.useCollapseGrid({
    maxRows: maxRows,
    itemWidth: itemWidth,
    columnGap: columnGap
  }),
      grid = _b.grid,
      expanded = _b.expanded,
      toggle = _b.toggle,
      isLine = _b.isLine,
      type = _b.type;

  obs.value = isLine;

  var renderButtonGroup = function renderButtonGroup() {
    if (type === 'collapsible') {
      return react_1['default'].createElement(react_1.Fragment, null, react_1['default'].createElement(antd_1.FormButtonGroup, null, react_1['default'].createElement('a', {
        style: {
          color: '#666',
          fontSize: '12px'
        },
        href: '',
        onClick: function onClick(e) {
          e.preventDefault();
          toggle();
        }
      }, !expanded ? react_1['default'].createElement(react_1['default'].Fragment, null, " \u5C55\u5F00", react_1['default'].createElement(icons_1.DownOutlined, {
        style: {
          marginLeft: '9px',
          color: '#999'
        }
      })) : react_1['default'].createElement(react_1['default'].Fragment, null, " \u6536\u8D77", react_1['default'].createElement(icons_1.UpOutlined, {
        style: {
          marginLeft: '9px',
          color: '#999'
        }
      })))));
    }
  };

  return react_1['default'].createElement(antd_1.Form, __assign({}, props, {
    feedbackLayout: 'terse'
  }), react_1['default'].createElement(antd_1.FormGrid, {
    grid: grid
  }, props.children, react_1['default'].createElement(antd_1.FormGrid.GridColumn, {
    gridSpan: 24,
    style: {
      display: 'flex',
      justifyContent: 'center'
    }
  }, renderButtonGroup())));
});

function YwFilter(props) {
  var maxRows = props.maxRows,
      maxColumns = props.maxColumns,
      minColumns = props.minColumns,
      items = props.items,
      itemWidth = props.itemWidth,
      initialValues = props.initialValues,
      cache = props.cache,
      columnGap = props.columnGap,
      onSubmit = props.onSubmit,
      onReset = props.onReset,
      others = __rest(props, ['maxRows', 'maxColumns', 'minColumns', 'items', 'itemWidth', 'initialValues', 'cache', 'columnGap', 'onSubmit', 'onReset']);

  var _items = [{
    customComponent: QueryForm,
    componentProps: {
      minColumns: 3,
      maxColumns: 3,
      columnGap: columnGap,
      rowGap: 12,
      itemWidth: itemWidth,
      maxRows: maxRows
    },
    children: items
  }];
  var form = react_1.useMemo(function () {
    return core_1.createForm({
      initialValues: initialValues,
      effects: function effects() {
        core_1.onFormSubmit(function (values) {
          // setSearchInfo(values)
          onSubmit(values);
        });
      }
    });
  }, []);
  return react_1['default'].createElement('div', __assign({
    className: index_module_less_1['default']['yw-filter']
  }, others), react_1['default'].createElement(react_2.FormProvider, {
    form: form
  }, react_1['default'].createElement('div', {
    className: index_module_less_1['default']['form-container']
  }, react_1['default'].createElement(YwJsonForm_1['default'], {
    style: {
      flex: 1
    },
    buttons: [],
    layoutProps: {
      colon: false
    },
    items: _items,
    form: form
  }), react_1['default'].createElement(react_2.Observer, null, function () {
    return react_1['default'].createElement('div', {
      className: index_module_less_1['default']['group-btn-' + (!obs.value ? 'col' : 'line')]
    }, react_1['default'].createElement(antd_1.Submit, {
      onSubmit: true
    }, "\u67E5\u8BE2"), react_1['default'].createElement(antd_1.Reset, {
      onClick: onReset
    }, "\u91CD\u7F6E"));
  }))));
}

exports['default'] = YwFilter;
YwFilter.defaultProps = {
  maxRows: 2,
  maxColumns: 6,
  minColumns: 3,
  itemWidth: 328,
  columnGap: 20,
  items: [],
  initialValues: {},
  children: null,
  onSubmit: function onSubmit() {},
  cache: false,
  onReset: function onReset() {}
};