import { useMemo } from 'react';
import { FormGrid } from '@formily/antd';
export var useCollapseGrid = function useCollapseGrid(_ref) {
  var maxRows = _ref.maxRows,
      itemWidth = _ref.itemWidth,
      columnGap = _ref.columnGap,
      maxColumns = _ref.maxColumns,
      minColumns = _ref.minColumns;
  var grid = useMemo(function () {
    return FormGrid.createFormGrid({
      maxColumns: maxColumns,
      minColumns: minColumns,
      maxWidth: itemWidth,
      minWidth: itemWidth,
      strictAutoFit: true,
      rowGap: 12,
      columnGap: columnGap,
      maxRows: maxRows,
      shouldVisible: function shouldVisible(node, grid) {
        if (node.index === grid.childSize - 1) return true;
        if (grid.maxRows === Infinity) return true;
        return node.shadowRow < maxRows + 1;
      }
    });
  }, []);
  var expanded = grid.maxRows === Infinity;
  var realRows = grid.shadowRows;
  var computeRows = grid.fullnessLastColumn ? grid.shadowRows - 1 : grid.shadowRows;

  var toggle = function toggle() {
    if (grid.maxRows === Infinity) {
      grid.maxRows = maxRows;
    } else {
      grid.maxRows = Infinity;
    }
  };

  var takeType = function takeType() {
    if (realRows < maxRows + 1) return 'incomplete-wrap';
    if (computeRows > maxRows) return 'collapsible';
    return 'complete-wrap';
  };

  return {
    grid: grid,
    expanded: expanded,
    toggle: toggle,
    isLine: computeRows === 1,
    type: takeType()
  };
};