import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/extends";
var _excluded = ["sortable", "layoutProps", "hasAdd", "maxRow", "minRow", "arrayConfig", "name", "editable", "itemsType"];
import React from 'react';
import { ArrayItems } from '@formily/antd';
import { FormProvider, createSchemaField, useParentForm, Observer, useFieldSchema } from '@formily/react';
import * as COMPS from "./components";
import { formatOptionsList } from "../../utils";
import { useAsyncDataSource } from "./hook";
var SchemaField = createSchemaField({
  components: _extends({}, COMPS, {
    ArrayItems: ArrayItems
  })
});

var getArrayItemsSchema = function getArrayItemsSchema(_ref) {
  var _properties;

  var sortable = _ref.sortable,
      name = _ref.name,
      arrayConfig = _ref.arrayConfig,
      editable = _ref.editable,
      arrSchema = _ref.arrSchema,
      maxRow = _ref.maxRow,
      minRow = _ref.minRow,
      itemsType = _ref.itemsType;
  var records = {};
  arrayConfig.forEach(function (item, idx) {
    var _item$componentProps, _item$componentProps2, _item$componentProps3, _item$componentProps4;

    var options = item["enum"] || formatOptionsList((_item$componentProps = item.componentProps) === null || _item$componentProps === void 0 ? void 0 : _item$componentProps.dataSource, (_item$componentProps2 = item.componentProps) === null || _item$componentProps2 === void 0 ? void 0 : _item$componentProps2.fieldNames) || formatOptionsList((_item$componentProps3 = item.componentProps) === null || _item$componentProps3 === void 0 ? void 0 : _item$componentProps3.dict, {
      label: 'dictName',
      value: 'dictValue'
    });
    records[item.name] = _extends({}, item, {
      "enum": options,
      type: item.type || 'string'
    }, (_item$componentProps4 = item.componentProps) !== null && _item$componentProps4 !== void 0 && _item$componentProps4.getDataSource && item.component !== 'SearchSelect' ? {
      'x-reactions': ['{{useAsyncDataSource()}}']
    } : {}, {
      "default": item.defaultValue,
      'x-disabled': item.disabled,
      'x-decorator': item.editable ? 'Editable' : 'FormItem',
      'x-component': COMPS[item.component],
      'x-validator': item.rules,
      'x-decorator-props': _extends({}, item.props || {}),
      'x-component-props': _extends({}, item.componentProps)
    });
  });
  var remove = {
    type: 'void',
    title: '',
    'x-component': 'ArrayItems.Remove',
    'x-reactions': {
      dependencies: [name],
      fulfill: {
        schema: {
          'x-visible': '{{$deps[0]?.length > minRow}}' // 任意层次属性都支持表达式

        }
      }
    }
  };
  var moveUp = {
    type: 'void',
    'x-visible': sortable,
    'x-component': 'ArrayItems.MoveUp'
  };
  var moveDown = {
    type: 'void',
    'x-visible': sortable,
    'x-component': 'ArrayItems.MoveDown'
  };
  var addition = {
    type: 'string',
    title: '',
    'x-component': 'ArrayItems.Addition',
    'x-component-props': {
      align: 'left',
      type: 'link'
    },
    'x-reactions': {
      dependencies: [name],
      fulfill: {
        schema: {
          'x-visible': '{{!!hasAdd}}'
        }
      }
    }
  };

  var getItems = function getItems() {
    if (itemsType === 'string') {
      return {
        type: 'void',
        'x-component': 'Space',
        'x-component-props': {
          align: 'flex-start'
        },
        properties: _extends({}, records, {
          addition: addition,
          remove: remove,
          moveUp: moveUp,
          moveDown: moveDown
        })
      };
    }

    return {
      type: 'object',
      properties: {
        space: {
          type: 'void',
          'x-component': 'Space',
          'x-component-props': {
            align: 'flex-start'
          },
          properties: _extends({}, records, {
            addition: addition,
            remove: remove,
            moveUp: moveUp,
            moveDown: moveDown
          })
        }
      }
    };
  };

  return {
    type: 'object',
    properties: (_properties = {}, _properties[name] = _extends({}, arrSchema, {
      title: '',
      'x-component': 'ArrayItems',
      'x-decorator': 'FormItem',
      'x-decorator-props': {
        style: {
          marginBottom: 0
        }
      },
      'x-read-pretty': arrSchema.readOnly,
      maxItems: maxRow,
      minItems: minRow,
      'x-component-props': _extends({}, arrSchema['x-component-props']),
      items: getItems()
    }), _properties)
  };
};

var YArrayItems = function YArrayItems(_ref2) {
  var sortable = _ref2.sortable,
      layoutProps = _ref2.layoutProps,
      _ref2$hasAdd = _ref2.hasAdd,
      hasAdd = _ref2$hasAdd === void 0 ? true : _ref2$hasAdd,
      _ref2$maxRow = _ref2.maxRow,
      maxRow = _ref2$maxRow === void 0 ? 9999 : _ref2$maxRow,
      _ref2$minRow = _ref2.minRow,
      minRow = _ref2$minRow === void 0 ? 0 : _ref2$minRow,
      _ref2$arrayConfig = _ref2.arrayConfig,
      arrayConfig = _ref2$arrayConfig === void 0 ? [] : _ref2$arrayConfig,
      name = _ref2.name,
      editable = _ref2.editable,
      _ref2$itemsType = _ref2.itemsType,
      itemsType = _ref2$itemsType === void 0 ? 'object' : _ref2$itemsType,
      props = _objectWithoutPropertiesLoose(_ref2, _excluded);

  var form = useParentForm();
  var arrSchema = useFieldSchema();
  var schema = getArrayItemsSchema({
    sortable: sortable,
    arrayConfig: arrayConfig,
    name: name,
    editable: editable,
    arrSchema: arrSchema,
    maxRow: maxRow,
    minRow: minRow,
    itemsType: itemsType
  });
  return /*#__PURE__*/React.createElement(FormProvider, {
    form: form
  }, /*#__PURE__*/React.createElement(Observer, null, /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema,
    scope: {
      maxRow: maxRow,
      hasAdd: hasAdd,
      minRow: minRow,
      sortable: sortable,
      itemsType: itemsType,
      useAsyncDataSource: useAsyncDataSource
    }
  })));
};

export default YArrayItems;