import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/extends";
var _excluded = ["sortable", "layoutProps", "hasAdd", "maxRow", "minRow", "arrayConfig", "name", "editable"];
import React from 'react';
import { ArrayTable } from '@formily/antd';
import { FormProvider, createSchemaField, useParentForm, observer, useFieldSchema } from '@formily/react';
import * as COMPS from "./components";
var SchemaField = createSchemaField({
  components: _extends({}, COMPS, {
    ArrayTable: ArrayTable
  })
});

var getArrayTableSchema = function getArrayTableSchema(_ref) {
  var _properties2;

  var sortable = _ref.sortable,
      name = _ref.name,
      arrayConfig = _ref.arrayConfig,
      editable = _ref.editable,
      arrSchema = _ref.arrSchema;
  var records = {};
  arrayConfig.forEach(function (item, idx) {
    var _properties;

    records["NO_FIELD_NAME_" + item.name + "_" + idx] = {
      type: 'void',
      'x-component': 'ArrayTable.Column',
      'x-component-props': {
        title: item.title,
        align: 'left'
      },
      properties: (_properties = {}, _properties[item.name] = _extends({}, item, {
        title: '',
        "default": '',
        'x-disabled': item.disabled,
        'x-decorator': item.editable ? 'Editable' : 'FormItem',
        'x-component': COMPS[item.component],
        'x-validator': item.rules,
        'x-decorator-props': {},
        'x-component-props': _extends({}, item.componentProps, {
          required: true
        })
      }), _properties)
    };
  });
  return {
    type: 'object',
    properties: (_properties2 = {}, _properties2[name] = _extends({}, arrSchema, {
      title: '',
      'x-decorator': 'FormItem',
      'x-decorator-props': {
        style: {
          marginBottom: 0
        }
      },
      // default: dataSource,
      'x-read-pretty': arrSchema.readOnly,
      'x-component-props': _extends({
        pagination: {
          pageSize: 10
        }
      }, arrSchema['x-component-props'], {
        align: 'left',
        bordered: false
      }),
      items: {
        type: 'object',
        properties: _extends({
          column1: {
            type: 'void',
            'x-visible': false,
            'x-component': 'ArrayTable.Column',
            'x-component-props': {
              title: 'Sort',
              align: 'center'
            },
            properties: {
              sort: {
                type: 'void',
                // 'x-visible': false,
                'x-component': 'ArrayTable.SortHandle'
              }
            }
          }
        }, records, {
          column6: {
            type: 'void',
            'x-reactions': {
              dependencies: [name],
              fulfill: {
                schema: {
                  'x-visible': '{{($deps[0]?.length > minRow) || sortable}}' // 任意层次属性都支持表达式

                }
              }
            },
            'x-component': 'ArrayTable.Column',
            'x-component-props': {
              title: '',
              dataIndex: 'operations' // fixed: 'right',

            },
            properties: {
              item: {
                type: 'void',
                'x-component': 'Space',
                properties: {
                  addition: {
                    type: 'string',
                    title: '',
                    'x-component': 'ArrayTable.Addition',
                    'x-component-props': {
                      align: 'left',
                      type: 'link'
                    },
                    'x-reactions': {
                      dependencies: [name],
                      fulfill: {
                        schema: {
                          'x-visible': '{{ hasAdd && sortable }}'
                        }
                      }
                    }
                  },
                  remove: {
                    type: 'void',
                    'x-reactions': {
                      dependencies: [name],
                      fulfill: {
                        schema: {
                          'x-visible': '{{ hasAdd && sortable }}'
                        }
                      }
                    },
                    'x-component': 'ArrayTable.Remove'
                  },
                  moveDown: {
                    type: 'void',
                    'x-visible': sortable,
                    'x-component-props': {
                      style: {
                        color: '#1890ff'
                      }
                    },
                    'x-component': 'ArrayTable.MoveDown'
                  },
                  moveUp: {
                    type: 'void',
                    'x-visible': sortable,
                    'x-component-props': {
                      style: {
                        color: '#1890ff'
                      }
                    },
                    'x-component': 'ArrayTable.MoveUp'
                  }
                }
              }
            }
          }
        })
      }
    }), _properties2)
  };
};

var YArrayTable = function YArrayTable(_ref2) {
  var sortable = _ref2.sortable,
      layoutProps = _ref2.layoutProps,
      _ref2$hasAdd = _ref2.hasAdd,
      hasAdd = _ref2$hasAdd === void 0 ? true : _ref2$hasAdd,
      _ref2$maxRow = _ref2.maxRow,
      maxRow = _ref2$maxRow === void 0 ? 9999 : _ref2$maxRow,
      _ref2$minRow = _ref2.minRow,
      minRow = _ref2$minRow === void 0 ? 0 : _ref2$minRow,
      _ref2$arrayConfig = _ref2.arrayConfig,
      arrayConfig = _ref2$arrayConfig === void 0 ? [] : _ref2$arrayConfig,
      name = _ref2.name,
      editable = _ref2.editable,
      props = _objectWithoutPropertiesLoose(_ref2, _excluded);

  var form = useParentForm();
  var arrSchema = useFieldSchema();
  var schema = getArrayTableSchema({
    sortable: sortable,
    arrayConfig: arrayConfig,
    name: name,
    editable: editable,
    arrSchema: arrSchema
  });
  return /*#__PURE__*/React.createElement(FormProvider, {
    form: form
  }, /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema,
    scope: {
      maxRow: maxRow,
      hasAdd: hasAdd,
      minRow: minRow,
      sortable: sortable
    }
  }));
};

export default observer(YArrayTable);