import _CascaderSelect from "@alifd/next/lib/cascader-select";
import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["value", "fieldNames", "loadData", "labelInValue"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React from 'react';
import { useField } from '@formily/react';
import { observable } from '@formily/reactive';
import { Observer } from '@formily/react';
import { set } from 'lodash';
import { formatOptionsList, isArray, isObject } from "../../utils/index";
var obs = observable({
  dataSource: []
});

var YCascaderSelect = function YCascaderSelect(_ref) {
  var _field$initialValue;

  var value = _ref.value,
      fieldNames = _ref.fieldNames,
      loadData = _ref.loadData,
      _ref$labelInValue = _ref.labelInValue,
      labelInValue = _ref$labelInValue === void 0 ? false : _ref$labelInValue,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var field = useField();
  var defaultValue = isArray(field.initialValue) ? (_field$initialValue = field.initialValue) === null || _field$initialValue === void 0 ? void 0 : _field$initialValue.map(function (item) {
    return isObject(item) ? item[fieldNames.value] : item;
  }) : field.initialValue;
  return /*#__PURE__*/React.createElement(Observer, null, function () {
    return /*#__PURE__*/React.createElement(_CascaderSelect, _extends({}, props, {
      disabled: field.disabled,
      dataSource: field.dataSource,
      value: field.value,
      isPreview: !field.editable,
      defaultValue: defaultValue,
      onChange: function onChange(value, data, extra) {
        field.setValue(value);
        props.onChange && props.onChange(value, data, extra); // if (props.onChange) {
        //   props.onChange(field, value, data, extra);
        // } else {
        //   console.log(value);
        //   field.setValue(value);
        // }
      }
    }, loadData ? {
      loadData: function () {
        var _loadData = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(data, source) {
          var _data$pos;

          var res;
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return props.getDataSource(field, data);

                case 2:
                  res = _context.sent;
                  source.children = formatOptionsList(res, fieldNames);
                  set([obs.dataSource], (_data$pos = data.pos) === null || _data$pos === void 0 ? void 0 : _data$pos.split('-'), source);
                  return _context.abrupt("return", obs.dataSource);

                case 6:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function loadData(_x, _x2) {
          return _loadData.apply(this, arguments);
        }

        return loadData;
      }()
    } : {}));
  });
};

export default YCascaderSelect;