import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["value", "fieldNames"];
import React, { useState } from 'react';
import { Select } from 'antd';
import { useField } from '@formily/react';
import YwEmpSelector from "../YwEmpSelector/index";
import { formatOptionsList, formatDataList } from "../../utils/index";
import { useFormEffects } from '@formily/react';
import { onFieldValueChange } from '@formily/core';

var YEmpSelector = function YEmpSelector(_ref) {
  var value = _ref.value,
      _ref$fieldNames = _ref.fieldNames,
      fieldNames = _ref$fieldNames === void 0 ? {
    label: 'userName',
    value: 'userId'
  } : _ref$fieldNames,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var field = useField();

  var _useState = useState(false),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = useState(field.initialValue || []),
      empValue = _useState2[0],
      setEmpValue = _useState2[1];

  var maxItems = props.maxItems;
  useFormEffects(function () {
    onFieldValueChange(field.props.name, function (field) {
      setEmpValue(field.value);
    });
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Select, {
    onDropdownVisibleChange: function onDropdownVisibleChange(open) {
      open && setVisible(open);
    } // onFocus={() => {
    //     console.log(111)
    //   setVisible(true);
    // }}
    ,
    dropdownStyle: {
      display: 'none'
    },
    labelInValue: true,
    value: formatOptionsList(empValue, fieldNames),
    onChange: function onChange(v) {
      field.setValue(formatDataList(v, {
        label: 'userName',
        value: 'userId'
      }));
    },
    dropdownRender: function dropdownRender() {
      return null;
    },
    disabled: field.disabled,
    options: formatOptionsList(empValue, fieldNames),
    mode: maxItems !== 1 ? 'multiple' : null // defaultValue={field.initialValue}
    // open={false}

  }), /*#__PURE__*/React.createElement(YwEmpSelector, _extends({}, props, {
    visible: visible,
    onCancel: function onCancel() {
      setVisible(false);
    },
    defaultValue: field.initialValue,
    value: field.value,
    onOk: function onOk(data) {
      setEmpValue(data);
      field.setValue(data);
      setVisible(false);
    }
  })));
};

export default YEmpSelector;