import _extends from "@babel/runtime/helpers/extends";
import React from 'react';
import { Select, Input } from '@formily/antd';
import { FormProvider, createSchemaField, useField, useFieldSchema, useParentForm, useFormEffects } from '@formily/react';
import { onFieldChange } from '@formily/core';
import * as COMPS from "./components";
import { keys } from 'lodash';
var SchemaField = createSchemaField({
  components: _extends({}, COMPS)
});

var YInputGroup = function YInputGroup(props) {
  var field = useField();
  var form = useParentForm();
  var schema = useFieldSchema();
  var options = field.dataSource;
  var fieldName = keys(schema.properties);
  useFormEffects(function () {
    onFieldChange(schema.name, function (field) {
      var _schema$properties$fi;

      form.setValuesIn(fieldName, ((_schema$properties$fi = schema.properties[fieldName]) === null || _schema$properties$fi === void 0 ? void 0 : _schema$properties$fi["default"]) || undefined);
    });
    onFieldChange(fieldName, function (field) {
      options.forEach(function (v) {
        form.setValuesIn(v.value, undefined);
      });
      form.setValuesIn([form.getValuesIn(schema.name)], field.value);
    });
  });
  return /*#__PURE__*/React.createElement(FormProvider, {
    form: form
  }, field.editable ? /*#__PURE__*/React.createElement(Input.Group, {
    compact: true
  }, /*#__PURE__*/React.createElement(Select, _extends({
    defaultValue: field.initialValue,
    disabled: field.disabled,
    options: options
  }, props)), /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema
  })) : /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema
  }));
};

export default YInputGroup;