import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["prefix", "suffix"];
import React from 'react';
import { NumberPicker, Space } from '@formily/antd';
import { useField } from '@formily/react';
import { VoidField } from '@formily/react';
import { isArray } from "../../utils/index";

var YNumberRangePicker = function YNumberRangePicker(_ref) {
  var prefix = _ref.prefix,
      suffix = _ref.suffix,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var field = useField();

  var getValue = function getValue(data, idx) {
    return isArray(data) ? data[idx] : data;
  };

  var commonProps = _extends({
    formatter: function formatter(value) {
      return "" + (prefix ? prefix + " " : '') + props.formatter(value);
    }
  }, suffix ? {
    style: {
      paddingRight: suffix.length * 12 + 22 + "px"
    }
  } : {});

  var renderSuffix = function renderSuffix() {
    return suffix && /*#__PURE__*/React.createElement("span", {
      style: {
        position: 'absolute',
        right: '26px'
      }
    }, suffix);
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(VoidField, {
    component: [Space],
    decorator: ['Space', {
      align: 'center'
    }]
  }, /*#__PURE__*/React.createElement("span", {
    style: {
      position: 'relative'
    }
  }, /*#__PURE__*/React.createElement(NumberPicker, _extends({}, props, commonProps, {
    value: getValue(props.value, 0),
    min: getValue(props.min, 0),
    max: getValue(props.value, 1) !== undefined ? Math.min(getValue(props.value, 1), getValue(props.max, 0)) : getValue(props.max, 0),
    onChange: function onChange(num) {
      field.setValue([num, field.value[1]]);
    }
  })), renderSuffix()), /*#__PURE__*/React.createElement("span", null, "-"), /*#__PURE__*/React.createElement("span", {
    style: {
      position: 'relative'
    }
  }, /*#__PURE__*/React.createElement(NumberPicker, _extends({}, props, commonProps, {
    value: getValue(props.value, 1),
    min: getValue(props.value, 0) !== undefined ? Math.max(getValue(props.value, 0), getValue(props.min, 1)) : getValue(props.min, 1),
    max: getValue(props.max, 1),
    onChange: function onChange(num) {
      field.setValue([field.value[0], num]);
    }
  })), renderSuffix())));
};

YNumberRangePicker.defaultProps = {
  formatter: function formatter(value) {
    return value;
  },
  min: Number.MIN_SAFE_INTEGER,
  max: Number.MAX_SAFE_INTEGER
};
export default YNumberRangePicker;