import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["value", "fieldNames", "getOrgList"];
import React, { useState } from 'react';
import { Select } from 'antd';
import { useField } from '@formily/react';
import YwOrgSelector from "../YwOrgSelector/index";
import { useFormEffects } from '@formily/react';
import { onFieldValueChange } from '@formily/core';
import { formatOptionsList, formatDataList } from "../../utils/index";
import { last } from 'lodash';

var YOrgSelector = function YOrgSelector(_ref) {
  var value = _ref.value,
      _ref$fieldNames = _ref.fieldNames,
      fieldNames = _ref$fieldNames === void 0 ? {
    label: 'orgName',
    value: 'orgId'
  } : _ref$fieldNames,
      getOrgList = _ref.getOrgList,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var field = useField();

  var formatOrgName = function formatOrgName(_value) {
    if (_value === void 0) {
      _value = [];
    }

    return _value.map(function (v) {
      var _v$orgName;

      return _extends({}, v, {
        orgName: last((_v$orgName = v.orgName) === null || _v$orgName === void 0 ? void 0 : _v$orgName.split('/'))
      });
    });
  };

  var _useState = useState(false),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = useState(formatOrgName(field.value || field.initialValue) || []),
      orgValue = _useState2[0],
      setOrgValue = _useState2[1];

  var maxItems = props.maxItems;
  useFormEffects(function () {
    onFieldValueChange(field.props.name, function (field) {
      setOrgValue(formatOrgName(field.value));
    });
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Select, {
    onDropdownVisibleChange: function onDropdownVisibleChange(open) {
      open && setVisible(open);
    },
    dropdownStyle: {
      display: 'none'
    },
    labelInValue: true,
    value: formatOptionsList(orgValue, fieldNames),
    onChange: function onChange(v) {
      field.setValue(formatDataList(v, fieldNames));
    },
    dropdownRender: function dropdownRender() {
      return null;
    },
    disabled: field.disabled,
    options: formatOptionsList(orgValue, fieldNames),
    mode: maxItems !== 1 ? 'multiple' : null // defaultValue={field.initialValue}
    // open={false}

  }), /*#__PURE__*/React.createElement(YwOrgSelector, _extends({}, props, {
    getDataSource: getOrgList,
    visible: visible,
    onCancel: function onCancel() {
      setVisible(false);
    },
    defaultValue: field.initialValue,
    value: formatOrgName(field.value),
    onOk: function onOk(data) {
      var _data;

      if (data === void 0) {
        data = [];
      }

      var value = (_data = data) === null || _data === void 0 ? void 0 : _data.map(function (item) {
        var _ref2;

        return _ref2 = {}, _ref2[fieldNames.label] = item[fieldNames.label], _ref2[fieldNames.value] = item[fieldNames.value], _ref2;
      });
      setOrgValue(value);
      field.setValue(value);
      setVisible(false);
    }
  })));
};

export default YOrgSelector;