import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["fetchOptions", "debounceTimeout"];
import React, { useRef, useMemo, useState } from 'react';
import { Select, Spin } from 'antd';
import { PreviewText } from '@formily/antd';
import debounce from 'lodash/debounce';
import { useField, useFieldSchema, useParentForm } from '@formily/react';
import { formatOptionsList } from "../../utils/index";
export function DebounceSelect(_ref) {
  var fetchOptions = _ref.fetchOptions,
      _ref$debounceTimeout = _ref.debounceTimeout,
      debounceTimeout = _ref$debounceTimeout === void 0 ? 800 : _ref$debounceTimeout,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(false),
      fetching = _useState[0],
      setFetching = _useState[1];

  var _useState2 = useState([]),
      options = _useState2[0],
      setOptions = _useState2[1];

  var fetchRef = useRef(0);
  var debounceFetcher = useMemo(function () {
    var loadOptions = function loadOptions(value) {
      if (value === void 0) {
        value = '';
      }

      props.onKeywordChange && props.onKeywordChange(value);
      fetchRef.current += 1;
      var fetchId = fetchRef.current;
      setOptions([]);
      setFetching(true);
      fetchOptions(value.trim()).then(function (newOptions) {
        if (fetchId !== fetchRef.current) {
          // for fetch callback order
          return;
        }

        setOptions(formatOptionsList(newOptions, props.fieldNames) || []);
        setFetching(false);
      });
    };

    props.focusSearch && loadOptions('');
    return debounce(loadOptions, debounceTimeout);
  }, [fetchOptions, debounceTimeout]);
  return /*#__PURE__*/React.createElement(Select, _extends({
    filterOption: false,
    onSearch: debounceFetcher,
    showSearch: true,
    showArrow: true,
    notFoundContent: fetching ? /*#__PURE__*/React.createElement(Spin, {
      size: "small"
    }) : null,
    ref: function ref(el) {
      el && props.selectRef && props.selectRef({
        current: el
      });
    }
  }, props, {
    options: options
  }));
}

var YSearchSelect = function YSearchSelect(props) {
  var field = useField();
  var form = useParentForm();
  var schema = useFieldSchema();
  var comProps = schema['x-component-props'] || {}; // const [value, setValue] = useState<UserValue[] | UserValue | null>(
  //   field.initialValue || (comProps.mode ? [] : null),
  // );

  return (// <FormProvider form={form as Form}>
    field.editable ? /*#__PURE__*/React.createElement(DebounceSelect, _extends({
      style: {
        width: '100%'
      },
      onChange: function onChange(newValue) {
        field.setValue(newValue);
        field.validate();
      }
    }, comProps, {
      value: field.value,
      defaultValue: field.initialValue,
      disabled: field.disabled,
      fetchOptions: comProps.getDataSource
    })) : /*#__PURE__*/React.createElement(PreviewText.Select, {
      labelInValue: true,
      mode: props.mode,
      value: field.value,
      options: field.value
    }) // </FormProvider>

  );
};

export default YSearchSelect;