import { action } from '@formily/reactive';
import { formatOptionsList } from "../../utils";
export var useAsyncDataSource = function useAsyncDataSource(dataSource) {
  return function (field) {
    var _field$componentProps, _field$componentProps2;

    var service = ((_field$componentProps = field.componentProps) === null || _field$componentProps === void 0 ? void 0 : _field$componentProps.getDataSource) || dataSource[field.props.name];
    var fieldNames = (_field$componentProps2 = field.componentProps) === null || _field$componentProps2 === void 0 ? void 0 : _field$componentProps2.fieldNames;
    if (!service) return;
    field.loading = true;
    field.dataSource = [];
    service(field).then(action.bound(function (data) {
      var options = formatOptionsList(data, fieldNames);
      field.dataSource = options || [];
      field.loading = false;
    }));
  };
};