import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["getDataSource", "visible"];
import React, { useEffect, useState, useMemo } from 'react';
import styles from "./index.module.less";
import commonStyles from "../common/index.module.less";
import { get, last, uniqBy, pullAllBy, unionBy, filter, every } from 'lodash';
import { Checkbox, Col, Row, Breadcrumb } from 'antd';
import ModalSelector from "../common/modalSelector";
import { formatOptionsList } from "../../utils/index";

var YwOrgSelector = function YwOrgSelector(_ref) {
  var _currentOrg$children, _currentOrg$children2;

  var getDataSource = _ref.getDataSource,
      visible = _ref.visible,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 部门树结构
  var _useState = useState([]),
      orgTreeList = _useState[0],
      setOrgTreeList = _useState[1]; // 部门路径


  var _useState2 = useState([]),
      orgPathList = _useState2[0],
      setOrgPathList = _useState2[1]; // 默认值


  var defaultValue = useMemo(function () {
    return formatOptionsList(props.defaultValue, props.fieldNames);
  }, [props.defaultValue, props.fieldNames]); // 受控值

  var value = useMemo(function () {
    if (!props.value) return null;
    return formatOptionsList(props.value, props.fieldNames);
  }, [props.fieldNames, props.value]); // select组件回显部门数据

  var _useState3 = useState(defaultValue),
      selectValue = _useState3[0],
      setSelectValue = _useState3[1];

  useEffect(function () {
    value && setSelectValue(value);
  }, [value]); // 选中部门id

  var selectIds = useMemo(function () {
    return (selectValue === null || selectValue === void 0 ? void 0 : selectValue.map(function (v) {
      return v.value;
    })) || [];
  }, [selectValue]); // 当前节点

  var currentOrg = useMemo(function () {
    return get(orgTreeList, last(orgPathList));
  }, [orgPathList, orgTreeList]); // 当前path

  var orgPath = useMemo(function () {
    return last(orgPathList);
  }, [orgPathList]); // 是否全选

  var isAll = useMemo(function () {
    return every(currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children, function (_ref2) {
      var value = _ref2.value;
      return selectIds.includes(value);
    });
  }, [selectIds, currentOrg]);

  var onCheckAllChange = function onCheckAllChange(e) {
    if (e.target.checked) {
      setSelectValue(unionBy(selectValue, currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children, 'value'));
    } else {
      setSelectValue([].concat(pullAllBy(selectValue, currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children, 'value')));
    }
  };

  useEffect(function () {
    if (visible) {
      setOrgPathList(['[0]']);

      if (orgTreeList !== null && orgTreeList !== void 0 && orgTreeList.length) {
        return;
      }

      getDataSource().then(function (data) {
        var res = formatOptionsList(data, props.fieldNames);
        var _orgTreeList = res;
        setOrgTreeList(_orgTreeList);
      });
    }
  }, [visible]);
  return /*#__PURE__*/React.createElement("div", {
    className: styles['yw-org-selector']
  }, /*#__PURE__*/React.createElement(ModalSelector, _extends({}, props, {
    visible: visible,
    labelInValue: true,
    autoFocus: false,
    showSearch: false,
    value: selectValue,
    placeholder: "\u8BF7\u9009\u62E9",
    onChange: function onChange(nextValue) {
      setSelectValue(nextValue);
    }
  }), /*#__PURE__*/React.createElement("div", {
    className: commonStyles['title'],
    onClick: function onClick() {
      setOrgPathList(['[0]']);
    }
  }, /*#__PURE__*/React.createElement("span", null, "\u676D\u5DDE\u9065\u671B\u79D1\u6280\u6709\u9650\u516C\u53F8")), orgPathList && /*#__PURE__*/React.createElement("div", {
    className: commonStyles['dept-list']
  }, /*#__PURE__*/React.createElement(Breadcrumb, null, orgPathList.map(function (v, i) {
    // if (i === 0) return;
    return /*#__PURE__*/React.createElement(Breadcrumb.Item, {
      className: commonStyles['dept-list-path-item'],
      onClick: function onClick() {
        setOrgPathList(orgPathList.slice(0, i + 1));
      }
    }, get(orgTreeList, v + ".label"));
  }))), !!(currentOrg !== null && currentOrg !== void 0 && (_currentOrg$children = currentOrg.children) !== null && _currentOrg$children !== void 0 && _currentOrg$children.length) && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Row, {
    style: {
      paddingLeft: '20px',
      height: '38px'
    }
  }, /*#__PURE__*/React.createElement(Col, null, /*#__PURE__*/React.createElement(Checkbox // indeterminate={
  //   !isAll && some(currentOrg.children, ({ value }) => selectIds.includes(value))
  // }
  , {
    onChange: onCheckAllChange,
    checked: isAll
  }, "\u5168\u9009"))), currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children2 = currentOrg.children) === null || _currentOrg$children2 === void 0 ? void 0 : _currentOrg$children2.map(function (v, i) {
    return /*#__PURE__*/React.createElement(Row, {
      align: "middle",
      className: commonStyles['item-row']
    }, /*#__PURE__*/React.createElement(Col, {
      span: 19
    }, /*#__PURE__*/React.createElement(Checkbox, {
      value: v.value,
      checked: selectIds.includes(v.value),
      disabled: v.disabled,
      onChange: function onChange(e) {
        if (e.target.checked) {
          setSelectValue(uniqBy([].concat(selectValue, [v]), 'value'));
        } else {
          setSelectValue(filter(selectValue, function (_ref3) {
            var value = _ref3.value;
            return value !== v.value;
          }));
        }
      }
    }, v.label)), /*#__PURE__*/React.createElement(Col, {
      span: 5,
      className: commonStyles['item-row-right'],
      "data-disabled": selectIds.includes(v.value),
      onClick: function onClick() {
        if (!selectIds.includes(v.value)) {
          setOrgPathList([].concat(orgPathList, [orgPathList[orgPathList.length - 1] + ".children[" + i + "]"]));
        }
      }
    }, /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("img", {
      src: "https://yw-fed-static.oss-cn-hangzhou.aliyuncs.com/ywDesign/img/org_icon.png"
    }), /*#__PURE__*/React.createElement("span", {
      style: {
        marginLeft: '6px'
      }
    }, "\u4E0B\u7EA7"))));
  }))));
};

YwOrgSelector.defaultProps = {
  title: '请选择部门',
  fieldNames: {
    label: 'orgName',
    value: 'orgId',
    children: 'subOrgList'
  },
  defaultValue: []
};
export default YwOrgSelector;