'use strict';

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === 'function') for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

exports.__esModule = true;

var react_1 = require('react');

var antd_1 = require('antd');

var index_module_less_1 = require("./index.module.less");

var TabPane = antd_1.Tabs.TabPane; // const tabs = [
//   { tab: '全部', key: 'key1', content: 'Content of Tab Pane 1', count: 32 },
//   { tab: '我的直播', key: 'key2', content: 'Content of Tab Pane 2', count: 32 },
//   { tab: '进行中', key: 'key3', content: 'Content of Tab Pane 3' },
//   { tab: '我的审核', key: 'key4', content: 'Content of Tab Pane 4', dot: true },
// ]

var Count = function Count(_a) {
  var count = _a.count;
  return react_1['default'].createElement('span', {
    className: index_module_less_1['default']['yw-tab-wrapped-item-count']
  }, count);
};

var renderTabTitle = function renderTabTitle(_a, shape) {
  var dot = _a.dot,
      tab = _a.tab,
      count = _a.count;
  if (dot && shape === 'pure') return react_1['default'].createElement(antd_1.Badge, {
    count: 5,
    dot: true,
    size: 'small',
    offset: [8, 0]
  }, tab);
  if (count !== undefined && shape === 'wrapped') return react_1['default'].createElement(react_1['default'].Fragment, null, tab, ' ', react_1['default'].createElement(Count, {
    count: count
  }));
  return tab;
};

var renderWrappedTabBar = function renderWrappedTabBar(tabBarProps, DefaultTabBar) {
  return react_1['default'].createElement('div', {
    className: index_module_less_1['default']['yw-tab-wrapped']
  }, react_1['default'].createElement(DefaultTabBar, __assign({}, tabBarProps), function (node) {
    return react_1['default'].createElement('div', {
      className: index_module_less_1['default']['yw-tab-wrapped-item']
    }, node);
  }));
};

var renderCapsuleTabBar = function renderCapsuleTabBar(tabBarProps, DefaultTabBar) {
  return react_1['default'].createElement('div', {
    className: index_module_less_1['default']['yw-tab-capsule']
  }, react_1['default'].createElement(DefaultTabBar, __assign({}, tabBarProps), function (node) {
    return react_1['default'].createElement('div', {
      className: index_module_less_1['default']['yw-tab-capsule-item']
    }, node);
  }));
};

var renderTabBar = {
  pure: null,
  wrapped: renderWrappedTabBar,
  capsule: renderCapsuleTabBar
};

function YwTab(props) {
  var shape = props.shape,
      dataSource = props.dataSource,
      _a = props.type,
      type = _a === void 0 ? '' : _a,
      children = props.children,
      others = __rest(props, ['shape', 'dataSource', 'type', 'children']);

  return react_1['default'].createElement('div', {
    className: '' + index_module_less_1['default']['yw-tab']
  }, react_1['default'].createElement(antd_1.Tabs, __assign({}, others, {
    renderTabBar: renderTabBar[shape],
    type: shape !== 'pure' ? 'card' : type
  }), children ? children : dataSource === null || dataSource === void 0 ? void 0 : dataSource.map(function (item) {
    return react_1['default'].createElement(TabPane, {
      key: item.key,
      tab: renderTabTitle(item, shape)
    }, item.content);
  })));
}

exports['default'] = YwTab;
YwTab.TabPane = TabPane;
YwTab.defaultProps = {
  shape: 'pure',
  dataSource: [],
  onChange: function onChange() {}
};