import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["shape", "dataSource", "type", "children", "style"];
import React from 'react';
import { Tabs, Badge } from 'antd';
import styles from "./index.module.less";

var Count = function Count(_ref) {
  var count = _ref.count;
  return /*#__PURE__*/React.createElement("span", {
    className: styles['yw-tab-wrapped-item-count']
  }, count);
};

var renderTabTitle = function renderTabTitle(_ref2, shape) {
  var dot = _ref2.dot,
      tab = _ref2.tab,
      count = _ref2.count;
  if (shape === 'pure') return /*#__PURE__*/React.createElement(Badge, {
    count: count,
    dot: dot,
    size: "small",
    offset: [8, 0]
  }, tab);
  if (count !== undefined && shape === 'wrapped') return /*#__PURE__*/React.createElement(React.Fragment, null, tab, " ", /*#__PURE__*/React.createElement(Count, {
    count: count
  }));
  return tab;
};

var renderWrappedTabBar = function renderWrappedTabBar(tabBarProps, DefaultTabBar) {
  return /*#__PURE__*/React.createElement("div", {
    className: styles['yw-tab-wrapped']
  }, /*#__PURE__*/React.createElement(DefaultTabBar, tabBarProps, function (node) {
    return /*#__PURE__*/React.createElement("div", {
      className: styles['yw-tab-wrapped-item']
    }, node);
  }));
};

var renderCapsuleTabBar = function renderCapsuleTabBar(tabBarProps, DefaultTabBar) {
  return /*#__PURE__*/React.createElement("div", {
    className: styles['yw-tab-capsule']
  }, /*#__PURE__*/React.createElement(DefaultTabBar, tabBarProps, function (node) {
    return /*#__PURE__*/React.createElement("div", {
      className: styles['yw-tab-capsule-item']
    }, node);
  }));
};

var renderTabBar = {
  pure: null,
  wrapped: renderWrappedTabBar,
  capsule: renderCapsuleTabBar
};
export default function YwTab(props) {
  var shape = props.shape,
      dataSource = props.dataSource,
      type = props.type,
      children = props.children,
      style = props.style,
      others = _objectWithoutPropertiesLoose(props, _excluded);

  return /*#__PURE__*/React.createElement("div", {
    className: "" + styles['yw-tab'],
    style: style
  }, /*#__PURE__*/React.createElement(Tabs, _extends({}, others, {
    renderTabBar: renderTabBar[shape],
    type: shape !== 'pure' ? 'card' : type
  }), children || (dataSource === null || dataSource === void 0 ? void 0 : dataSource.map(function (item) {
    return /*#__PURE__*/React.createElement(Tabs.TabPane, {
      key: item.key,
      tab: renderTabTitle(item, shape)
    }, item.content);
  }))));
}
YwTab.defaultProps = {
  shape: 'pure',
  dataSource: [],
  onChange: function onChange() {}
};