import React from 'react';
import styles from "../index.module.less";
import { message, Tooltip } from 'antd';
import { CopyToClipboard } from 'react-copy-to-clipboard';
import { isFunction, isVisible } from "../../../utils/index";
import { CopyIcon } from "../../common/icon";
var preCssFix = 'yw-table-cell';
export var Copy = function Copy(_ref) {
  var text = _ref.text,
      _ref$onCopy = _ref.onCopy,
      _onCopy = _ref$onCopy === void 0 ? function () {} : _ref$onCopy;

  return /*#__PURE__*/React.createElement(CopyToClipboard, {
    text: text,
    onCopy: function onCopy() {
      message.success('复制成功');

      _onCopy();
    }
  }, /*#__PURE__*/React.createElement(CopyIcon, {
    style: {
      marginLeft: '4px'
    }
  }));
};
export var LongText2Ellipsis = function LongText2Ellipsis(_ref2) {
  var value = _ref2.value,
      _ref2$tooltip = _ref2.tooltip,
      tooltip = _ref2$tooltip === void 0 ? false : _ref2$tooltip,
      _ref2$isCopy = _ref2.isCopy,
      isCopy = _ref2$isCopy === void 0 ? false : _ref2$isCopy,
      _ref2$row = _ref2.row,
      row = _ref2$row === void 0 ? 2 : _ref2$row,
      children = _ref2.children,
      _onClick = _ref2.onClick,
      record = _ref2.record,
      style = _ref2.style;
  var isClick = isFunction(_onClick);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    style: style,
    className: styles[preCssFix + "-long-text"] + " " + (isClick && styles[preCssFix + "-long-text-link"]),
    onClick: function onClick() {
      isClick && _onClick(record);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: styles["row-" + row],
    style: {
      flex: 1
    }
  }, tooltip ? /*#__PURE__*/React.createElement(Tooltip, {
    placement: "topLeft",
    title: value
  }, children || value) : children || value), isCopy && /*#__PURE__*/React.createElement(Copy, {
    text: value
  })));
};
export var Price = function Price(_ref3) {
  var value = _ref3.value;
  if (!value) return null;

  var PriceItem = function PriceItem(_ref4) {
    var value = _ref4.value;
    if (!value) return null;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", {
      className: styles.rmb
    }, "\xA5"), /*#__PURE__*/React.createElement("span", {
      className: styles.count
    }, value));
  };

  if (Array.isArray(value)) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: styles[preCssFix + "-detail-info-price"]
    }, /*#__PURE__*/React.createElement(PriceItem, {
      value: value[0]
    }), /*#__PURE__*/React.createElement("span", {
      className: styles.line
    }, "-"), /*#__PURE__*/React.createElement(PriceItem, {
      value: value[1]
    })));
  } else {
    return /*#__PURE__*/React.createElement("div", {
      className: styles[preCssFix + "-detail-info-price"]
    }, /*#__PURE__*/React.createElement(PriceItem, {
      value: value
    }));
  }
};

var ExtraInfo = function ExtraInfo(_ref5) {
  var items = _ref5.items;
  if (!items) return null;
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info-row"]
  }, items.map(function (v) {
    return /*#__PURE__*/React.createElement("div", {
      className: styles.item
    }, v.label && /*#__PURE__*/React.createElement("span", {
      style: {
        whiteSpace: 'nowrap'
      }
    }, v.label, "\uFF1A"), /*#__PURE__*/React.createElement(LongText2Ellipsis, {
      value: v.value,
      tooltip: v.tooltip,
      row: v.row,
      onClick: v.onClick,
      isCopy: v.isCopy,
      style: {
        color: '#666'
      }
    }, /*#__PURE__*/React.createElement("span", null, v.value || '-')));
  }));
};

export var TagsInfo = function TagsInfo(_ref6) {
  var tags = _ref6.tags,
      record = _ref6.record;
  if (!tags) return null;
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info-tags"]
  }, tags === null || tags === void 0 ? void 0 : tags.map(function (v) {
    var visible = isVisible(v.visible, record);
    return visible && /*#__PURE__*/React.createElement("span", {
      className: styles.tag,
      key: v.value
    }, v.value);
  }));
};
export var GoodTitle = function GoodTitle(_ref7) {
  var _ref7$title = _ref7.title,
      title = _ref7$title === void 0 ? {} : _ref7$title;
  var value = title.value,
      tooltip = title.tooltip,
      row = title.row,
      onClick = title.onClick,
      icon = title.icon;
  if (!value) return null;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.title
  }, /*#__PURE__*/React.createElement(LongText2Ellipsis, {
    value: value,
    tooltip: tooltip,
    row: row,
    onClick: onClick,
    style: {
      color: '#666'
    }
  }));
};

var TitleToolTip = function TitleToolTip(_ref8) {
  var _ref8$tooltip = _ref8.tooltip,
      tooltip = _ref8$tooltip === void 0 ? {} : _ref8$tooltip;
  var value = tooltip.value,
      label = tooltip.label,
      isCopy = tooltip.isCopy;
  if (!value) return null;
  var title = /*#__PURE__*/React.createElement("div", null, label && /*#__PURE__*/React.createElement("span", null, label, "\uFF1A"), value && /*#__PURE__*/React.createElement("span", null, value), isCopy && /*#__PURE__*/React.createElement(Copy, {
    text: value
  }));
  return /*#__PURE__*/React.createElement(Tooltip, {
    placement: "top",
    title: title
  }, /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info-tooltip"]
  }, /*#__PURE__*/React.createElement("span", {
    className: styles['icon-id']
  }, "ID")));
};

export var DetailInfo = function DetailInfo(_ref9) {
  var _ref9$value = _ref9.value,
      value = _ref9$value === void 0 ? {} : _ref9$value,
      record = _ref9.record;
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info"]
  }, /*#__PURE__*/React.createElement("div", null, value !== null && value !== void 0 && value.renderImg ? /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info-img"]
  }, value.renderImg()) : value.imgUrl && /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info-img"]
  }, /*#__PURE__*/React.createElement("img", {
    src: value.imgUrl,
    alt: ""
  }))), /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-detail-info-text"]
  }, /*#__PURE__*/React.createElement(GoodTitle, {
    title: value.title
  }), /*#__PURE__*/React.createElement(ExtraInfo, {
    items: value.items
  }), /*#__PURE__*/React.createElement(Price, {
    value: value.price
  }), /*#__PURE__*/React.createElement(TagsInfo, {
    tags: value.tags,
    record: record
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(TitleToolTip, {
    tooltip: value.tooltip
  })));
};