import * as React from 'react';
import styles from "../index.module.less";
import Operates from "./operates";
import { Tag } from 'antd';
import { COLORMAP, isFunction, formatDictList } from "../../../utils";
import { LongText2Ellipsis, Copy } from "./detailInfo";
var preCssFix = 'yw-table-cell';

var MultipleCol = function MultipleCol(_ref) {
  var value = _ref.value,
      record = _ref.record;
  return value.map(function (_ref2, idx) {
    var label = _ref2.label,
        value = _ref2.value,
        isCopy = _ref2.isCopy,
        tooltip = _ref2.tooltip,
        onClick = _ref2.onClick,
        children = _ref2.children;
    return /*#__PURE__*/React.createElement("div", {
      key: idx,
      style: {
        color: '#666',
        marginTop: idx !== 0 ? '12px' : 0
      },
      className: styles[preCssFix + "-multiple-col"]
    }, /*#__PURE__*/React.createElement("span", {
      className: styles.label
    }, label || '-'), "\uFF1A", /*#__PURE__*/React.createElement(LongText2Ellipsis, {
      value: value,
      row: 1,
      isCopy: isCopy,
      tooltip: tooltip,
      record: record,
      onClick: onClick
    }, /*#__PURE__*/React.createElement("span", null, children || value || '-')));
  });
};

var IndexCol = function IndexCol(_ref3) {
  var value = _ref3.value,
      record = _ref3.record,
      index = _ref3.index;
  return /*#__PURE__*/React.createElement("div", {
    style: {
      color: '#666'
    },
    className: styles[preCssFix + "-index-col"]
  }, index + 1);
};

var CopyCol = function CopyCol(_ref4) {
  var value = _ref4.value,
      render = _ref4.render,
      record = _ref4.record;
  return /*#__PURE__*/React.createElement("div", {
    style: {
      color: '#666'
    },
    className: styles[preCssFix + "-copy-col"]
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.content
  }, render(record)), /*#__PURE__*/React.createElement(Copy, {
    text: value(record)
  }));
};

var Person = function Person(_ref5) {
  var value = _ref5.value,
      _onClick = _ref5.onClick;
  var canClick = isFunction(_onClick);
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-person"]
  }, /*#__PURE__*/React.createElement("img", {
    className: styles.avatar,
    src: value.avatar,
    alt: "",
    onClick: function onClick() {
      _onClick(value);
    },
    style: {
      cursor: canClick ? 'pointer' : ''
    }
  }), /*#__PURE__*/React.createElement("span", null, value.name));
};

var Time = function Time(_ref6) {
  var value = _ref6.value;
  return /*#__PURE__*/React.createElement("div", null, value || '/');
};

var Status = function Status(_ref7) {
  var value = _ref7.value,
      dataSource = _ref7.dataSource,
      _ref7$dict = _ref7.dict,
      dict = _ref7$dict === void 0 ? [] : _ref7$dict;
  var data = dataSource || formatDictList(dict) || [];
  var target = data.find(function (v) {
    return v.value === value;
  }) || {};
  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-status"]
  }, /*#__PURE__*/React.createElement("span", {
    className: styles.dot,
    style: {
      background: COLORMAP[target.color || 'default'] || target.color
    }
  }), target.label || target.value);
};

var Tags = function Tags(_ref8) {
  var _ref8$value = _ref8.value,
      value = _ref8$value === void 0 ? [] : _ref8$value,
      _ref8$dataSource = _ref8.dataSource,
      dataSource = _ref8$dataSource === void 0 ? [] : _ref8$dataSource;

  var _v = Array.isArray(value) ? value : [value];

  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-tag"]
  }, _v === null || _v === void 0 ? void 0 : _v.map(function (v) {
    var target = dataSource.find(function (data) {
      return data.value === v;
    }) || {};
    return /*#__PURE__*/React.createElement(Tag, {
      key: target.value,
      color: target.color
    }, target.value);
  }));
};

export { Person, Time, Status, Tags, MultipleCol, CopyCol, IndexCol, Operates };