import _extends from "@babel/runtime/helpers/extends";
import * as React from 'react';
import styles from "../index.module.less";
import { Modal } from 'antd';
import YwFormDialog from "../../YwFormDialog";
import YwTableDialog from "../../YwTableDialog";
import { isVisible, isDisabled, isFunction } from "../../../utils";
import YwButton from "../../YwButton";
var confirm = Modal.confirm;
var preCssFix = 'yw-table-cell';

var showDeleteConfirm = function showDeleteConfirm(props, data, reload) {
  confirm(_extends({
    okText: '确定',
    okType: 'primary',
    cancelText: '取消'
  }, props, {
    content: isFunction(props.content) ? props.content(data) : props.content,
    title: isFunction(props.title) ? props.title(data) : props.title || '提示',
    onOk: function onOk() {
      return props.onOk(data, reload);
    },
    onCancel: function onCancel() {
      console.log('Cancel');
    }
  }));
};

var handleOperatesClick = function handleOperatesClick(component, componentProps, data, reload) {
  switch (component) {
    case 'ConfirmModal':
      showDeleteConfirm(componentProps, data, reload);
      break;

    default:
      break;
  }
};

var Operates = function Operates(_ref) {
  var _ref$value = _ref.value,
      value = _ref$value === void 0 ? [] : _ref$value,
      record = _ref.record,
      reload = _ref.reload,
      index = _ref.index;
  var showValues = value.filter(function (_ref2) {
    var _ref2$visible = _ref2.visible,
        visible = _ref2$visible === void 0 ? true : _ref2$visible;
    return isVisible(visible, record);
  });

  var renderBtn = function renderBtn(_ref3) {
    var i = _ref3.i,
        v = _ref3.v,
        _ref3$btnProps = _ref3.btnProps,
        btnProps = _ref3$btnProps === void 0 ? {} : _ref3$btnProps;
    return /*#__PURE__*/React.createElement("span", {
      key: i,
      style: {
        marginRight: '8px'
      }
    }, /*#__PURE__*/React.createElement(YwButton, _extends({}, v, {
      visible: true,
      btnType: "link",
      danger: v.type === 'danger',
      style: {
        padding: '4px 0'
      },
      disabled: isDisabled(v.disabled, record)
    }, btnProps)));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: styles[preCssFix + "-operates"]
  }, showValues.map(function (v, i) {
    if (v.render) {
      return /*#__PURE__*/React.createElement("span", {
        key: i,
        style: {
          marginRight: '8px',
          marginBottom: '12px'
        }
      }, v.render(record, index, reload));
    }

    if (v.component === 'YwFormDialog') {
      return /*#__PURE__*/React.createElement(YwFormDialog, _extends({
        initialValues: record
      }, v.componentProps, {
        onConfirm: function onConfirm(values) {
          return isFunction(v.componentProps.onConfirm) && v.componentProps.onConfirm(values, reload);
        }
      }), renderBtn({
        v: v,
        i: i
      }));
    } else if (v.component === 'YwTableDialog') {
      return /*#__PURE__*/React.createElement(YwTableDialog, _extends({}, v.componentProps, {
        onConfirm: function onConfirm(values) {
          return isFunction(v.componentProps.onConfirm) && v.componentProps.onConfirm(values, reload);
        }
      }), renderBtn({
        v: v,
        i: i
      }));
    } else {
      return renderBtn({
        v: v,
        i: i,
        btnProps: {
          onClick: function onClick(e) {
            if (v.component) {
              handleOperatesClick(v.component, v.componentProps, record, reload);
            } else {
              v.onClick && v.onClick(e, record, reload);
            }
          }
        }
      });
    }
  }));
};

export default Operates;