'use strict';

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === 'function') for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

exports.__esModule = true;

var react_1 = require('react');

var antd_1 = require('antd');

var icons_1 = require('@ant-design/icons');

var index_module_less_1 = require("./index.module.less");

var components_1 = require("./components");

var usePagination_1 = require("./usePagination");

var registerCom = {
  MultipleCol: components_1.MultipleCol,
  Time: components_1.Time,
  Person: components_1.Person,
  Status: components_1.Status,
  Operates: components_1.Operates
};

var formatColumns = function formatColumns(_columns, _a) {
  if (_columns === void 0) {
    _columns = [];
  }

  var reload = _a.reload;
  return _columns.map(function (_a, idx) {
    var _b = _a.component,
        component = _b === void 0 ? '' : _b,
        componentProps = _a.componentProps,
        _c = _a.formatValues,
        formatValues = _c === void 0 ? null : _c,
        item = __rest(_a, ['component', 'componentProps', 'formatValues']);

    if (!component) return item;
    return __assign(__assign({}, item), {
      render: function render(data, record, index) {
        var Component = registerCom[component] || null;

        if (formatValues) {
          var value = formatValues(data, record, index);
          return react_1['default'].createElement(Component, __assign({
            value: value
          }, componentProps, {
            record: record,
            key: item.dataIndex
          }));
        }

        return react_1['default'].createElement(Component, __assign({
          value: data
        }, componentProps, {
          record: record,
          reload: reload,
          key: item.dataIndex
        }));
      }
    });
  });
};

var formatBatchBtn = function formatBatchBtn(buttons, _a) {
  if (buttons === void 0) {
    buttons = [];
  }

  var hasSelect = _a.hasSelect,
      selectedRowKeys = _a.selectedRowKeys,
      selectedData = _a.selectedData,
      reload = _a.reload;
  return buttons.filter(function (v) {
    return v.type === 'batch';
  }).map(function (_a, i) {
    var _b = _a.visible,
        visible = _b === void 0 ? true : _b,
        v = __rest(_a, ['visible']);

    return visible && react_1['default'].createElement(antd_1.Button, {
      key: i,
      disabled: !hasSelect || v.disabled,
      onClick: function onClick() {
        v.onClick(selectedRowKeys, selectedData, reload);
      }
    }, v.btnText);
  });
};

var formatActionBtn = function formatActionBtn(buttons, _a) {
  if (buttons === void 0) {
    buttons = [];
  }

  var reload = _a.reload;
  return buttons.filter(function (v) {
    return v.type !== 'batch';
  }).map(function (_a, i) {
    var _b;

    var _c = _a.visible,
        visible = _c === void 0 ? true : _c,
        v = __rest(_a, ['visible']);

    if (v.btnType === 'dropdown') {
      var menu = react_1['default'].createElement(antd_1.Menu, {
        onClick: function onClick(data) {
          v.onClick(data, reload);
        }
      }, (_b = v.dataSource) === null || _b === void 0 ? void 0 : _b.map(function (_a) {
        var key = _a.key,
            label = _a.label;
        return react_1['default'].createElement(antd_1.Menu.Item, {
          key: key
        }, label);
      }));
      return visible && react_1['default'].createElement(antd_1.Dropdown, {
        overlay: menu
      }, react_1['default'].createElement(antd_1.Button, {
        disabled: v.disabled
      }, v.btnText, ' ', react_1['default'].createElement(icons_1.DownOutlined, null)));
    }

    return visible && react_1['default'].createElement(antd_1.Button, {
      key: i,
      type: v.btnType || 'primary',
      disabled: v.disabled,
      onClick: function onClick() {
        v.onClick(reload);
      }
    }, v.children || v.btnText);
  });
};

function YwTable(props) {
  var _a;

  var actions = props.actions,
      columns = props.columns,
      filterProps = props.filterProps,
      buttons = props.buttons,
      getTableData = props.getTableData,
      others = __rest(props, ['actions', 'columns', 'filterProps', 'buttons', 'getTableData']);

  var _b = react_1.useState(((_a = props.rowSelection) === null || _a === void 0 ? void 0 : _a.rowSelection) || []),
      selectedRowKeys = _b[0],
      setSelectedRowKeys = _b[1];

  var _c = react_1.useState([]),
      selectedData = _c[0],
      setSelectedData = _c[1];

  var rowSelection = props.rowSelection ? __assign(__assign({}, rowSelection), {
    selectedRowKeys: selectedRowKeys,
    onChange: function onChange(newSelectedRowKeys, data) {
      setSelectedRowKeys(newSelectedRowKeys);
      setSelectedData(data);
    }
  }) : null;
  var hasSelect = react_1.useMemo(function () {
    return !!selectedRowKeys.length > 0;
  }, [selectedRowKeys]);

  var _d = usePagination_1['default'](function (_a, filterProps) {
    var pageIndex = _a.pageIndex,
        pageSize = _a.pageSize;
    return getTableData(__assign({
      pageIndex: pageIndex,
      pageSize: pageSize
    }, filterProps));
  }, {
    manual: true
  }),
      data = _d.data,
      loading = _d.loading,
      pagination = _d.pagination,
      run = _d.run,
      params = _d.params;

  react_1.useEffect(function () {
    var _a;

    run({
      pageIndex: 1,
      pageSize: ((_a = params[0]) === null || _a === void 0 ? void 0 : _a.pageSize) || 20
    }, filterProps);
  }, [filterProps]);

  var reload = function reload() {
    setSelectedRowKeys([]);
    setSelectedData([]);
    run(params[0] || {}, params[1] || {});
  };

  return react_1['default'].createElement('div', {
    className: index_module_less_1['default']['yw-table'] + ' ' + index_module_less_1['default']['yw-table-multiple']
  }, react_1['default'].createElement('div', {
    className: '' + index_module_less_1['default']['yw-table-btns']
  }, react_1['default'].createElement('div', {
    className: '' + index_module_less_1['default']['batch']
  }, react_1['default'].createElement('span', {
    className: '' + index_module_less_1['default']['total']
  }, "\u5171\u9009\u4E2D ", selectedRowKeys.length, " \u6761 "), formatBatchBtn(buttons, {
    hasSelect: hasSelect,
    selectedRowKeys: selectedRowKeys,
    selectedData: selectedData,
    reload: reload
  })), react_1['default'].createElement('div', {
    className: '' + index_module_less_1['default']['action']
  }, formatActionBtn(buttons, {
    reload: reload
  }))), react_1['default'].createElement(antd_1.Table, __assign({}, others, {
    columns: formatColumns(columns, {
      reload: reload
    }),
    dataSource: (data === null || data === void 0 ? void 0 : data.list) || [],
    loading: loading,
    pagination: __assign(__assign({}, pagination), props.pagination),
    rowSelection: rowSelection
  })));
}

YwTable.defaultProps = {
  multiple: true,
  stickyHeader: false,
  composite: true,
  pagination: {},
  filterProps: {},
  buttons: [],
  rowSelection: null,
  columns: [],
  getTableData: function getTableData() {}
};
exports['default'] = YwTable;