import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["title", "size", "btnText", "btnType", "filterItems", "columns", "getTableData", "initialValues", "btnDisabled", "children", "itemWidth", "buttons", "rowSelection", "rowKey", "pagination", "onClose", "onSubmit", "onOpen", "onTableInit", "okText", "onOk"];
import React, { useState, useEffect, useMemo, useRef } from 'react';
import styles from "./index.module.less";
import { Modal, Spin, Button } from 'antd';
import { isFunction } from "../../utils";
import YwFilter from "../YwFilter/index";
import YwTable from "../YwTable/index";
import YwButton from "../YwButton/index";
var widthMap = {
  s: 680,
  m: 920,
  l: 1200,
  full: '100vw'
};

var YwTableDialog = function YwTableDialog(_ref) {
  var title = _ref.title,
      size = _ref.size,
      btnText = _ref.btnText,
      btnType = _ref.btnType,
      filterItems = _ref.filterItems,
      columns = _ref.columns,
      getTableData = _ref.getTableData,
      initialValues = _ref.initialValues,
      btnDisabled = _ref.btnDisabled,
      children = _ref.children,
      itemWidth = _ref.itemWidth,
      buttons = _ref.buttons,
      rowSelection = _ref.rowSelection,
      rowKey = _ref.rowKey,
      pagination = _ref.pagination,
      onClose = _ref.onClose,
      onSubmit = _ref.onSubmit,
      onOpen = _ref.onOpen,
      onTableInit = _ref.onTableInit,
      okText = _ref.okText,
      onOk = _ref.onOk,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(others.visible || false),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = useState(false),
      spinning = _useState2[0],
      setSpinning = _useState2[1];

  var _useState3 = useState(null),
      filterProps = _useState3[0],
      setFilterProps = _useState3[1];

  var _useState4 = useState([]),
      selectKeys = _useState4[0],
      setSelectKeys = _useState4[1];

  var _useState5 = useState([]),
      selectData = _useState5[0],
      setSelectData = _useState5[1];

  var _useState6 = useState(null),
      selectInfo = _useState6[0],
      setSelectInfo = _useState6[1];

  var formRef = useRef(null);
  var isControl = useMemo(function () {
    return others.visible !== undefined;
  }, []);

  var showModal = function showModal() {
    if (isFunction(onOpen)) {
      setSpinning(true);
      onOpen().then(function (initialValues) {})["finally"](function () {
        setSpinning(false);
      });
    }
  };

  var handleCancel = function handleCancel() {
    onClose();
  }; //   const handleOk = () => {
  //     onConfirm(value).finally(() => {
  //       setVisible(false);
  //     });
  //   };


  var handleInit = function handleInit() {
    setFilterProps(initialValues || {});
    setSelectData([]);
    setSelectKeys([]);
    setSelectInfo(null);
    formRef.current && formRef.current.reset();
  };

  useEffect(function () {
    setVisible(others.visible);
  }, [others.visible]);
  useEffect(function () {
    if (visible) {
      handleInit();
    }
  }, [visible]);

  var SubmitButton = function SubmitButton() {
    if (rowSelection) {
      return /*#__PURE__*/React.createElement(YwButton, {
        btnType: "primary",
        onClick: function onClick() {
          onOk && onOk(selectKeys, selectData, selectInfo);
        }
      }, okText);
    }

    return null;
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, !isControl && /*#__PURE__*/React.createElement("div", {
    onClick: function onClick() {
      setVisible(true);
    },
    style: {
      display: 'inline-block'
    }
  }, children || /*#__PURE__*/React.createElement(Button, {
    type: btnType,
    disabled: btnDisabled
  }, btnText)), /*#__PURE__*/React.createElement(Modal, _extends({}, others, {
    wrapClassName: styles['yw-table-dialog'],
    title: title,
    width: widthMap[size],
    visible: visible,
    onCancel: function onCancel() {
      !isControl ? setVisible(false) : onClose();
    },
    destroyOnClose: true,
    footer: [/*#__PURE__*/React.createElement(YwButton, {
      key: "back",
      onClick: function onClick() {
        !isControl ? setVisible(false) : onClose();
      }
    }, "\u5173\u95ED"), /*#__PURE__*/React.createElement(SubmitButton, null)]
  }), /*#__PURE__*/React.createElement(Spin, {
    spinning: spinning
  }, filterItems && visible && /*#__PURE__*/React.createElement(YwFilter, {
    items: filterItems,
    onCreate: function onCreate(_form) {
      formRef.current = _form;
    },
    itemWidth: itemWidth,
    initialValues: initialValues // onSubmit={setFilterProps}
    // hasSearchBtn={false}
    ,
    onSubmit: function onSubmit(data) {
      setFilterProps(_extends({}, data));
    },
    maxColumns: 2
  }), /*#__PURE__*/React.createElement(YwTable, {
    filterProps: filterProps,
    ref: function ref(_ref2) {
      _ref2 && isFunction(onTableInit) && onTableInit(_ref2);
    },
    columns: columns,
    rowKey: rowKey,
    getTableData: getTableData,
    buttons: buttons,
    rowSelection: rowSelection ? _extends({
      onChange: function onChange(keys, data, info) {
        setSelectKeys(keys);
        setSelectData(data);
        setSelectInfo(info);
        rowSelection.onChange && rowSelection.onChange(keys, data, info);
      }
    }, rowSelection) : rowSelection,
    pagination: pagination ? _extends({
      size: 'small'
    }, pagination) : pagination
  }))));
};

YwTableDialog.defaultProps = {
  btnType: 'primary',
  size: 'm',
  btnDisabled: false,
  rowKey: 'id',
  rowSelection: null,
  pagination: {},
  okText: '确定',
  buttons: [],
  onClose: function onClose() {},
  onSubmit: function onSubmit() {}
};
export default YwTableDialog;