import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["maxItems", "defaultValue", "fieldNames", "fetchOptions", "tagRender", "labelInValue", "children", "onOk", "value", "placeholder", "autoFocus", "showSearch"],
    _excluded2 = ["label", "value"];
import React, { useEffect, useState, useRef } from 'react';
import { Modal, message } from 'antd';
import styles from "./index.module.less";
import YwButton from "../../components/YwButton";
import { DebounceSelect } from "../YwJsonForm/YSearchSelect";
import { obj } from "../../utils/index";

var ModalSelector = function ModalSelector(_ref) {
  var maxItems = _ref.maxItems,
      _ref$defaultValue = _ref.defaultValue,
      defaultValue = _ref$defaultValue === void 0 ? [] : _ref$defaultValue,
      fieldNames = _ref.fieldNames,
      fetchOptions = _ref.fetchOptions,
      tagRender = _ref.tagRender,
      labelInValue = _ref.labelInValue,
      children = _ref.children,
      onOk = _ref.onOk,
      value = _ref.value,
      placeholder = _ref.placeholder,
      autoFocus = _ref.autoFocus,
      showSearch = _ref.showSearch,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(false),
      confirmLoading = _useState[0],
      setConfirmLoading = _useState[1];

  var _useState2 = useState(true),
      open = _useState2[0],
      setOpen = _useState2[1];

  var _selectRef = useRef(null);

  var _useState3 = useState(defaultValue),
      selectValue = _useState3[0],
      setSelectValue = _useState3[1];

  useEffect(function () {
    value && setSelectValue(value);
  }, [value]); // useEffect(() => {
  //   if (selectValue?.length > maxItems) {
  //   }
  // }, [selectValue, maxItems]);

  return /*#__PURE__*/React.createElement(Modal, _extends({
    className: styles['modal-selector'],
    maskClosable: false,
    keyboard: false,
    destroyOnClose: true,
    footer: null,
    width: 680
  }, props), /*#__PURE__*/React.createElement("div", {
    className: styles['modal-selector-left'],
    onClick: function onClick() {
      var _selectRef$current;

      !props.disabled && (_selectRef === null || _selectRef === void 0 ? void 0 : (_selectRef$current = _selectRef.current) === null || _selectRef$current === void 0 ? void 0 : _selectRef$current.focus());
    }
  }, /*#__PURE__*/React.createElement(DebounceSelect, {
    bordered: false,
    selectRef: function selectRef(el) {
      if (el) {
        _selectRef.current = el.current;
      }
    },
    defaultValue: defaultValue,
    mode: "multiple",
    showArrow: false,
    style: {
      width: '100%'
    },
    placeholder: placeholder,
    value: selectValue !== null && selectValue !== void 0 && selectValue.length ? selectValue : null,
    labelInValue: labelInValue,
    autoFocus: true,
    showSearch: showSearch,
    onChange: function onChange(nextValue, data) {
      if ((nextValue === null || nextValue === void 0 ? void 0 : nextValue.length) > maxItems) {
        message.error('超过数量限制');
        setOpen(false);
        return;
      }

      props.onChange(nextValue, data);
      setOpen(false); // setSelectValue(nextValue);
    },
    onBlur: function onBlur() {
      setOpen(false);
    },
    onKeywordChange: function onKeywordChange() {
      setOpen(true);
    },
    open: open,
    disabled: props.disabled,
    tagRender: tagRender,
    fieldNames: fieldNames,
    dropdownClassName: styles['dropdown-selector'],
    dropdownRender: function dropdownRender(menu) {
      return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
        className: styles['dropdown-selector-help']
      }, "\u60A8\u53EF\u80FD\u60F3\u627E"), menu);
    },
    allowClear: true,
    fetchOptions: fetchOptions
  }), /*#__PURE__*/React.createElement("div", {
    className: styles['modal-selector-left-footer']
  }, /*#__PURE__*/React.createElement(YwButton, {
    loading: confirmLoading,
    disabled: (selectValue === null || selectValue === void 0 ? void 0 : selectValue.length) > maxItems,
    btnText: "\u786E\u5B9A (" + (selectValue === null || selectValue === void 0 ? void 0 : selectValue.length) + "/" + (maxItems || (selectValue === null || selectValue === void 0 ? void 0 : selectValue.length)) + ")",
    onClick: function onClick() {
      var value = selectValue === null || selectValue === void 0 ? void 0 : selectValue.map(function (_ref2) {
        var _extends2;

        var label = _ref2.label,
            value = _ref2.value,
            v = _objectWithoutPropertiesLoose(_ref2, _excluded2);

        return _extends({}, v, (_extends2 = {}, _extends2[fieldNames.label] = label, _extends2[fieldNames.value] = value, _extends2));
      });

      if (obj.isPromise(onOk)) {
        setConfirmLoading(true);
        onOk(value).then(function () {
          props.onCancel();
        })["finally"](function () {
          setConfirmLoading(false);
        });
      } else {
        onOk(value);
        props.onCancel();
      }
    },
    type: "primary"
  }), /*#__PURE__*/React.createElement(YwButton, {
    btnText: "\u53D6 \u6D88",
    onClick: props.onCancel
  }))), /*#__PURE__*/React.createElement("div", {
    className: styles['modal-selector-right']
  }, children));
};

ModalSelector.defaultProps = {
  onOk: function onOk() {},
  defaultValue: null,
  labelInValue: true,
  placeholder: '搜索...',
  onChange: function onChange() {},
  onCancel: function onCancel() {},
  fieldNames: {
    label: 'label',
    value: 'value'
  }
};
export default ModalSelector;