import * as _func from './func';
import * as _object from './object';
import * as _string from './string';
import * as _hoc from './hoc';
import type { Dict } from '../types';
export declare const isFunction: (value: unknown) => value is Function;
export declare const isObject: (obj: any) => boolean;
export declare const isArray: (arr: any) => boolean;
export declare const COLORMAP: {
    primary: string;
    success: string;
    error: string;
    warning: string;
    info: string;
    other: string;
    default: string;
};
export declare const RANGES: {
    昨天: any[];
    今天: any[];
    '7\u5929': any[];
    '15\u5929': any[];
    '30\u5929': any[];
    本月: any[];
    本周: any[];
    上月: any[];
    上周: any[];
};
export declare const isVisible: (visible: boolean | Function, any: any) => boolean;
export declare const isDisabled: (disabled: boolean | Function, any: any) => boolean;
export declare const StatusTypeIcon: {
    success: JSX.Element;
    warning: JSX.Element;
    error: JSX.Element;
    help: JSX.Element;
    notice: JSX.Element;
};
export declare const formatDictList: (dictList?: Dict[]) => any[];
export declare const formatOptionsList: (dataList: any, fieldNames?: {
    label: string;
    value: string;
    children?: string;
}) => any;
export declare const formatDataList: (dataList: any, fieldNames?: {
    label: string;
    value: string;
    children?: string;
}) => any;
export declare const func: typeof _func;
export declare const obj: typeof _object;
export declare const str: typeof _string;
export declare const hoc: typeof _hoc;
