import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/extends";
var _excluded = ["label", "value"];
import { InfoCircleFilled, CheckCircleFilled, ExclamationCircleFilled, CloseCircleFilled, QuestionCircleFilled } from '@ant-design/icons';
import moment from 'moment';
import * as React from 'react';
import * as _func from "./func";
import * as _object from "./object";
import * as _string from "./string";
import * as _hoc from "./hoc";
export var isFunction = function isFunction(value) {
  return typeof value === 'function';
};
export var isObject = function isObject(obj) {
  return Object.prototype.toString.call(obj) === '[object Object]';
};
export var isArray = function isArray(arr) {
  return Object.prototype.toString.call(arr) === '[object Array]';
};
export var COLORMAP = {
  primary: '#1890FF',
  success: '#23CBB7',
  error: '#F15A5A',
  warning: '#FAAD14',
  info: '#999',
  other: '#9C7AFF',
  "default": '#999'
};
export var RANGES = {
  昨天: [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
  今天: [moment(), moment()],
  '7天': [moment().subtract(6, 'days'), moment()],
  '15天': [moment().subtract(14, 'days'), moment()],
  '30天': [moment().subtract(29, 'days'), moment()],
  本月: [moment().startOf('month'), moment().endOf('month')],
  本周: [moment().startOf('week'), moment().endOf('week')],
  上月: [moment().subtract(1, 'months').startOf('month'), moment().subtract(1, 'months').endOf('month')],
  上周: [moment().subtract(1, 'week').startOf('week'), moment().subtract(1, 'week').endOf('week')]
};
export var isVisible = function isVisible(visible, data) {
  if (visible === void 0) {
    visible = true;
  }

  return isFunction(visible) ? visible(data) : visible;
};
export var isDisabled = function isDisabled(disabled, data) {
  return isFunction(disabled) ? disabled(data) : disabled;
};
export var StatusTypeIcon = {
  success: /*#__PURE__*/React.createElement(CheckCircleFilled, null),
  warning: /*#__PURE__*/React.createElement(ExclamationCircleFilled, null),
  error: /*#__PURE__*/React.createElement(CloseCircleFilled, null),
  help: /*#__PURE__*/React.createElement(QuestionCircleFilled, null),
  notice: /*#__PURE__*/React.createElement(InfoCircleFilled, null)
};
export var formatDictList = function formatDictList(dictList) {
  if (dictList === void 0) {
    dictList = [];
  }

  return dictList.map(function (dict) {
    return _extends({
      value: dict.dictValue,
      label: dict.dictName
    }, isObject(dict.extParams) ? dict.extParams : {});
  });
};
export var formatOptionsList = function formatOptionsList(dataList, fieldNames) {
  if (fieldNames === void 0) {
    fieldNames = {
      label: 'label',
      value: 'value',
      children: 'children'
    };
  }

  if (!dataList) return null;
  return dataList.map(function (data) {
    return _extends({}, data, data[fieldNames.value] !== undefined ? {
      value: data[fieldNames.value]
    } : {}, data[fieldNames.label] !== undefined ? {
      label: data[fieldNames.label]
    } : {}, data[fieldNames.children] ? {
      children: formatOptionsList(data[fieldNames.children], fieldNames)
    } : {});
  });
};
export var formatDataList = function formatDataList(dataList, fieldNames) {
  if (fieldNames === void 0) {
    fieldNames = {
      label: 'label',
      value: 'value',
      children: 'children'
    };
  }

  if (!dataList) return null;
  return dataList.map(function (_ref) {
    var _extends2;

    var label = _ref.label,
        value = _ref.value,
        data = _objectWithoutPropertiesLoose(_ref, _excluded);

    return _extends((_extends2 = {}, _extends2[fieldNames.value] = value, _extends2[fieldNames.label] = label, _extends2), data[fieldNames.children] ? {
      children: formatDataList(data[fieldNames.children], fieldNames)
    } : {}, data);
  });
};
export var func = _func;
export var obj = _object;
export var str = _string;
export var hoc = _hoc;