"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.renderCardItem = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _antd = require("antd");

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _utils = require("../../utils");

var _YwButton = _interopRequireDefault(require("../YwButton"));

var _excluded = ["disabledTooltip", "disabled"];
var preCssFix = 'yw-card-list';

var BtnWithToolTip = _utils.hoc.withToolTip(_YwButton["default"]);

var renderCardItem = function renderCardItem(item, config) {
  var _value$itemTags;

  var rowKey = config.rowKey,
      _config$operates = config.operates,
      operates = _config$operates === void 0 ? [] : _config$operates,
      formatValues = config.formatValues,
      toggle = config.toggle,
      renderItemMain = config.renderItemMain;
  var value = formatValues(item);
  return /*#__PURE__*/_react["default"].createElement(_antd.List.Item, {
    className: _indexModule["default"][preCssFix + "-default-item"] + " " + _indexModule["default"][preCssFix + "-card-item"],
    key: item[rowKey],
    style: value.itemStyle
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-card-item-main"]
  }, value.renderItemAvatar && /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-card-item-avatar"]
  }, value.renderItemAvatar()), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-card-item-text"]
  }, value.renderItemMain && value.renderItemMain())), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-default-item-operates"]
  }, !!((_value$itemTags = value.itemTags) !== null && _value$itemTags !== void 0 && _value$itemTags.length) && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-default-item-tags"]
  }, value.itemTags.filter(function (v) {
    return v.fixed !== 'right';
  }).map(function (v) {
    return /*#__PURE__*/_react["default"].createElement(_antd.Tag, {
      color: v.color,
      style: v.style,
      visible: (0, _utils.isVisible)(v.visible, item)
    }, v.value);
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "" + _indexModule["default"][preCssFix + "-default-item-tags-right"]
  }, value.itemTags.filter(function (v) {
    return v.fixed === 'right';
  }).map(function (v) {
    return /*#__PURE__*/_react["default"].createElement(_antd.Tag, {
      style: v.style,
      color: v.color,
      visible: (0, _utils.isVisible)(v.visible, item)
    }, v.value);
  }))), value.operates && value.operates.map(function (_ref) {
    var disabledTooltip = _ref.disabledTooltip,
        disabled = _ref.disabled,
        v = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
    return /*#__PURE__*/_react["default"].createElement(BtnWithToolTip, (0, _extends2["default"])({}, v, {
      tooltip: disabled && disabledTooltip ? {
        title: disabledTooltip,
        placement: 'top'
      } : false,
      visible: (0, _utils.isVisible)(v.visible, item),
      disabled: (0, _utils.isDisabled)(disabled, item)
    }));
  })));
};

exports.renderCardItem = renderCardItem;