"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.renderDefaultItem = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _antd = require("antd");

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _utils = require("../../utils");

var _detailInfo = require("../YwTable/components/detailInfo");

var _YwButton = _interopRequireDefault(require("../YwButton"));

var preCssFix = 'yw-card-list';

var renderDefaultItem = function renderDefaultItem(item, config) {
  var _value$itemTags;

  var isSelected = config.isSelected,
      rowKey = config.rowKey,
      formatValues = config.formatValues,
      toggle = config.toggle,
      _config$rowSelection = config.rowSelection,
      rowSelection = _config$rowSelection === void 0 ? {} : _config$rowSelection;
  var value = formatValues(item);
  var checkboxProps = (0, _extends2["default"])({
    disabled: false
  }, (0, _utils.isFunction)(rowSelection.getCheckboxProps) ? rowSelection.getCheckboxProps(item) : {}, {
    checked: isSelected(item[rowKey]),
    onClick: function onClick() {
      toggle(item[rowKey]);
      (0, _utils.isFunction)(rowSelection.onSelect) && rowSelection.onSelect(item, isSelected(item[rowKey]));
    }
  });
  return /*#__PURE__*/_react["default"].createElement(_antd.List.Item, {
    className: _indexModule["default"][preCssFix + "-default-item"],
    style: value.itemStyle,
    key: item[rowKey]
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'flex-start',
      flex: '1'
    }
  }, !value.hideSelect && /*#__PURE__*/_react["default"].createElement(_antd.Checkbox, checkboxProps), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-default-item-main"]
  }, value !== null && value !== void 0 && value.renderItemImg ? /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-default-item-img"]
  }, value.renderItemImg()) : value.imgUrl && /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-default-item-img"]
  }, /*#__PURE__*/_react["default"].createElement("img", {
    src: value.imgUrl,
    alt: ""
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-default-item-text"]
  }, value.renderItemMain && value.renderItemMain(item), /*#__PURE__*/_react["default"].createElement(_detailInfo.TagsInfo, {
    tags: value.tags,
    record: item
  }), value.renderItemShop && value.renderItemShop(item), value.renderItemFooter ? /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-default-item-footer"]
  }, value.renderItemFooter(item)) : ''))), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-default-item-operates"]
  }, !!((_value$itemTags = value.itemTags) !== null && _value$itemTags !== void 0 && _value$itemTags.length) && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-default-item-tags"]
  }, value.itemTags.filter(function (v) {
    return v.fixed !== 'right';
  }).map(function (v) {
    return /*#__PURE__*/_react["default"].createElement(_antd.Tag, {
      style: v.style,
      color: v.color,
      visible: (0, _utils.isVisible)(v.visible, item)
    }, v.value);
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "" + _indexModule["default"][preCssFix + "-default-item-tags-right"]
  }, value.itemTags.filter(function (v) {
    return v.fixed === 'right';
  }).map(function (v) {
    return /*#__PURE__*/_react["default"].createElement(_antd.Tag, {
      style: v.style,
      color: v.color,
      visible: (0, _utils.isVisible)(v.visible, item)
    }, v.value);
  }))), value.operates && value.operates.map(function (v, i) {
    if (v.render) {
      return /*#__PURE__*/_react["default"].createElement("span", {
        key: i,
        style: {
          marginRight: '8px',
          marginBottom: '12px'
        }
      }, v.render(item, config.reload));
    }

    return /*#__PURE__*/_react["default"].createElement(_YwButton["default"], (0, _extends2["default"])({}, v, {
      visible: (0, _utils.isVisible)(v.visible, item),
      disabled: (0, _utils.isDisabled)(v.disabled, item),
      onClick: function onClick() {
        v.onClick(item[rowKey], config.reload);
      }
    }));
  })));
};

exports.renderDefaultItem = renderDefaultItem;