"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _index = require("../../utils/index");

var _zh_CN = _interopRequireDefault(require("antd/es/locale/zh_CN"));

var _ahooks = require("ahooks");

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _YwButton = _interopRequireDefault(require("../YwButton"));

var _usePagination2 = _interopRequireDefault(require("../YwTable/usePagination"));

var _defaultItem = require("./defaultItem");

var _cardItem = require("./cardItem");

var _excluded = ["dataSource", "pagination", "rowKey", "operates", "rowSelection"],
    _excluded2 = ["dataSource"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var formatFilter = function formatFilter(buttons, _ref) {
  if (buttons === void 0) {
    buttons = [];
  }

  var reload = _ref.reload,
      _ref$innerFilter = _ref.innerFilter,
      innerFilter = _ref$innerFilter === void 0 ? {} : _ref$innerFilter,
      updateInnerFilter = _ref.updateInnerFilter;
  return buttons.filter(function (v) {
    return v.type === 'filter' && (0, _index.isVisible)(v.visible, null);
  }).map(function (v, i) {
    return v.children || /*#__PURE__*/_react["default"].createElement(_antd.Checkbox, {
      disabled: (0, _index.isDisabled)(v.disabled, null),
      defaultChecked: v.defaultValue || false,
      checked: innerFilter[v.name],
      onChange: function onChange(e) {
        var _updateInnerFilter;

        v.name && updateInnerFilter((_updateInnerFilter = {}, _updateInnerFilter[v.name] = e.target.checked, _updateInnerFilter)); // v.onChange && v.onChange(e.target.checked);
        // v.onClick(selectedRowKeys, selectedData, reload);
      }
    }, v.btnText);
  });
};

var formatBatchBtn = function formatBatchBtn(buttons, _ref2) {
  if (buttons === void 0) {
    buttons = [];
  }

  var hasSelect = _ref2.hasSelect,
      selectedRowKeys = _ref2.selectedRowKeys,
      selectedData = _ref2.selectedData,
      reload = _ref2.reload;
  return buttons.filter(function (v) {
    return v.type === 'batch';
  }).map(function (v, i) {
    return v.children || /*#__PURE__*/_react["default"].createElement(_YwButton["default"], (0, _extends2["default"])({}, v, {
      btnType: "link",
      visible: (0, _index.isVisible)(v.visible, null),
      disabled: !hasSelect || (0, _index.isDisabled)(v.disabled, null),
      onClick: function onClick() {
        v.onClick(selectedRowKeys, selectedData, reload);
      }
    }));
  });
};

var CheckableList = function CheckableList(_ref3) {
  var dataSource = _ref3.dataSource,
      pagination = _ref3.pagination,
      rowKey = _ref3.rowKey,
      operates = _ref3.operates,
      _ref3$rowSelection = _ref3.rowSelection,
      rowSelection = _ref3$rowSelection === void 0 ? {} : _ref3$rowSelection,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref3, _excluded);

  var _useSelections = (0, _ahooks.useSelections)(dataSource.map(function (v) {
    return v[rowKey];
  }), (rowSelection === null || rowSelection === void 0 ? void 0 : rowSelection.selectedRowKeys) || []),
      selected = _useSelections.selected,
      allSelected = _useSelections.allSelected,
      isSelected = _useSelections.isSelected,
      toggle = _useSelections.toggle,
      toggleAll = _useSelections.toggleAll,
      setSelected = _useSelections.setSelected,
      noneSelected = _useSelections.noneSelected,
      unSelect = _useSelections.unSelect,
      select = _useSelections.select,
      partiallySelected = _useSelections.partiallySelected;

  var reload = function reload(_ref4) {
    var _ref4$unSelectKeys = _ref4.unSelectKeys,
        unSelectKeys = _ref4$unSelectKeys === void 0 ? [] : _ref4$unSelectKeys;
    unSelectKeys === null || unSelectKeys === void 0 ? void 0 : unSelectKeys.forEach(function (v) {
      unSelect(v);
    });
    props.reload();
  };

  (0, _react.useEffect)(function () {
    rowSelection.onChange && rowSelection.onChange(selected); // props.rowSelection.onSelect && props.rowSelection.onSelect()
  }, [selected]);
  (0, _react.useEffect)(function () {
    setSelected((rowSelection === null || rowSelection === void 0 ? void 0 : rowSelection.selectedRowKeys) || []);
  }, [rowSelection.selectedRowKeys]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_antd.List, {
    header: props.renderHeader,
    footer: props.renderFooter // footer={renderFooter({
    //   selected,
    //   allSelected,
    //   toggleAll,
    //   partiallySelected,
    //   renderFooter: props.renderFooter,
    // })}
    ,
    rowSelection: rowSelection,
    dataSource: dataSource,
    pagination: pagination,
    renderItem: function renderItem(item) {
      return props.renderItem ? props.renderItem(item, (0, _extends2["default"])({
        isSelected: isSelected,
        rowKey: rowKey,
        operates: operates,
        toggle: toggle
      }, props, {
        reload: reload
      })) : (0, _defaultItem.renderDefaultItem)(item, (0, _extends2["default"])({
        isSelected: isSelected,
        unSelect: unSelect,
        rowKey: rowKey,
        operates: operates,
        toggle: toggle,
        rowSelection: rowSelection
      }, props, {
        reload: reload
      }));
    }
  }), props.renderFooter && props.renderFooter({
    selected: selected,
    allSelected: allSelected,
    toggleAll: toggleAll,
    partiallySelected: partiallySelected,
    dataSource: dataSource
  }), !props.renderFooter && /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['yw-card-list-footer'],
    style: props.footerStyle
  }, /*#__PURE__*/_react["default"].createElement("div", null, rowSelection.hideSelectAll !== true && /*#__PURE__*/_react["default"].createElement(_antd.Checkbox, {
    checked: !noneSelected,
    onClick: function onClick(e) {
      var _data = dataSource.filter(function (record) {
        var checkboxProps = (0, _extends2["default"])({
          disabled: false
        }, (0, _index.isFunction)(rowSelection.getCheckboxProps) ? rowSelection.getCheckboxProps(record) : {}, {
          checked: isSelected(record[rowKey])
        });
        return !(checkboxProps.disabled && !checkboxProps.checked);
      });

      if (e.target.checked) {
        // setSelected(_data.map((v) => v[rowKey]));
        _data === null || _data === void 0 ? void 0 : _data.forEach(function (v) {
          v[rowKey] && select(v[rowKey]);
        });
      } else {
        _data === null || _data === void 0 ? void 0 : _data.forEach(function (v) {
          v[rowKey] && unSelect(v[rowKey]);
        });
      }
    },
    indeterminate: partiallySelected
  }, "\u5171\u9009\u4E2D ", selected.length, " \u6761"), formatBatchBtn(props.buttons, {
    hasSelect: !!selected.length,
    selectedRowKeys: selected,
    selectedData: [],
    reload: reload
  })), /*#__PURE__*/_react["default"].createElement(_YwButton["default"], {
    type: "primary",
    onClick: function onClick() {
      props.onSubmit(selected, reload);
    },
    loading: props.confirmLoading,
    disabled: !selected.length || props.confirmDisabled
  }, props.confirmText)));
};

var CardList = function CardList(_ref5) {
  var dataSource = _ref5.dataSource,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref5, _excluded2);
  return /*#__PURE__*/_react["default"].createElement(_antd.List, {
    header: props.renderHeader,
    footer: props.renderFooter,
    style: props.listItemStyle,
    dataSource: dataSource,
    renderItem: function renderItem(item) {
      return props.renderItem ? props.renderItem(item, (0, _extends2["default"])({}, props)) : (0, _cardItem.renderCardItem)(item, (0, _extends2["default"])({}, props));
    }
  });
};

var getDefaultInnerFilter = function getDefaultInnerFilter(data) {
  var _data2, _data2$filter;

  if (data === void 0) {
    data = [];
  }

  var _inner = {};
  (_data2 = data) === null || _data2 === void 0 ? void 0 : (_data2$filter = _data2.filter(function (v) {
    return v.type === 'filter' && (0, _index.isVisible)(v.visible, null);
  })) === null || _data2$filter === void 0 ? void 0 : _data2$filter.forEach(function (v) {
    v.name && (_inner[v.name] = v.defaultValue);
  });
  return _inner;
};

var YwCardList = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var _props$pagination;

  var getDataSource = props.getDataSource,
      filterProps = props.filterProps,
      rowKey = props.rowKey,
      rowSelection = props.rowSelection;

  var _useState = (0, _react.useState)((rowSelection === null || rowSelection === void 0 ? void 0 : rowSelection.selectedRowKeys) || []),
      selectedRowKeys = _useState[0],
      setSelectedRowKeys = _useState[1];

  var _useState2 = (0, _react.useState)(getDefaultInnerFilter(props.buttons)),
      innerFilter = _useState2[0],
      setInnerFilter = _useState2[1];

  var updateInnerFilter = function updateInnerFilter(_props) {
    setInnerFilter((0, _extends2["default"])({}, innerFilter, _props));
  };

  var hasPagination = (0, _react.useMemo)(function () {
    return props.pagination !== false;
  }, [props.pagination]);

  var _usePagination = (0, _usePagination2["default"])(function (_ref6, params) {
    var pageIndex = _ref6.pageIndex,
        pageSize = _ref6.pageSize;
    return getDataSource((0, _extends2["default"])({}, hasPagination ? {
      pageIndex: pageIndex
    } : {}, hasPagination ? {
      pageSize: pageSize
    } : {}, params));
  }, (0, _extends2["default"])({}, hasPagination ? {
    defaultPageSize: ((_props$pagination = props.pagination) === null || _props$pagination === void 0 ? void 0 : _props$pagination.pageSize) || 20
  } : {}, {
    manual: true
  })),
      data = _usePagination.data,
      loading = _usePagination.loading,
      pagination = _usePagination.pagination,
      run = _usePagination.run,
      params = _usePagination.params;

  (0, _react.useEffect)(function () {
    _refresh();
  }, [filterProps, innerFilter]);

  var _reload = function reload() {
    run(params[0] || {}, params[1] || {});
  };

  var _refresh = function refresh() {
    var _params$, _props$pagination2;

    run({
      pageIndex: 1,
      pageSize: ((_params$ = params[0]) === null || _params$ === void 0 ? void 0 : _params$.pageSize) || ((_props$pagination2 = props.pagination) === null || _props$pagination2 === void 0 ? void 0 : _props$pagination2.pageSize) || 20
    }, (0, _extends2["default"])({}, filterProps, innerFilter));
    rowSelection && setSelectedRowKeys([]);
  };

  (0, _react.useImperativeHandle)(ref, function () {
    return {
      reload: function reload() {
        _reload();
      },
      refresh: function refresh() {
        _refresh();
      }
    };
  });
  var dataSource = (data === null || data === void 0 ? void 0 : data.list) || props.dataSource || [];
  return /*#__PURE__*/_react["default"].createElement(_antd.ConfigProvider, {
    locale: _zh_CN["default"]
  }, /*#__PURE__*/_react["default"].createElement(_antd.Spin, {
    spinning: loading
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['yw-card-list'] + " " + props.className,
    style: props.style
  }, /*#__PURE__*/_react["default"].createElement("div", null, props.showTotal || props.renderTotal && pagination ? /*#__PURE__*/_react["default"].createElement("span", {
    className: _indexModule["default"].total
  }, props.renderTotal ? props.renderTotal(pagination === null || pagination === void 0 ? void 0 : pagination.total) : "\u5171 " + ((pagination === null || pagination === void 0 ? void 0 : pagination.total) || 0) + " \u6761 ") : null, props.buttons && formatFilter(props.buttons, {
    reload: _reload,
    updateInnerFilter: updateInnerFilter,
    innerFilter: innerFilter
  })), rowSelection && !!dataSource.length && /*#__PURE__*/_react["default"].createElement(CheckableList, (0, _extends2["default"])({}, props, {
    reload: _reload,
    dataSource: dataSource,
    rowSelection: (0, _extends2["default"])({
      selectedRowKeys: selectedRowKeys
    }, rowSelection),
    pagination: (0, _index.isObject)(pagination) ? (0, _extends2["default"])({
      size: 'small'
    }, pagination) : pagination
  })), !rowSelection && !!dataSource.length && /*#__PURE__*/_react["default"].createElement(CardList, (0, _extends2["default"])({}, props, {
    reload: _reload,
    dataSource: dataSource,
    pagination: (0, _index.isObject)(pagination) ? (0, _extends2["default"])({
      size: 'small'
    }, pagination) : pagination
  })))));
});

YwCardList.defaultProps = {
  dataSource: [],
  showTotal: true,
  confirmText: '提 交',
  onSubmit: function onSubmit(value) {},
  filterProps: {},
  // renderHeader: () => {},
  // renderFooter: () => {},
  // listItemStyle: { height: 500 },
  rowKey: 'id'
};
var _default = YwCardList;
exports["default"] = _default;