"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _lodash = require("lodash");

var _YwFilter = _interopRequireDefault(require("../YwFilter"));

var _YwTable = _interopRequireDefault(require("../YwTable"));

var _YwButton = _interopRequireDefault(require("../YwButton"));

var _index = require("../../utils/index");

var _index2 = _interopRequireDefault(require("../YwCardList/index"));

var _icon = require("../common/icon");

var _excluded = ["listType"],
    _excluded2 = ["title", "children", "btnType", "btnText", "disabled", "width", "filterItems", "getTableData", "columns", "rowSelection", "pagination", "rowKey", "confirmText", "itemWidth", "initialValues", "onSubmit", "onClose", "formatPreviewItemValue"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var DataList = /*#__PURE__*/_react["default"].forwardRef(function (_ref, ref) {
  var listType = _ref.listType,
      rest = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var extraProps = {
    getDataSource: rest.getTableData
  };
  return listType === 'card' ? /*#__PURE__*/_react["default"].createElement(_index2["default"], (0, _extends2["default"])({
    ref: ref
  }, rest, extraProps, {
    className: _indexModule["default"]['card-list'],
    listItemStyle: {
      height: '100%',
      paddingBottom: '20px'
    },
    style: {
      paddingBottom: 0
    },
    renderFooter: function renderFooter(props) {
      return null;
    }
  })) : /*#__PURE__*/_react["default"].createElement(_YwTable["default"], (0, _extends2["default"])({
    ref: ref
  }, rest, extraProps));
});

var PreviewList = function PreviewList(_ref2) {
  var dataSource = _ref2.dataSource,
      _ref2$pageSize = _ref2.pageSize,
      pageSize = _ref2$pageSize === void 0 ? 10 : _ref2$pageSize,
      deleteItem = _ref2.deleteItem,
      rowKey = _ref2.rowKey,
      maxItems = _ref2.maxItems,
      setStyleBottom = _ref2.setStyleBottom,
      formatPreviewItemValue = _ref2.formatPreviewItemValue,
      renderMaxItemsMessageError = _ref2.renderMaxItemsMessageError;
  var total = (0, _react.useMemo)(function () {
    return dataSource.length || 0;
  }, [dataSource]); // 倒序显示

  var perviewData = (0, _react.useMemo)(function () {
    return dataSource || [];
  }, [dataSource]);
  (0, _react.useEffect)(function () {
    setIsShow(total > 0);
    return function () {
      setPageIndex(1);
      setIsShow(false);
    };
  }, [total]);

  var _useState = (0, _react.useState)(1),
      pageIndex = _useState[0],
      setPageIndex = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      isShow = _useState2[0],
      setIsShow = _useState2[1];

  (0, _react.useEffect)(function () {
    (dataSource === null || dataSource === void 0 ? void 0 : dataSource.length) === 0 && setIsShow(false);
  }, [dataSource]);
  (0, _react.useEffect)(function () {
    setStyleBottom(isShow ? 120 : 35);
  }, [isShow]);
  var startIdx = (0, _react.useMemo)(function () {
    return pageIndex === 1 ? 0 : pageSize * (pageIndex - 1);
  }, [pageIndex, total]);
  var endIdx = (0, _react.useMemo)(function () {
    return pageIndex * pageSize >= total ? total : pageSize * pageIndex;
  }, [pageIndex, total]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['preview-container'] + " " + (!isShow ? _indexModule["default"]['preview-container-close'] : '')
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['preview-container-bar']
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['preview-container-bar-left']
  }, /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      marginRight: '12px'
    }
  }, "\u5DF2\u9009\u62E9 ", total, " \u4E2A"), (dataSource === null || dataSource === void 0 ? void 0 : dataSource.length) > maxItems && /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      marginRight: '12px',
      color: '#F15A5A'
    }
  }, renderMaxItemsMessageError(maxItems)), isShow ? /*#__PURE__*/_react["default"].createElement(_icon.DownIcon, {
    onClick: function onClick() {
      setIsShow(false);
    }
  }) : /*#__PURE__*/_react["default"].createElement(_icon.UpIcon, {
    onClick: function onClick() {
      setIsShow(true);
    }
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['preview-container-bar-right'] + " " + (pageIndex * pageSize >= total ? _indexModule["default"].disabled : '')
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: _indexModule["default"]['prev'] + " " + (pageIndex === 1 ? _indexModule["default"].disabled : ''),
    onClick: function onClick() {
      if (pageIndex > 1) {
        setPageIndex(pageIndex - 1);
      }
    }
  }, /*#__PURE__*/_react["default"].createElement(_icons.LeftOutlined, null)), /*#__PURE__*/_react["default"].createElement("span", {
    onClick: function onClick() {
      if (pageIndex * pageSize < total) {
        setPageIndex(pageIndex + 1);
      }
    },
    className: _indexModule["default"]['next'] + " " + (pageIndex * pageSize >= total || total === 0 ? _indexModule["default"].disabled : '')
  }, /*#__PURE__*/_react["default"].createElement(_icons.RightOutlined, null)))), !!perviewData.length && /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['preview-list']
  }, perviewData.slice(startIdx, endIdx).map(function (item, index) {
    var data = formatPreviewItemValue(item);

    var content = /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]['preview-item'],
      key: item[rowKey],
      onClick: function onClick() {
        deleteItem(item[rowKey], item);
      }
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: _indexModule["default"]['order']
    }, index + 1 + pageSize * (pageIndex - 1)), /*#__PURE__*/_react["default"].createElement("img", {
      src: data.imgUrl,
      alt: ""
    }), /*#__PURE__*/_react["default"].createElement(_icons.CloseCircleFilled, {
      className: _indexModule["default"]['close']
    }));

    return data.tooltip ? /*#__PURE__*/_react["default"].createElement(_antd.Tooltip, (0, _extends2["default"])({
      placement: "topLeft"
    }, data.tooltip), content) : content;
  })));
};

var YwDrawerSelector = function YwDrawerSelector(_ref3) {
  var title = _ref3.title,
      children = _ref3.children,
      btnType = _ref3.btnType,
      btnText = _ref3.btnText,
      disabled = _ref3.disabled,
      width = _ref3.width,
      filterItems = _ref3.filterItems,
      getTableData = _ref3.getTableData,
      columns = _ref3.columns,
      rowSelection = _ref3.rowSelection,
      pagination = _ref3.pagination,
      rowKey = _ref3.rowKey,
      confirmText = _ref3.confirmText,
      itemWidth = _ref3.itemWidth,
      initialValues = _ref3.initialValues,
      onSubmit = _ref3.onSubmit,
      _onClose = _ref3.onClose,
      formatPreviewItemValue = _ref3.formatPreviewItemValue,
      others = (0, _objectWithoutPropertiesLoose2["default"])(_ref3, _excluded2);

  var _useState3 = (0, _react.useState)(others.visible || false),
      visible = _useState3[0],
      setVisible = _useState3[1];

  var _useState4 = (0, _react.useState)(false),
      confirmLoading = _useState4[0],
      setConfirmLoading = _useState4[1];

  var formRef = (0, _react.useRef)(null);

  var _useState5 = (0, _react.useState)([]),
      selectedData = _useState5[0],
      setSelectedData = _useState5[1];

  var _useState6 = (0, _react.useState)([]),
      selectedRowKeys = _useState6[0],
      setSelectedRowKeys = _useState6[1];

  var _useState7 = (0, _react.useState)(initialValues),
      filterProps = _useState7[0],
      setFilterProps = _useState7[1]; // 预览底部边距


  var _useState8 = (0, _react.useState)(35),
      styleBottom = _useState8[0],
      setStyleBottom = _useState8[1]; //   const onClose = () => {
  //     // setVisible(false);
  //   };


  var isControl = (0, _react.useMemo)(function () {
    return others.visible !== undefined;
  }, [others.visible]);

  var handleInit = function handleInit() {
    // setFilterProps(initialValues || {});
    setConfirmLoading(false);
    setSelectedData([]);
    setSelectedRowKeys([]);
    formRef.current && formRef.current.reset();
  };

  (0, _react.useEffect)(function () {
    setVisible(others.visible); // others.visible && handleInit();
  }, [others.visible]);
  (0, _react.useEffect)(function () {
    if (visible) {
      handleInit();
    } else {
      setFilterProps(initialValues || {});
    }
  }, [visible]);

  var _rowSelection = (0, _extends2["default"])({}, rowSelection, {
    selectedRowKeys: selectedRowKeys,
    hideSelectTotal: true,
    // onChange: (keys, data, info) => {
    //   setSelectedData(unionBy(selectedData, data, rowKey));
    //   setSelectedRowKeys(union(selectedRowKeys, keys));
    // },
    onSelectAll: function onSelectAll(selected, _, changeRows) {
      if (selected) {
        var data = (0, _lodash.unionBy)(changeRows, selectedData, rowKey) || [];
        setSelectedData(data);
        setSelectedRowKeys(data.map(function (v) {
          return v[rowKey];
        }));
      } else {
        var _data = (0, _lodash.xorBy)(selectedData, changeRows, rowKey);

        setSelectedData(_data);
        setSelectedRowKeys(_data.map(function (v) {
          return v[rowKey];
        }));
      }
    },
    onSelect: function onSelect(record, selected) {
      if (selected) {
        var data = (0, _lodash.unionBy)([record], selectedData, rowKey);
        setSelectedData(data);
        setSelectedRowKeys(data.map(function (v) {
          return v[rowKey];
        }));
      } else {
        setSelectedData(selectedData.filter(function (v) {
          return v[rowKey] !== record[rowKey];
        }));
        setSelectedRowKeys(selectedRowKeys.filter(function (v) {
          return v !== record[rowKey];
        }));
      }
    }
  });

  var renderFooter = function renderFooter() {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_YwButton["default"], {
      btnText: confirmText,
      btnType: "primary",
      loading: confirmLoading,
      onClick: function onClick() {
        if (selectedRowKeys.length > others.maxItems) {
          _antd.message.error(others.renderMaxItemsMessageError(others.maxItems));

          setConfirmLoading(false);
          return;
        }

        if (others.minItems && selectedRowKeys.length < others.minItems) {
          _antd.message.error(others.renderMinItemsMessageError(others.minItems));

          setConfirmLoading(false);
          return;
        }

        setConfirmLoading(true);
        onSubmit(selectedRowKeys, selectedData).then(function () {
          !isControl ? setVisible(false) : _onClose();
        })["finally"](function () {
          setConfirmLoading(false);
        });
      }
    }), /*#__PURE__*/_react["default"].createElement(_YwButton["default"], {
      btnText: "\u5173\u95ED",
      style: {
        marginLeft: '12px'
      },
      onClick: function onClick() {
        !isControl ? setVisible(false) : _onClose();
      }
    }));
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, !isControl && /*#__PURE__*/_react["default"].createElement("div", {
    onClick: function onClick() {
      setVisible(true);
    },
    style: {
      display: 'inline-block'
    }
  }, children || /*#__PURE__*/_react["default"].createElement(_YwButton["default"], {
    btnText: btnText,
    btnType: btnType,
    disabled: disabled
  })), /*#__PURE__*/_react["default"].createElement(_antd.Drawer, {
    visible: visible,
    width: width,
    className: _indexModule["default"]['yw-drawer-selector'],
    title: title,
    bodyStyle: {
      padding: '20px'
    },
    maskClosable: false,
    onClose: function onClose() {
      !isControl ? setVisible(false) : _onClose();
    },
    contentWrapperStyle: {
      display: visible ? 'block' : 'none'
    },
    keyboard: false,
    destroyOnClose: true,
    footerStyle: {
      display: 'flex',
      justifyContent: 'flex-end',
      alignItems: 'center'
    },
    footer: renderFooter()
  }, /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, filterItems && /*#__PURE__*/_react["default"].createElement(_YwFilter["default"], {
    itemWidth: itemWidth,
    labelInset: true,
    items: filterItems,
    columnGap: 15,
    initialValues: initialValues,
    onSubmit: function onSubmit(data) {
      setFilterProps((0, _extends2["default"])({}, data));
    },
    onCreate: function onCreate(_form) {
      formRef.current = _form;
    }
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['yw-drawer-selector-table-container'],
    style: {
      paddingBottom: styleBottom
    }
  }, visible && /*#__PURE__*/_react["default"].createElement(DataList, (0, _extends2["default"])({}, others, {
    filterProps: filterProps,
    getTableData: getTableData,
    columns: columns,
    rowSelection: _rowSelection,
    pagination: (0, _index.isObject)(pagination) ? (0, _extends2["default"])({
      size: 'small'
    }, pagination) : pagination,
    listType: others.listType,
    rowKey: rowKey
  }))), /*#__PURE__*/_react["default"].createElement(PreviewList, {
    dataSource: selectedData,
    pageSize: 10,
    rowKey: rowKey,
    maxItems: others.maxItems,
    renderMaxItemsMessageError: others.renderMaxItemsMessageError,
    setStyleBottom: setStyleBottom,
    formatPreviewItemValue: formatPreviewItemValue,
    deleteItem: function deleteItem(key, data) {
      setSelectedData(selectedData.filter(function (v) {
        return v[rowKey] !== data[rowKey];
      }));
      setSelectedRowKeys(selectedRowKeys.filter(function (v) {
        return v !== key;
      }));
    }
  }))));
};

YwDrawerSelector.defaultProps = {
  width: '833px',
  pagination: {},
  rowSelection: {},
  rowKey: 'id',
  confirmText: '确认',
  listType: 'table',
  minItems: 0,
  renderMaxItemsMessageError: function renderMaxItemsMessageError(maxItems) {
    return "\u6700\u591A\u53EF\u9009 " + maxItems + " \u4E2A";
  },
  renderMinItemsMessageError: function renderMinItemsMessageError(minItems) {
    return "\u81F3\u5C11\u9009 " + minItems + " \u4E2A";
  } // itemWidth: 300,

};
var _default = YwDrawerSelector;
exports["default"] = _default;