"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _antd = require("antd");

var _YwJsonForm = require("../YwJsonForm");

var _YwButton = _interopRequireDefault(require("../YwButton"));

var _excluded = ["title", "size", "btnText", "btnType", "items", "disabled", "editable", "initialValues", "layoutProps", "btnDisabled", "children", "linkages", "onCancel", "onConfirm", "onOpen", "onFormInit"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var widthMap = {
  s: 680,
  m: 920,
  l: 1200,
  full: '100vw'
};

var YwFormDialog = function YwFormDialog(_ref) {
  var title = _ref.title,
      size = _ref.size,
      btnText = _ref.btnText,
      btnType = _ref.btnType,
      items = _ref.items,
      disabled = _ref.disabled,
      editable = _ref.editable,
      initialValues = _ref.initialValues,
      layoutProps = _ref.layoutProps,
      btnDisabled = _ref.btnDisabled,
      children = _ref.children,
      linkages = _ref.linkages,
      _onCancel = _ref.onCancel,
      onConfirm = _ref.onConfirm,
      onOpen = _ref.onOpen,
      onFormInit = _ref.onFormInit,
      others = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  var _useState = (0, _react.useState)(others.visible || false),
      visible = _useState[0],
      setVisible = _useState[1];

  var isControl = (0, _react.useMemo)(function () {
    return others.visible !== undefined;
  }, []);
  var formRef = (0, _react.useRef)(null);

  var _useState2 = (0, _react.useState)(false),
      spinning = _useState2[0],
      setSpinning = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      confirmLoading = _useState3[0],
      setConfirmLoading = _useState3[1];

  var handleOk = function handleOk() {
    var _formRef$current;

    formRef === null || formRef === void 0 ? void 0 : (_formRef$current = formRef.current) === null || _formRef$current === void 0 ? void 0 : _formRef$current.submit().then(function (value) {
      if (isControl) {
        onConfirm(value);
      } else {
        setConfirmLoading(true);
        onConfirm(value).then(function () {
          setVisible(false);
        })["finally"](function () {
          setConfirmLoading(false);
        });
      }
    });
  }; // const handleCancel = () => {
  //   onCancel();
  //   setConfirmLoading(false);
  // };


  (0, _react.useEffect)(function () {
    setVisible(others.visible);
  }, [others.visible]);
  (0, _react.useEffect)(function () {
    if (visible) {
      if (onOpen) {
        setSpinning(true);
        onOpen().then(function (_initialValues) {
          var _formRef$current2;

          _initialValues && ((_formRef$current2 = formRef.current) === null || _formRef$current2 === void 0 ? void 0 : _formRef$current2.setValues(_initialValues || {}));
        })["finally"](function () {
          setSpinning(false);
        });
      } else {// formRef?.current?.setValues(initialValues || {});
      }
    }
  }, [visible]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, others.visible === undefined && /*#__PURE__*/_react["default"].createElement("div", {
    onClick: function onClick() {
      setVisible(true);
    },
    style: {
      display: 'inline-block'
    }
  }, children || /*#__PURE__*/_react["default"].createElement(_antd.Button, {
    type: btnType,
    disabled: btnDisabled
  }, btnText)), /*#__PURE__*/_react["default"].createElement(_antd.Modal, (0, _extends2["default"])({}, others, {
    wrapClassName: _indexModule["default"]['yw-form-dialog'],
    title: title,
    width: widthMap[size],
    visible: visible,
    onOk: handleOk,
    maskClosable: false,
    okText: "\u786E\u5B9A",
    destroyOnClose: true // cancelText={editable ? '取消' : '关闭'}
    ,
    onCancel: function onCancel() {
      !isControl ? setVisible(false) : _onCancel();
    },
    footer: [/*#__PURE__*/_react["default"].createElement(_YwButton["default"], {
      key: "back",
      onClick: function onClick() {
        !isControl ? setVisible(false) : _onCancel();
      }
    }, editable ? '取消' : '关闭'), editable ? [/*#__PURE__*/_react["default"].createElement(_YwButton["default"], {
      key: "submit",
      btnType: "primary",
      loading: others.confirmLoading === undefined ? confirmLoading : others.confirmLoading,
      onClick: handleOk
    }, "\u786E\u5B9A")] : []]
  }), /*#__PURE__*/_react["default"].createElement(_antd.Spin, {
    spinning: spinning
  }, /*#__PURE__*/_react["default"].createElement(_YwJsonForm.YwJsonForm, {
    items: items,
    editable: editable,
    initialValues: initialValues,
    onCreate: function onCreate(_form) {
      formRef.current = _form;
      onFormInit(_form);
    },
    disabled: disabled,
    layoutProps: layoutProps,
    buttons: [],
    linkages: linkages
  }))));
};

YwFormDialog.defaultProps = {
  btnType: 'primary',
  size: 's',
  btnDisabled: false,
  editable: true,
  onCancel: function onCancel() {},
  onConfirm: function onConfirm() {},
  onFormInit: function onFormInit(any) {}
};
var _default = YwFormDialog;
exports["default"] = _default;