"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _antd = require("@formily/antd");

var _react2 = require("@formily/react");

var COMPS = _interopRequireWildcard(require("./components"));

var _utils = require("../../utils");

var _hook = require("./hook");

var _excluded = ["sortable", "layoutProps", "hasAdd", "maxRow", "minRow", "arrayConfig", "name", "editable", "itemsType"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var SchemaField = (0, _react2.createSchemaField)({
  components: (0, _extends2["default"])({}, COMPS, {
    ArrayItems: _antd.ArrayItems
  })
});

var getArrayItemsSchema = function getArrayItemsSchema(_ref) {
  var _properties;

  var sortable = _ref.sortable,
      name = _ref.name,
      arrayConfig = _ref.arrayConfig,
      editable = _ref.editable,
      arrSchema = _ref.arrSchema,
      maxRow = _ref.maxRow,
      minRow = _ref.minRow,
      itemsType = _ref.itemsType;
  var records = {};
  arrayConfig.forEach(function (item, idx) {
    var _item$componentProps, _item$componentProps2, _item$componentProps3, _item$componentProps4;

    var options = item["enum"] || (0, _utils.formatOptionsList)((_item$componentProps = item.componentProps) === null || _item$componentProps === void 0 ? void 0 : _item$componentProps.dataSource, (_item$componentProps2 = item.componentProps) === null || _item$componentProps2 === void 0 ? void 0 : _item$componentProps2.fieldNames) || (0, _utils.formatOptionsList)((_item$componentProps3 = item.componentProps) === null || _item$componentProps3 === void 0 ? void 0 : _item$componentProps3.dict, {
      label: 'dictName',
      value: 'dictValue'
    });
    records[item.name] = (0, _extends2["default"])({}, item, {
      "enum": options,
      type: item.type || 'string'
    }, (_item$componentProps4 = item.componentProps) !== null && _item$componentProps4 !== void 0 && _item$componentProps4.getDataSource && item.component !== 'SearchSelect' ? {
      'x-reactions': ['{{useAsyncDataSource()}}']
    } : {}, {
      "default": item.defaultValue,
      'x-disabled': item.disabled,
      'x-decorator': item.editable ? 'Editable' : 'FormItem',
      'x-component': COMPS[item.component],
      'x-validator': item.rules,
      'x-decorator-props': (0, _extends2["default"])({}, item.props || {}),
      'x-component-props': (0, _extends2["default"])({}, item.componentProps)
    });
  });
  var remove = {
    type: 'void',
    title: '',
    'x-component': 'ArrayItems.Remove',
    'x-reactions': {
      dependencies: [name],
      fulfill: {
        schema: {
          'x-visible': '{{$deps[0]?.length > minRow}}' // 任意层次属性都支持表达式

        }
      }
    }
  };
  var moveUp = {
    type: 'void',
    'x-visible': sortable,
    'x-component': 'ArrayItems.MoveUp'
  };
  var moveDown = {
    type: 'void',
    'x-visible': sortable,
    'x-component': 'ArrayItems.MoveDown'
  };
  var addition = {
    type: 'string',
    title: '',
    'x-component': 'ArrayItems.Addition',
    'x-component-props': {
      align: 'left',
      type: 'link'
    },
    'x-reactions': {
      dependencies: [name],
      fulfill: {
        schema: {
          'x-visible': '{{!!hasAdd}}'
        }
      }
    }
  };

  var getItems = function getItems() {
    if (itemsType === 'string') {
      return {
        type: 'void',
        'x-component': 'Space',
        'x-component-props': {
          align: 'flex-start'
        },
        properties: (0, _extends2["default"])({}, records, {
          addition: addition,
          remove: remove,
          moveUp: moveUp,
          moveDown: moveDown
        })
      };
    }

    return {
      type: 'object',
      properties: {
        space: {
          type: 'void',
          'x-component': 'Space',
          'x-component-props': {
            align: 'flex-start'
          },
          properties: (0, _extends2["default"])({}, records, {
            addition: addition,
            remove: remove,
            moveUp: moveUp,
            moveDown: moveDown
          })
        }
      }
    };
  };

  return {
    type: 'object',
    properties: (_properties = {}, _properties[name] = (0, _extends2["default"])({}, arrSchema, {
      title: '',
      'x-component': 'ArrayItems',
      'x-decorator': 'FormItem',
      'x-decorator-props': {
        style: {
          marginBottom: 0
        }
      },
      'x-read-pretty': arrSchema.readOnly,
      maxItems: maxRow,
      minItems: minRow,
      'x-component-props': (0, _extends2["default"])({}, arrSchema['x-component-props']),
      items: getItems()
    }), _properties)
  };
};

var YArrayItems = function YArrayItems(_ref2) {
  var sortable = _ref2.sortable,
      layoutProps = _ref2.layoutProps,
      _ref2$hasAdd = _ref2.hasAdd,
      hasAdd = _ref2$hasAdd === void 0 ? true : _ref2$hasAdd,
      _ref2$maxRow = _ref2.maxRow,
      maxRow = _ref2$maxRow === void 0 ? 9999 : _ref2$maxRow,
      _ref2$minRow = _ref2.minRow,
      minRow = _ref2$minRow === void 0 ? 0 : _ref2$minRow,
      _ref2$arrayConfig = _ref2.arrayConfig,
      arrayConfig = _ref2$arrayConfig === void 0 ? [] : _ref2$arrayConfig,
      name = _ref2.name,
      editable = _ref2.editable,
      _ref2$itemsType = _ref2.itemsType,
      itemsType = _ref2$itemsType === void 0 ? 'object' : _ref2$itemsType,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded);
  var form = (0, _react2.useParentForm)();
  var arrSchema = (0, _react2.useFieldSchema)();
  var schema = getArrayItemsSchema({
    sortable: sortable,
    arrayConfig: arrayConfig,
    name: name,
    editable: editable,
    arrSchema: arrSchema,
    maxRow: maxRow,
    minRow: minRow,
    itemsType: itemsType
  });
  return /*#__PURE__*/_react["default"].createElement(_react2.FormProvider, {
    form: form
  }, /*#__PURE__*/_react["default"].createElement(_react2.Observer, null, /*#__PURE__*/_react["default"].createElement(SchemaField, {
    schema: schema,
    scope: {
      maxRow: maxRow,
      hasAdd: hasAdd,
      minRow: minRow,
      sortable: sortable,
      itemsType: itemsType,
      useAsyncDataSource: _hook.useAsyncDataSource
    }
  })));
};

var _default = YArrayItems;
exports["default"] = _default;