"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _antd = require("@formily/antd");

var _react2 = require("@formily/react");

var COMPS = _interopRequireWildcard(require("./components"));

var _excluded = ["sortable", "layoutProps", "hasAdd", "maxRow", "minRow", "arrayConfig", "name", "editable"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var SchemaField = (0, _react2.createSchemaField)({
  components: (0, _extends2["default"])({}, COMPS, {
    ArrayTable: _antd.ArrayTable
  })
});

var getArrayTableSchema = function getArrayTableSchema(_ref) {
  var _properties2;

  var sortable = _ref.sortable,
      name = _ref.name,
      arrayConfig = _ref.arrayConfig,
      editable = _ref.editable,
      arrSchema = _ref.arrSchema;
  var records = {};
  arrayConfig.forEach(function (item, idx) {
    var _properties;

    records["NO_FIELD_NAME_" + item.name + "_" + idx] = {
      type: 'void',
      'x-component': 'ArrayTable.Column',
      'x-component-props': {
        title: item.title,
        align: 'left'
      },
      properties: (_properties = {}, _properties[item.name] = (0, _extends2["default"])({}, item, {
        title: '',
        "default": '',
        'x-disabled': item.disabled,
        'x-decorator': item.editable ? 'Editable' : 'FormItem',
        'x-component': COMPS[item.component],
        'x-validator': item.rules,
        'x-decorator-props': {},
        'x-component-props': (0, _extends2["default"])({}, item.componentProps, {
          required: true
        })
      }), _properties)
    };
  });
  return {
    type: 'object',
    properties: (_properties2 = {}, _properties2[name] = (0, _extends2["default"])({}, arrSchema, {
      title: '',
      'x-decorator': 'FormItem',
      'x-decorator-props': {
        style: {
          marginBottom: 0
        }
      },
      // default: dataSource,
      'x-read-pretty': arrSchema.readOnly,
      'x-component-props': (0, _extends2["default"])({
        pagination: {
          pageSize: 10
        }
      }, arrSchema['x-component-props'], {
        align: 'left',
        bordered: false
      }),
      items: {
        type: 'object',
        properties: (0, _extends2["default"])({
          column1: {
            type: 'void',
            'x-visible': false,
            'x-component': 'ArrayTable.Column',
            'x-component-props': {
              title: 'Sort',
              align: 'center'
            },
            properties: {
              sort: {
                type: 'void',
                // 'x-visible': false,
                'x-component': 'ArrayTable.SortHandle'
              }
            }
          }
        }, records, {
          column6: {
            type: 'void',
            'x-reactions': {
              dependencies: [name],
              fulfill: {
                schema: {
                  'x-visible': '{{($deps[0]?.length > minRow) || sortable}}' // 任意层次属性都支持表达式

                }
              }
            },
            'x-component': 'ArrayTable.Column',
            'x-component-props': {
              title: '',
              dataIndex: 'operations' // fixed: 'right',

            },
            properties: {
              item: {
                type: 'void',
                'x-component': 'Space',
                properties: {
                  addition: {
                    type: 'string',
                    title: '',
                    'x-component': 'ArrayTable.Addition',
                    'x-component-props': {
                      align: 'left',
                      type: 'link'
                    },
                    'x-reactions': {
                      dependencies: [name],
                      fulfill: {
                        schema: {
                          'x-visible': '{{ hasAdd && sortable }}'
                        }
                      }
                    }
                  },
                  remove: {
                    type: 'void',
                    'x-reactions': {
                      dependencies: [name],
                      fulfill: {
                        schema: {
                          'x-visible': '{{ hasAdd && sortable }}'
                        }
                      }
                    },
                    'x-component': 'ArrayTable.Remove'
                  },
                  moveDown: {
                    type: 'void',
                    'x-visible': sortable,
                    'x-component-props': {
                      style: {
                        color: '#1890ff'
                      }
                    },
                    'x-component': 'ArrayTable.MoveDown'
                  },
                  moveUp: {
                    type: 'void',
                    'x-visible': sortable,
                    'x-component-props': {
                      style: {
                        color: '#1890ff'
                      }
                    },
                    'x-component': 'ArrayTable.MoveUp'
                  }
                }
              }
            }
          }
        })
      }
    }), _properties2)
  };
};

var YArrayTable = function YArrayTable(_ref2) {
  var sortable = _ref2.sortable,
      layoutProps = _ref2.layoutProps,
      _ref2$hasAdd = _ref2.hasAdd,
      hasAdd = _ref2$hasAdd === void 0 ? true : _ref2$hasAdd,
      _ref2$maxRow = _ref2.maxRow,
      maxRow = _ref2$maxRow === void 0 ? 9999 : _ref2$maxRow,
      _ref2$minRow = _ref2.minRow,
      minRow = _ref2$minRow === void 0 ? 0 : _ref2$minRow,
      _ref2$arrayConfig = _ref2.arrayConfig,
      arrayConfig = _ref2$arrayConfig === void 0 ? [] : _ref2$arrayConfig,
      name = _ref2.name,
      editable = _ref2.editable,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded);
  var form = (0, _react2.useParentForm)();
  var arrSchema = (0, _react2.useFieldSchema)();
  var schema = getArrayTableSchema({
    sortable: sortable,
    arrayConfig: arrayConfig,
    name: name,
    editable: editable,
    arrSchema: arrSchema
  });
  return /*#__PURE__*/_react["default"].createElement(_react2.FormProvider, {
    form: form
  }, /*#__PURE__*/_react["default"].createElement(SchemaField, {
    schema: schema,
    scope: {
      maxRow: maxRow,
      hasAdd: hasAdd,
      minRow: minRow,
      sortable: sortable
    }
  }));
};

var _default = (0, _react2.observer)(YArrayTable);

exports["default"] = _default;