"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _cascaderSelect = _interopRequireDefault(require("@alifd/next/lib/cascader-select"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@formily/react");

var _reactive = require("@formily/reactive");

var _lodash = require("lodash");

var _index = require("../../utils/index");

var _excluded = ["value", "fieldNames", "loadData", "labelInValue"];
var obs = (0, _reactive.observable)({
  dataSource: []
});

var YCascaderSelect = function YCascaderSelect(_ref) {
  var _field$initialValue;

  var value = _ref.value,
      fieldNames = _ref.fieldNames,
      loadData = _ref.loadData,
      _ref$labelInValue = _ref.labelInValue,
      labelInValue = _ref$labelInValue === void 0 ? false : _ref$labelInValue,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var field = (0, _react2.useField)();
  var defaultValue = (0, _index.isArray)(field.initialValue) ? (_field$initialValue = field.initialValue) === null || _field$initialValue === void 0 ? void 0 : _field$initialValue.map(function (item) {
    return (0, _index.isObject)(item) ? item[fieldNames.value] : item;
  }) : field.initialValue;
  return /*#__PURE__*/_react["default"].createElement(_react2.Observer, null, function () {
    return /*#__PURE__*/_react["default"].createElement(_cascaderSelect["default"], (0, _extends2["default"])({}, props, {
      disabled: field.disabled,
      dataSource: field.dataSource,
      value: field.value,
      isPreview: !field.editable,
      defaultValue: defaultValue,
      onChange: function onChange(value, data, extra) {
        field.setValue(value);
        props.onChange && props.onChange(value, data, extra); // if (props.onChange) {
        //   props.onChange(field, value, data, extra);
        // } else {
        //   console.log(value);
        //   field.setValue(value);
        // }
      }
    }, loadData ? {
      loadData: function () {
        var _loadData = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(data, source) {
          var _data$pos;

          var res;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return props.getDataSource(field, data);

                case 2:
                  res = _context.sent;
                  source.children = (0, _index.formatOptionsList)(res, fieldNames);
                  (0, _lodash.set)([obs.dataSource], (_data$pos = data.pos) === null || _data$pos === void 0 ? void 0 : _data$pos.split('-'), source);
                  return _context.abrupt("return", obs.dataSource);

                case 6:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function loadData(_x, _x2) {
          return _loadData.apply(this, arguments);
        }

        return loadData;
      }()
    } : {}));
  });
};

var _default = YCascaderSelect;
exports["default"] = _default;