"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.WeekRangePicker = exports.WeekPicker = exports.TimeRangePicker = exports.TimePicker = exports.MonthRangePicker = exports.MonthPicker = exports.DateTimeRangePicker = exports.DateTimePicker = exports.DateRangePicker = exports.DateRangeGroup = exports.DatePicker = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("@formily/antd");

var _zh_CN = _interopRequireDefault(require("antd/es/date-picker/locale/zh_CN"));

var _core = require("@formily/core");

var _react2 = require("@formily/react");

var _moment = _interopRequireDefault(require("moment"));

var _antd2 = require("antd");

var _utils = require("../../utils");

var _index = _interopRequireDefault(require("../YwButton/index"));

var _excluded = ["ranges"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var RangePicker = _antd.DatePicker.RangePicker;
var common = {
  locale: _zh_CN["default"]
};

var Permanent = function Permanent(props) {
  var field = (0, _react2.useField)();
  var form = (0, _react2.useParentForm)();
  var schema = (0, _react2.useFieldSchema)();

  var _useState = (0, _react.useState)(props.isPermanent),
      isPermanent = _useState[0],
      setIsPermanent = _useState[1];

  (0, _react.useEffect)(function () {
    isPermanent && field.setValue(false);
  }, [isPermanent]);
  (0, _react2.useFormEffects)(function () {
    (0, _core.onFieldValueChange)(schema.name, function (field) {
      var _field$value;

      !!((_field$value = field.value) !== null && _field$value !== void 0 && _field$value.length) && setIsPermanent(false);
    });
  });
  return isPermanent !== undefined && /*#__PURE__*/_react["default"].createElement(_antd2.Checkbox // {...props}
  , {
    checked: isPermanent,
    style: {
      right: '-75px',
      position: 'absolute'
    },
    onChange: function onChange(e) {
      var checked = e.target.checked; // props.onChange && props.onChange(e.target.checked);

      setIsPermanent(checked);
      form.setValuesIn('isPermanent', checked);
      checked ? field.setRequired(false) : field.setRequired(schema.required);
    }
  }, "\u957F\u671F");
};

var DateRangeGroup = function DateRangeGroup(_ref) {
  var ranges = _ref.ranges,
      _ref$rangesValue = _ref.rangesValue,
      rangesValue = _ref$rangesValue === void 0 ? {} : _ref$rangesValue,
      onChange = _ref.onChange;
  var field = (0, _react2.useField)();
  var schema = (0, _react2.useFieldSchema)();
  (0, _react2.useFormEffects)(function () {
    (0, _core.onFieldValueChange)(schema.name, function (field) {
      onChange(field.value);
    });
  });
  return /*#__PURE__*/_react["default"].createElement(_antd.Space, null, ranges.map(function (v) {
    return /*#__PURE__*/_react["default"].createElement(_index["default"], {
      type: "default",
      btnText: v,
      onClick: function onClick() {
        var timeArr = rangesValue[v] || _utils.RANGES[v];
        field.setValue(timeArr ? [timeArr[0].format('YYYY-MM-DD'), timeArr[1].format('YYYY-MM-DD')] : null);
      }
    });
  }));
};

exports.DateRangeGroup = DateRangeGroup;

var useMaxDates = function useMaxDates(_ref2) {
  var maxDates = _ref2.maxDates;

  var _useState2 = (0, _react.useState)(null),
      dates = _useState2[0],
      setDates = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      hackValue = _useState3[0],
      setHackValue = _useState3[1];

  var disabledDate = function disabledDate(current) {
    if (!dates) {
      return false;
    }

    var tooLate = dates[0] && current.diff(dates[0], 'days') > maxDates;
    var tooEarly = dates[1] && dates[1].diff(current, 'days') > maxDates;
    return !!tooEarly || !!tooLate;
  };

  var onOpenChange = function onOpenChange(open) {
    if (open) {
      setHackValue([null, null]);
      setDates([null, null]);
    } else {
      setHackValue(null);
    }
  };

  var onCalendarChange = function onCalendarChange(data) {
    setDates(data);
  };

  return maxDates !== undefined ? {
    disabledDate: disabledDate,
    onCalendarChange: onCalendarChange,
    onOpenChange: onOpenChange
  } : {};
};

var useFieldValue = function useFieldValue(field) {
  var getValue = (0, _react.useCallback)(function () {
    return (0, _core.isArrayField)(field) ? field.value[0] || '' : field.value || '';
  }, [field]);

  var _useState4 = (0, _react.useState)(getValue()),
      value = _useState4[0],
      setValue = _useState4[1];

  (0, _react2.useFormEffects)(function () {
    (0, _core.onFieldValueChange)(field.props.name, function () {
      setValue(getValue());
    });
  });
  return {
    value: value
  };
};

var formatProps = function formatProps(props) {
  return (0, _extends2["default"])({}, common, {
    allowClear: true
  }, props);
};

var formatRangeProps = function formatRangeProps(props) {
  return (0, _extends2["default"])({}, common, {
    allowClear: true
  }, props);
}; // 日期选择


var DatePicker = function DatePicker(props) {
  var _props = formatProps((0, _extends2["default"])({}, props, {
    picker: 'date'
  }));

  var field = (0, _react2.useField)();

  var _useFieldValue = useFieldValue(field),
      value = _useFieldValue.value;

  return /*#__PURE__*/_react["default"].createElement(_antd.DatePicker, (0, _extends2["default"])({
    format: "YYYY-MM-DD"
  }, _props, {
    disabled: field.disabled,
    value: value,
    onChange: function onChange(date) {
      (0, _core.isArrayField)(field) ? field.setValue([date ? date + " 00:00:00" : date, date ? date + " 23:59:59" : date]) : field.setValue(date);
    }
  }));
}; // 日期时间选择


exports.DatePicker = DatePicker;

var DateTimePicker = function DateTimePicker(props) {
  var _props = formatProps((0, _extends2["default"])({}, props, {
    picker: 'date',
    showTime: {
      hideDisabledOptions: true,
      defaultValue: props.defaultTime ? (0, _moment["default"])(props.defaultTime, 'HH:mm:ss') : (0, _moment["default"])('00:00:00', 'HH:mm:ss')
    }
  }));

  var field = (0, _react2.useField)();

  var _useFieldValue2 = useFieldValue(field),
      value = _useFieldValue2.value;

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_antd.DatePicker, (0, _extends2["default"])({
    format: "YYYY-MM-DD HH:mm:ss"
  }, _props, {
    disabled: field.disabled,
    value: value,
    onChange: function onChange(date) {
      (0, _core.isArrayField)(field) ? field.setValue([date, date]) : field.setValue(date);
    }
  })));
}; // 月选择


exports.DateTimePicker = DateTimePicker;

var MonthPicker = function MonthPicker(props) {
  var _props = formatProps((0, _extends2["default"])({}, props, {
    picker: 'month'
  }));

  var field = (0, _react2.useField)();

  var _useFieldValue3 = useFieldValue(field),
      value = _useFieldValue3.value;

  return /*#__PURE__*/_react["default"].createElement(_antd.DatePicker, (0, _extends2["default"])({}, _props, {
    value: value,
    disabled: field.disabled,
    onChange: function onChange(date) {
      (0, _core.isArrayField)(field) ? field.setValue([date ? (0, _moment["default"])(date, 'YYYY-MM').startOf('month').format('YYYY-MM-DD') : date, date ? (0, _moment["default"])(date, 'YYYY-MM').endOf('month').format('YYYY-MM-DD') : date]) : field.setValue(date);
    }
  }));
};

exports.MonthPicker = MonthPicker;

var WeekPicker = function WeekPicker(props) {
  var _props = formatProps((0, _extends2["default"])({}, props, {
    picker: 'week'
  }));

  var field = (0, _react2.useField)();

  var _useFieldValue4 = useFieldValue(field),
      value = _useFieldValue4.value;

  return /*#__PURE__*/_react["default"].createElement(_antd.DatePicker, (0, _extends2["default"])({}, _props, {
    value: value,
    disabled: field.disabled,
    onChange: function onChange(date) {
      field.setValue([date ? (0, _moment["default"])(date, 'YYYY-ww').startOf('week').format('YYYY-MM-DD') : date, date ? (0, _moment["default"])(date, 'YYYY-ww').endOf('week').format('YYYY-MM-DD') : date]);
    }
  }));
}; // 时间选择


exports.WeekPicker = WeekPicker;

var TimePicker = function TimePicker(props) {
  var _props = formatProps((0, _extends2["default"])({}, props));

  var field = (0, _react2.useField)();
  return /*#__PURE__*/_react["default"].createElement(_antd.TimePicker, (0, _extends2["default"])({
    format: "HH:mm:ss"
  }, _props, {
    disabled: field.disabled
  }));
}; // range


exports.TimePicker = TimePicker;

var WeekRangePicker = function WeekRangePicker(props) {
  var _props = formatRangeProps((0, _extends2["default"])({}, props, {
    picker: 'week'
  }));

  var field = (0, _react2.useField)();

  var formatWeek = function formatWeek(date) {
    var _date;

    if (date === void 0) {
      date = [];
    }

    if (!((_date = date) !== null && _date !== void 0 && _date.length)) return [];
    return [(0, _moment["default"])(props.value[0], 'YYYY-MM-DD').format('YYYY-wo'), (0, _moment["default"])(props.value[1], 'YYYY-MM-DD').format('YYYY-wo')];
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(RangePicker, (0, _extends2["default"])({
    separator: "-"
  }, _props, {
    value: formatWeek(props.value),
    disabled: field.disabled,
    onChange: function onChange(date) {
      field.setValue([date ? (0, _moment["default"])(date[0], 'YYYY-ww').startOf('week').format('YYYY-MM-DD') : date, date ? (0, _moment["default"])(date[1], 'YYYY-ww').endOf('week').format('YYYY-MM-DD') : date]);
    }
  })), props.isPermanent !== undefined && /*#__PURE__*/_react["default"].createElement(Permanent, {
    isPermanent: props.isPermanent
  }));
};

exports.WeekRangePicker = WeekRangePicker;

var DateRangePicker = function DateRangePicker(_ref3) {
  var ranges = _ref3.ranges,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref3, _excluded);
  var field = (0, _react2.useField)();

  var _ranges = Array.isArray(ranges) ? ranges.reduce(function (curr, prev) {
    if (!_utils.RANGES[prev]) {
      return curr;
    }

    curr[prev] = _utils.RANGES[prev];
    return curr;
  }, {}) : ranges || {};

  var _useMaxDates = useMaxDates({
    maxDates: props.maxDates
  }),
      disabledDate = _useMaxDates.disabledDate,
      onCalendarChange = _useMaxDates.onCalendarChange;

  var _props = formatRangeProps((0, _extends2["default"])({
    disabledDate: disabledDate,
    onCalendarChange: onCalendarChange
  }, props, {
    ranges: _ranges,
    picker: 'date'
  }));

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(RangePicker, (0, _extends2["default"])({
    separator: "-"
  }, _props, {
    disabled: field.disabled
  })), props.isPermanent !== undefined && /*#__PURE__*/_react["default"].createElement(Permanent, {
    isPermanent: props.isPermanent
  }));
};

exports.DateRangePicker = DateRangePicker;

var MonthRangePicker = function MonthRangePicker(props) {
  var _props = formatRangeProps((0, _extends2["default"])({}, props, {
    picker: 'month'
  }));

  var field = (0, _react2.useField)();

  var formatMonth = function formatMonth(date) {
    var _date2;

    if (date === void 0) {
      date = [];
    }

    if (!((_date2 = date) !== null && _date2 !== void 0 && _date2.length)) return [];
    return [(0, _moment["default"])(props.value[0]).startOf('month').format('YYYY-MM'), (0, _moment["default"])(props.value[1]).startOf('month').format('YYYY-MM')];
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(RangePicker, (0, _extends2["default"])({
    separator: "-"
  }, _props, {
    value: formatMonth(props.value),
    disabled: field.disabled,
    onChange: function onChange(date) {
      field.setValue([date ? (0, _moment["default"])(date[0]).startOf('month').format('YYYY-MM-DD') : date, date ? (0, _moment["default"])(date[1]).endOf('month').format('YYYY-MM-DD') : date]);
    }
  })), props.isPermanent !== undefined && /*#__PURE__*/_react["default"].createElement(Permanent, {
    isPermanent: props.isPermanent
  }));
};

exports.MonthRangePicker = MonthRangePicker;

var DateTimeRangePicker = function DateTimeRangePicker(props) {
  var _props$defaultTime;

  var field = (0, _react2.useField)();

  var _useMaxDates2 = useMaxDates({
    maxDates: props.maxDates
  }),
      disabledDate = _useMaxDates2.disabledDate,
      onCalendarChange = _useMaxDates2.onCalendarChange;

  var _props = formatRangeProps((0, _extends2["default"])({
    disabledDate: disabledDate,
    onCalendarChange: onCalendarChange
  }, props, {
    picker: 'date',
    showTime: {
      hideDisabledOptions: true,
      defaultValue: ((_props$defaultTime = props.defaultTime) === null || _props$defaultTime === void 0 ? void 0 : _props$defaultTime.length) > 0 ? [(0, _moment["default"])(props.defaultTime[0], 'HH:mm:ss'), (0, _moment["default"])(props.defaultTime[1], 'HH:mm:ss')] : [(0, _moment["default"])('00:00:00', 'HH:mm:ss'), (0, _moment["default"])('23:59:59', 'HH:mm:ss')]
    }
  }));

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(RangePicker, (0, _extends2["default"])({
    format: "YYYY-MM-DD HH:mm:ss",
    separator: "-"
  }, _props, {
    disabled: field.disabled
  })), props.isPermanent !== undefined && /*#__PURE__*/_react["default"].createElement(Permanent, {
    isPermanent: props.isPermanent
  }));
}; // 时间范围选择


exports.DateTimeRangePicker = DateTimeRangePicker;

var TimeRangePicker = function TimeRangePicker(props) {
  var _props = formatRangeProps((0, _extends2["default"])({}, props));

  var field = (0, _react2.useField)();
  return /*#__PURE__*/_react["default"].createElement(_antd.TimePicker.RangePicker, (0, _extends2["default"])({
    format: "HH:mm:ss"
  }, _props, {
    disabled: field.disabled
  }));
};

exports.TimeRangePicker = TimeRangePicker;