"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _antd = require("@formily/antd");

var _react2 = require("@formily/react");

var _index = require("../../utils/index");

var _excluded = ["prefix", "suffix"];

var YNumberRangePicker = function YNumberRangePicker(_ref) {
  var prefix = _ref.prefix,
      suffix = _ref.suffix,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var field = (0, _react2.useField)();

  var getValue = function getValue(data, idx) {
    return (0, _index.isArray)(data) ? data[idx] : data;
  };

  var commonProps = (0, _extends2["default"])({
    formatter: function formatter(value) {
      return "" + (prefix ? prefix + " " : '') + props.formatter(value);
    }
  }, suffix ? {
    style: {
      paddingRight: suffix.length * 12 + 22 + "px"
    }
  } : {});

  var renderSuffix = function renderSuffix() {
    return suffix && /*#__PURE__*/_react["default"].createElement("span", {
      style: {
        position: 'absolute',
        right: '26px'
      }
    }, suffix);
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_react2.VoidField, {
    component: [_antd.Space],
    decorator: ['Space', {
      align: 'center'
    }]
  }, /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      position: 'relative'
    }
  }, /*#__PURE__*/_react["default"].createElement(_antd.NumberPicker, (0, _extends2["default"])({}, props, commonProps, {
    value: getValue(props.value, 0),
    min: getValue(props.min, 0),
    max: getValue(props.value, 1) !== undefined ? Math.min(getValue(props.value, 1), getValue(props.max, 0)) : getValue(props.max, 0),
    onChange: function onChange(num) {
      field.setValue([num, field.value[1]]);
    }
  })), renderSuffix()), /*#__PURE__*/_react["default"].createElement("span", null, "-"), /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      position: 'relative'
    }
  }, /*#__PURE__*/_react["default"].createElement(_antd.NumberPicker, (0, _extends2["default"])({}, props, commonProps, {
    value: getValue(props.value, 1),
    min: getValue(props.value, 0) !== undefined ? Math.max(getValue(props.value, 0), getValue(props.min, 1)) : getValue(props.min, 1),
    max: getValue(props.max, 1),
    onChange: function onChange(num) {
      field.setValue([field.value[0], num]);
    }
  })), renderSuffix())));
};

YNumberRangePicker.defaultProps = {
  formatter: function formatter(value) {
    return value;
  },
  min: Number.MIN_SAFE_INTEGER,
  max: Number.MAX_SAFE_INTEGER
};
var _default = YNumberRangePicker;
exports["default"] = _default;