"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _react2 = require("@formily/react");

var _index = _interopRequireDefault(require("../YwOrgSelector/index"));

var _core = require("@formily/core");

var _index2 = require("../../utils/index");

var _lodash = require("lodash");

var _excluded = ["value", "fieldNames", "getOrgList"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var YOrgSelector = function YOrgSelector(_ref) {
  var value = _ref.value,
      _ref$fieldNames = _ref.fieldNames,
      fieldNames = _ref$fieldNames === void 0 ? {
    label: 'orgName',
    value: 'orgId'
  } : _ref$fieldNames,
      getOrgList = _ref.getOrgList,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var field = (0, _react2.useField)();

  var formatOrgName = function formatOrgName(_value) {
    if (_value === void 0) {
      _value = [];
    }

    return _value.map(function (v) {
      var _v$orgName;

      return (0, _extends2["default"])({}, v, {
        orgName: (0, _lodash.last)((_v$orgName = v.orgName) === null || _v$orgName === void 0 ? void 0 : _v$orgName.split('/'))
      });
    });
  };

  var _useState = (0, _react.useState)(false),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = (0, _react.useState)(formatOrgName(field.value || field.initialValue) || []),
      orgValue = _useState2[0],
      setOrgValue = _useState2[1];

  var maxItems = props.maxItems;
  (0, _react2.useFormEffects)(function () {
    (0, _core.onFieldValueChange)(field.props.name, function (field) {
      setOrgValue(formatOrgName(field.value));
    });
  });
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_antd.Select, {
    onDropdownVisibleChange: function onDropdownVisibleChange(open) {
      open && setVisible(open);
    },
    dropdownStyle: {
      display: 'none'
    },
    labelInValue: true,
    value: (0, _index2.formatOptionsList)(orgValue, fieldNames),
    onChange: function onChange(v) {
      field.setValue((0, _index2.formatDataList)(v, fieldNames));
    },
    dropdownRender: function dropdownRender() {
      return null;
    },
    disabled: field.disabled,
    options: (0, _index2.formatOptionsList)(orgValue, fieldNames),
    mode: maxItems !== 1 ? 'multiple' : null // defaultValue={field.initialValue}
    // open={false}

  }), /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({}, props, {
    getDataSource: getOrgList,
    visible: visible,
    onCancel: function onCancel() {
      setVisible(false);
    },
    defaultValue: field.initialValue,
    value: formatOrgName(field.value),
    onOk: function onOk(data) {
      var _data;

      if (data === void 0) {
        data = [];
      }

      var value = (_data = data) === null || _data === void 0 ? void 0 : _data.map(function (item) {
        var _ref2;

        return _ref2 = {}, _ref2[fieldNames.label] = item[fieldNames.label], _ref2[fieldNames.value] = item[fieldNames.value], _ref2;
      });
      setOrgValue(value);
      field.setValue(value);
      setVisible(false);
    }
  })));
};

var _default = YOrgSelector;
exports["default"] = _default;