"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.DebounceSelect = DebounceSelect;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _antd2 = require("@formily/antd");

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _react2 = require("@formily/react");

var _index = require("../../utils/index");

var _excluded = ["fetchOptions", "debounceTimeout"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function DebounceSelect(_ref) {
  var fetchOptions = _ref.fetchOptions,
      _ref$debounceTimeout = _ref.debounceTimeout,
      debounceTimeout = _ref$debounceTimeout === void 0 ? 800 : _ref$debounceTimeout,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  var _useState = (0, _react.useState)(false),
      fetching = _useState[0],
      setFetching = _useState[1];

  var _useState2 = (0, _react.useState)([]),
      options = _useState2[0],
      setOptions = _useState2[1];

  var fetchRef = (0, _react.useRef)(0);
  var debounceFetcher = (0, _react.useMemo)(function () {
    var loadOptions = function loadOptions(value) {
      if (value === void 0) {
        value = '';
      }

      props.onKeywordChange && props.onKeywordChange(value);
      fetchRef.current += 1;
      var fetchId = fetchRef.current;
      setOptions([]);
      setFetching(true);
      fetchOptions(value.trim()).then(function (newOptions) {
        if (fetchId !== fetchRef.current) {
          // for fetch callback order
          return;
        }

        setOptions((0, _index.formatOptionsList)(newOptions, props.fieldNames) || []);
        setFetching(false);
      });
    };

    props.focusSearch && loadOptions('');
    return (0, _debounce["default"])(loadOptions, debounceTimeout);
  }, [fetchOptions, debounceTimeout]);
  return /*#__PURE__*/_react["default"].createElement(_antd.Select, (0, _extends2["default"])({
    filterOption: false,
    onSearch: debounceFetcher,
    showSearch: true,
    showArrow: true,
    notFoundContent: fetching ? /*#__PURE__*/_react["default"].createElement(_antd.Spin, {
      size: "small"
    }) : null,
    ref: function ref(el) {
      el && props.selectRef && props.selectRef({
        current: el
      });
    }
  }, props, {
    options: options
  }));
}

var YSearchSelect = function YSearchSelect(props) {
  var field = (0, _react2.useField)();
  var form = (0, _react2.useParentForm)();
  var schema = (0, _react2.useFieldSchema)();
  var comProps = schema['x-component-props'] || {}; // const [value, setValue] = useState<UserValue[] | UserValue | null>(
  //   field.initialValue || (comProps.mode ? [] : null),
  // );

  return (// <FormProvider form={form as Form}>
    field.editable ? /*#__PURE__*/_react["default"].createElement(DebounceSelect, (0, _extends2["default"])({
      style: {
        width: '100%'
      },
      onChange: function onChange(newValue) {
        field.setValue(newValue);
        field.validate();
      }
    }, comProps, {
      value: field.value,
      defaultValue: field.initialValue,
      disabled: field.disabled,
      fetchOptions: comProps.getDataSource
    })) : /*#__PURE__*/_react["default"].createElement(_antd2.PreviewText.Select, {
      labelInValue: true,
      mode: props.mode,
      value: field.value,
      options: field.value
    }) // </FormProvider>

  );
};

var _default = YSearchSelect;
exports["default"] = _default;