'use strict';

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === 'function') for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

exports.__esModule = true;

var react_1 = require('react');

var antd_1 = require('@formily/antd');

var react_2 = require('@formily/react');

var SchemaField = react_2.createSchemaField({
  components: {
    FormItem: antd_1.FormItem,
    Editable: antd_1.Editable,
    Input: antd_1.Input,
    ArrayTable: antd_1.ArrayTable,
    FormLayout: antd_1.FormLayout,
    NumberPicker: antd_1.NumberPicker,
    Select: antd_1.Select,
    RadioGroup: antd_1.Radio.Group
  }
});

var getArrayTableSchema = function getArrayTableSchema(_a) {
  var _b;

  var sortable = _a.sortable,
      minRow = _a.minRow,
      name = _a.name,
      arrayConfig = _a.arrayConfig,
      dataSource = _a.dataSource,
      editable = _a.editable;
  var records = {};
  arrayConfig.forEach(function (item, idx) {
    var _a;

    records['NO_FIELD_NAME_' + item.name + '_' + idx] = {
      type: 'void',
      'x-component': 'ArrayTable.Column',
      'x-component-props': {
        title: item.title,
        align: 'left'
      },
      properties: (_a = {}, _a[item.name] = __assign(__assign({}, item), {
        title: '',
        "default": '',
        'x-disabled': item.disabled,
        'x-decorator': item.editable ? 'Editable' : 'FormItem',
        'x-component': item.component,
        'x-validator': item.rules,
        'x-decorator-props': {},
        'x-component-props': __assign(__assign({}, item.componentProps), {
          required: true
        })
      }), _a)
    };
  });
  return {
    type: 'void',
    properties: (_b = {}, _b[name] = {
      type: 'array',
      "default": dataSource,
      'x-read-pretty': !editable,
      'x-decorator': 'FormItem',
      'x-component': 'ArrayTable',
      'x-component-props': {
        pagination: {
          pageSize: 10
        },
        align: 'center',
        bordered: false
      },
      items: {
        type: 'object',
        properties: __assign(__assign({
          column1: {
            type: 'void',
            'x-visible': sortable || false,
            'x-component': 'ArrayTable.Column',
            'x-component-props': {
              title: 'Sort',
              align: 'center'
            },
            properties: {
              sort: {
                type: 'void',
                'x-component': 'ArrayTable.SortHandle'
              }
            }
          }
        }, records), {
          column6: {
            type: 'void',
            'x-component': 'ArrayTable.Column',
            'x-component-props': {
              title: '',
              dataIndex: 'operations',
              width: 100,
              fixed: 'right'
            },
            properties: {
              item: {
                type: 'void',
                'x-component': 'FormItem',
                properties: {
                  remove: {
                    type: 'void',
                    'x-component': 'ArrayTable.Remove'
                  },
                  moveDown: {
                    type: 'void',
                    'x-component': 'ArrayTable.MoveDown'
                  },
                  moveUp: {
                    type: 'void',
                    'x-component': 'ArrayTable.MoveUp'
                  }
                }
              }
            }
          }
        })
      },
      properties: {
        add: {
          type: 'void',
          'x-component': 'ArrayTable.Addition',
          title: '增加',
          'x-visible': true,
          'x-reactions': {
            dependencies: [name],
            fulfill: {
              schema: {
                'x-visible': '{{ hasAdd && $deps[0]?.length < maxRow}}'
              }
            }
          }
        }
      }
    }, _b)
  };
};

var YArrayTable = function YArrayTable(_a) {
  var _b, _c;

  var sortable = _a.sortable,
      layoutProps = _a.layoutProps,
      _d = _a.hasAdd,
      hasAdd = _d === void 0 ? true : _d,
      _e = _a.maxRow,
      maxRow = _e === void 0 ? 3 : _e,
      _f = _a.minRow,
      minRow = _f === void 0 ? 0 : _f,
      _g = _a.arrayConfig,
      arrayConfig = _g === void 0 ? [] : _g,
      editable = _a.editable,
      props = __rest(_a, ['sortable', 'layoutProps', 'hasAdd', 'maxRow', 'minRow', 'arrayConfig', 'editable']);

  var arrayField = react_2.useField();
  var form = react_2.useParentForm();
  var dataSource = ((_b = arrayField === null || arrayField === void 0 ? void 0 : arrayField.value) === null || _b === void 0 ? void 0 : _b.slice()) || [];
  var schema = getArrayTableSchema({
    sortable: sortable,
    arrayConfig: arrayConfig,
    minRow: minRow,
    name: (_c = arrayField === null || arrayField === void 0 ? void 0 : arrayField.props) === null || _c === void 0 ? void 0 : _c.name,
    dataSource: dataSource,
    editable: editable
  });
  return react_1['default'].createElement(react_2.FormProvider, {
    form: form
  }, react_1['default'].createElement(SchemaField, {
    schema: schema,
    scope: {
      maxRow: maxRow,
      hasAdd: hasAdd
    }
  }));
};

exports['default'] = react_2.observer(YArrayTable);