'use strict';

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === 'function') for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

exports.__esModule = true;
exports.DateTimeRangePicker = exports.MonthRangePicker = exports.DateRangePicker = exports.WeekRangePicker = exports.WeekPicker = exports.MonthPicker = exports.DateTimePicker = exports.DatePicker = void 0;

var react_1 = require('react');

var antd_1 = require('@formily/antd');

var zh_CN_1 = require('antd/es/date-picker/locale/zh_CN');

var core_1 = require('@formily/core');

var moment_1 = require('moment');

require('moment/locale/zh-cn');

var react_2 = require('@formily/react');

moment_1['default'].locale('zh-cn', {
  week: {
    dow: 1
  }
});
var RangePicker = antd_1.DatePicker.RangePicker;
var common = {
  locale: zh_CN_1['default']
};
var RANGES = {
  昨天: [moment_1['default']().subtract(1, 'days'), moment_1['default']()],
  今天: [moment_1['default'](), moment_1['default']()],
  '7天': [moment_1['default']().subtract(6, 'days'), moment_1['default']()],
  '15天': [moment_1['default']().subtract(15, 'days'), moment_1['default']().endOf('month')],
  '30天': [moment_1['default']().subtract(30, 'days'), moment_1['default']().endOf('month')]
};

var formatProps = function formatProps(props) {
  return __assign(__assign(__assign({}, common), {
    allowClear: true
  }), props);
};

var formatRangeProps = function formatRangeProps(props) {
  return __assign(__assign(__assign({}, common), {
    allowClear: true
  }), props);
}; // 日期选择


exports.DatePicker = function (props) {
  var _props = formatProps(__assign(__assign({}, props), {
    picker: 'date'
  }));

  var field = react_2.useField();

  var _a = react_1.useState(core_1.isArrayField(field) ? props.value[0] || '' : props.value || ''),
      value = _a[0],
      setValue = _a[1];

  return react_1['default'].createElement(antd_1.DatePicker, __assign({
    format: 'YYYY-MM-DD'
  }, _props, {
    value: value,
    onChange: function onChange(date) {
      core_1.isArrayField(field) ? field.setValue([date + ' 00:00:00', date + ' 23:59:59']) : field.setValue(date);
      setValue(date);
    }
  }));
}; // 日期时间选择


exports.DateTimePicker = function (props) {
  var _props = formatProps(__assign(__assign({}, props), {
    picker: 'date',
    showTime: {
      hideDisabledOptions: true,
      defaultValue: props.defaultTime ? moment_1['default'](props.defaultTime, 'HH:mm:ss') : moment_1['default']('00:00:00', 'HH:mm:ss')
    }
  }));

  var field = react_2.useField();

  var _a = react_1.useState(core_1.isArrayField(field) ? props.value[0] || '' : props.value || ''),
      value = _a[0],
      setValue = _a[1];

  return react_1['default'].createElement(antd_1.DatePicker, __assign({
    format: 'YYYY-MM-DD HH:mm:ss'
  }, _props, {
    value: value,
    onChange: function onChange(date) {
      setValue(date);
      core_1.isArrayField(field) ? field.setValue([date, date]) : field.setValue(date);
    }
  }));
}; // 月选择


exports.MonthPicker = function (props) {
  var _props = formatProps(__assign(__assign({}, props), {
    picker: 'month'
  }));

  var field = react_2.useField();

  var _a = react_1.useState(core_1.isArrayField(field) ? props.value[0] || '' : props.value || ''),
      value = _a[0],
      setValue = _a[1];

  return react_1['default'].createElement(antd_1.DatePicker, __assign({}, _props, {
    value: value,
    onChange: function onChange(date) {
      setValue(date);
      core_1.isArrayField(field) ? field.setValue([moment_1['default'](date, 'YYYY-MM').startOf('month').format('YYYY-MM-DD'), moment_1['default'](date, 'YYYY-MM').endOf('month').format('YYYY-MM-DD')]) : field.setValue(date);
    }
  }));
};

exports.WeekPicker = function (props) {
  var _props = formatProps(__assign(__assign({}, props), {
    picker: 'week'
  }));

  var field = react_2.useField();

  var _a = react_1.useState(core_1.isArrayField(field) ? props.value[0] || '' : props.value || ''),
      value = _a[0],
      setValue = _a[1];

  return react_1['default'].createElement(antd_1.DatePicker, __assign({}, _props, {
    value: value,
    onChange: function onChange(date) {
      setValue(date);
      field.setValue([moment_1['default'](date, 'YYYY-ww').startOf('week').format('YYYY-MM-DD'), moment_1['default'](date, 'YYYY-ww').endOf('week').format('YYYY-MM-DD')]);
    }
  }));
}; // range


exports.WeekRangePicker = function (props) {
  var _props = formatRangeProps(__assign(__assign({}, props), {
    picker: 'week'
  }));

  var field = react_2.useField();

  var formatWeek = function formatWeek(date) {
    if (date === void 0) {
      date = [];
    }

    if (!(date === null || date === void 0 ? void 0 : date.length)) return [];
    return [moment_1['default'](props.value[0], 'YYYY-MM-DD').format('YYYY-wo'), moment_1['default'](props.value[1], 'YYYY-MM-DD').format('YYYY-wo')];
  };

  var _a = react_1.useState(formatWeek(props.value)),
      value = _a[0],
      setValue = _a[1];

  return react_1['default'].createElement(RangePicker, __assign({
    separator: '-'
  }, _props, {
    value: value,
    onChange: function onChange(date) {
      setValue(date);
      field.setValue([moment_1['default'](date[0], 'YYYY-ww').startOf('week').format('YYYY-MM-DD'), moment_1['default'](date[1], 'YYYY-ww').endOf('week').format('YYYY-MM-DD')]);
    }
  }));
};

exports.DateRangePicker = function (_a) {
  var ranges = _a.ranges,
      props = __rest(_a, ['ranges']);

  var _ranges = Array.isArray(ranges) ? ranges.reduce(function (curr, prev) {
    if (!RANGES[prev]) {
      return curr;
    }

    curr[prev] = RANGES[prev];
    return curr;
  }, {}) : ranges || {};

  var _props = formatRangeProps(__assign(__assign({}, props), {
    ranges: _ranges,
    picker: 'date'
  }));

  return react_1['default'].createElement(RangePicker, __assign({
    separator: '-'
  }, _props));
};

exports.MonthRangePicker = function (props) {
  var _a;

  var _props = formatRangeProps(__assign(__assign({}, props), {
    picker: 'month'
  }));

  var field = react_2.useField();

  var _initValue = ((_a = props.value) === null || _a === void 0 ? void 0 : _a.length) > 0 ? [moment_1['default'](props.value[0]).startOf('month').format('YYYY-MM'), moment_1['default'](props.value[1]).startOf('month').format('YYYY-MM')] : [];

  var _b = react_1.useState(_initValue),
      value = _b[0],
      setValue = _b[1];

  return react_1['default'].createElement(RangePicker, __assign({
    separator: '-'
  }, _props, {
    value: value,
    onChange: function onChange(date) {
      setValue(date);
      field.setValue([moment_1['default'](date[0]).startOf('month').format('YYYY-MM-DD'), moment_1['default'](date[1]).endOf('month').format('YYYY-MM-DD')]);
    }
  }));
};

exports.DateTimeRangePicker = function (props) {
  var _a;

  var _props = formatRangeProps(__assign(__assign({}, props), {
    picker: 'date',
    showTime: {
      hideDisabledOptions: true,
      defaultValue: ((_a = props.defaultTime) === null || _a === void 0 ? void 0 : _a.length) > 0 ? [moment_1['default'](props.defaultTime[0], 'HH:mm:ss'), moment_1['default'](props.defaultTime[1], 'HH:mm:ss')] : [moment_1['default']('00:00:00', 'HH:mm:ss'), moment_1['default']('23:59:59', 'HH:mm:ss')]
    }
  }));

  return react_1['default'].createElement(RangePicker, __assign({
    format: 'YYYY-MM-DD HH:mm:ss',
    separator: '-'
  }, _props));
};