"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.SchemaField = void 0;
exports.YwJsonForm = YwJsonForm;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _core = require("@formily/core");

var _antd = require("@formily/antd");

var _jsonLogicJs = _interopRequireDefault(require("json-logic-js"));

var _utils = require("../../utils");

var _react2 = require("@formily/react");

var _YwTitle = _interopRequireDefault(require("../YwTitle"));

var _hook = require("./hook");

var _rules = require("./rules");

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var COMPS = _interopRequireWildcard(require("./components"));

var _excluded = ["CustomComponent"],
    _excluded2 = ["buttons", "onCreate", "onSubmit", "editable", "disabled", "size", "layoutProps", "buttonsProps", "items", "initialValues", "onValueChange", "linkages"],
    _excluded3 = ["type", "conditions", "target"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var dataSource = {};
(0, _core.registerValidateFormats)(_rules.FORMATS);
(0, _core.registerValidateRules)(_rules.RULES);

var customComponent = function customComponent(props) {
  var field = (0, _react2.useField)();
  var schema = (0, _react2.useFieldSchema)();

  var _ref = schema['x-component-props'] || {},
      CustomComponent = _ref.CustomComponent,
      rest = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  return CustomComponent && /*#__PURE__*/_react["default"].createElement(CustomComponent, (0, _extends2["default"])({}, rest, {
    field: field
  }));
};

var SchemaField = (0, _react2.createSchemaField)({
  components: (0, _extends2["default"])({}, COMPS)
});
exports.SchemaField = SchemaField;

var formatSchema = function formatSchema(item) {
  var _item$componentProps, _item$componentProps2, _item$componentProps3, _item$componentProps4;

  if (item === void 0) {
    item = {};
  }

  // if (item.customComponent) {
  //   customComponent = [...customComponent, item.customComponent];
  // }
  var options = item["enum"] || (0, _utils.formatOptionsList)((_item$componentProps = item.componentProps) === null || _item$componentProps === void 0 ? void 0 : _item$componentProps.dataSource, (_item$componentProps2 = item.componentProps) === null || _item$componentProps2 === void 0 ? void 0 : _item$componentProps2.fieldNames) || (0, _utils.formatOptionsList)((_item$componentProps3 = item.componentProps) === null || _item$componentProps3 === void 0 ? void 0 : _item$componentProps3.dict, {
    label: 'dictName',
    value: 'dictValue'
  });

  if (item.getDataSource) {
    dataSource[item.name] = item.getDataSource;
  }

  return (0, _extends2["default"])({
    type: item.type || 'string',
    title: item.title,
    description: item.description,
    "default": item.defaultValue,
    readOnly: item.readOnly,
    "enum": options,
    required: item.required,
    'x-validator': item.rules,
    'x-decorator': item.decorator || 'FormItem',
    'x-decorator-props': (0, _extends2["default"])({}, item.props, {
      colon: false
    }),
    'x-reactions': item.reactions
  }, item.getDataSource ? {
    'x-reactions': ['{{useAsyncDataSource(dataSource)}}']
  } : {}, (_item$componentProps4 = item.componentProps) !== null && _item$componentProps4 !== void 0 && _item$componentProps4.getDataSource && item.component !== 'SearchSelect' ? {
    'x-reactions': ['{{useAsyncDataSource()}}']
  } : {}, {
    'x-component': item.customComponent ? customComponent : item.component,
    'x-component-props': (0, _extends2["default"])({
      allowClear: !item.required
    }, item.componentProps, item.customComponent ? {
      CustomComponent: item.customComponent
    } : {}),
    'x-visible': item.visible,
    'x-disabled': item.disabled,
    'x-read-pretty': item.preview
  });
};

function YwJsonForm(props) {
  var buttons = props.buttons,
      onCreate = props.onCreate,
      onSubmit = props.onSubmit,
      editable = props.editable,
      disabled = props.disabled,
      size = props.size,
      layoutProps = props.layoutProps,
      buttonsProps = props.buttonsProps,
      items = props.items,
      initialValues = props.initialValues,
      onValueChange = props.onValueChange,
      linkages = props.linkages,
      others = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded2);
  var form = props.form || (0, _react.useMemo)(function () {
    return (0, _core.createForm)({
      disabled: disabled,
      editable: editable,
      effects: function effects(form) {
        (0, _core.onFormInit)(function () {
          onCreate(form);
        });
        (0, _core.onFormValuesChange)(function (value) {
          onValueChange(form.values, form);
        });
      }
    });
  }, []);

  var FormGroup = function FormGroup(props) {
    var field = (0, _react2.useField)();
    return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_YwTitle["default"], (0, _extends2["default"])({
      size: props.size,
      text: props.text
    }, field.componentProps)), /*#__PURE__*/_react["default"].createElement(_antd.FormLayout, (0, _extends2["default"])({}, layoutProps, {
      size: size === 'middle' ? 'default' : size,
      style: {
        marginTop: '20px'
      }
    }), props.children));
  };

  var getItemsSchema = function getItemsSchema() {
    var formatItem = function formatItem(nodeList) {
      if (nodeList.length === 0) {
        return null;
      }

      var res = {};
      nodeList.forEach(function (item, idx) {
        if (item.component === 'FormGroup') {
          // 分组标题
          res["NO_FIELD_NAME_" + idx] = (0, _extends2["default"])({
            type: 'void',
            'x-component': FormGroup,
            'x-decorator': 'FormItem',
            'x-visible': item.visible,
            'x-component-props': (0, _extends2["default"])({
              size: size === 'small' ? 's' : 'm',
              text: item.title
            }, item.componentProps || {})
          }, item.children ? formatItem(item.children) : {});
        } else if (item.component === 'FormGrid') {
          // grid
          res["NO_FIELD_NAME_" + idx] = (0, _extends2["default"])({}, formatSchema(item), {
            type: 'void'
          }, item.children ? formatItem(item.children) : {});
        } else if (['ArrayTable', 'ArrayItems'].includes(item.component)) {
          // ArrayTable
          res["NO_FIELD_NAME_" + idx] = (0, _extends2["default"])({}, formatSchema(item), {
            type: 'array',
            'x-component-props': (0, _extends2["default"])({}, item.componentProps, {
              name: item.name,
              layoutProps: layoutProps,
              arrayConfig: item.children
            }),
            'x-decorator-props': (0, _extends2["default"])({}, formatSchema(item)['x-decorator-props'])
          }); // } else if (item.component === 'ArrayItems') {
          //   // ArrayTable
          //   res[`NO_FIELD_NAME_${idx}`] = {
          //     ...formatSchema(item),
          //     type: 'array',
          //     'x-component-props': {
          //       ...item.componentProps,
          //       name: item.name,
          //       layoutProps,
          //       arrayConfig: item.children,
          //     },
          //   };
        } else {
          res[item.name || "NO_FIELD_NAME_" + idx] = (0, _extends2["default"])({}, formatSchema(item), item.children ? formatItem(item.children) : {});
        }
      });
      return {
        properties: res
      };
    };

    return formatItem(items || []);
  };

  var renderButtons = function renderButtons() {
    return buttons !== null && buttons !== void 0 && buttons.length ? /*#__PURE__*/_react["default"].createElement(_antd.FormButtonGroup.FormItem, null, buttons === null || buttons === void 0 ? void 0 : buttons.map(function (btn) {
      var _component = {
        submit: /*#__PURE__*/_react["default"].createElement(_antd.Submit, {
          key: "submit",
          onSubmit: onSubmit,
          size: size
        }, "\u63D0\u4EA4"),
        reset: /*#__PURE__*/_react["default"].createElement(_antd.Reset, {
          key: "reset",
          size: size
        }, "\u91CD\u7F6E"),
        button: btn.children
      };
      return _component[btn.htmlType];
    })) : null;
  };

  var valueChangeforLink = function valueChangeforLink(linkages) {
    if (linkages === void 0) {
      linkages = [];
    }

    var isExecute = function isExecute(conditions, field, form) {
      if (conditions === void 0) {
        conditions = [];
      }

      if ((0, _utils.isObject)(conditions)) {
        return _jsonLogicJs["default"].apply(conditions, form.getValuesIn());
      } else if (!conditions.length) {
        return true;
      } else {
        return conditions.every(function (_ref2) {
          var key = _ref2.key,
              value = _ref2.value;
          return field.query(key).value() === value;
        });
      }
    };

    linkages.forEach(function (_ref3, idx) {
      var type = _ref3.type,
          conditions = _ref3.conditions,
          target = _ref3.target,
          rest = (0, _objectWithoutPropertiesLoose2["default"])(_ref3, _excluded3);

      if (type === 'value') {
        form.addEffects(type + "-" + target + "-" + idx, function (form) {
          (0, _core.onFieldReact)(target, function (field) {
            if (isExecute(conditions, field, form)) {
              field.setValue(rest.targetValue);
            } else {
              field.setValue(field.initialValue);
            }
          });
        });
      } else if (type === 'disabled') {
        form.addEffects(type + "-" + target + "-" + idx, function (form) {
          (0, _core.onFieldReact)(target, function (field) {
            if (isExecute(conditions, field, form)) {
              field.setState({
                disabled: rest.targetValue
              });
            } else {
              field.setState({
                disabled: !rest.targetValue
              });
            }
          });
        });
      } else if (type === 'visible') {
        form.addEffects(type + "-" + target + "-" + idx, function (form) {
          (0, _core.onFieldReact)(target, function (field) {
            if (isExecute(conditions, field, form)) {
              field.setState({
                visible: rest.targetValue
              });
            } else {
              field.setState({
                visible: !rest.targetValue
              });
            }
          });
        });
      } else if (type === 'enum') {
        form.addEffects(type + "-" + target + "-" + idx, function (form) {
          (0, _core.onFieldReact)(target, function (field) {
            if (isExecute(conditions, field, form)) {
              field.setState({
                dataSource: rest.targetValue
              });
              field.setValue('');
            } else {
              field.setState({
                dataSource: field.dataSource
              });
            }
          });
        });
      }
    });
  };

  (0, _react.useEffect)(function () {
    linkages && valueChangeforLink(linkages);
  }, []);
  (0, _react.useEffect)(function () {
    initialValues && form.setValues(initialValues);
  }, [initialValues]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['yw-json-form'],
    style: props.style
  }, /*#__PURE__*/_react["default"].createElement(_react2.FormProvider, {
    form: form
  }, /*#__PURE__*/_react["default"].createElement(_antd.PreviewText.Placeholder, {
    value: "\u6682\u65E0\u6570\u636E"
  }, /*#__PURE__*/_react["default"].createElement(_antd.FormLayout, (0, _extends2["default"])({}, layoutProps, {
    size: size === 'middle' ? 'default' : size
  }), /*#__PURE__*/_react["default"].createElement(SchemaField, {
    schema: getItemsSchema(),
    scope: {
      useAsyncDataSource: _hook.useAsyncDataSource,
      dataSource: dataSource
    }
  }), buttonsProps.sticky ? /*#__PURE__*/_react["default"].createElement(_antd.FormButtonGroup.Sticky, {
    align: buttonsProps.align
  }, renderButtons()) : renderButtons()))));
}

YwJsonForm.defaultProps = {
  form: null,
  layoutProps: {
    // labelAlign: 'right',
    fullness: false,
    labelCol: 6,
    wrapperCol: 10 // inset: true,
    // inline: true,
    // layout:['vertical', 'horizontal','inline'],

  },
  buttons: [{
    htmlType: 'submit'
  }, {
    htmlType: 'reset'
  }],
  buttonsProps: {},
  onSubmit: function onSubmit(form) {
    console.log('submit', form);
  },
  onCreate: function onCreate(form) {// console.log('表单初始化', form)
    // form.setInitialValues({ input: 123333 })
  },
  onValueChange: function onValueChange(data, form) {// form.setInitialValues({ input: 123333 });
  }
}; // YwJsonForm.displayName = 'YwJsonForm';