"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = YwNotice;

var _react = _interopRequireWildcard(require("react"));

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _antd = require("antd");

var _index = require("../../utils/index");

var _icons = require("@ant-design/icons");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function YwNotice(props) {
  var type = props.type,
      className = props.className,
      style = props.style,
      title = props.title,
      content = props.content,
      icon = props.icon,
      closeable = props.closeable,
      btnText = props.btnText,
      onClick = props.onClick;

  var _useState = (0, _react.useState)(true),
      visible = _useState[0],
      setVisible = _useState[1];

  var isInline = (0, _react.useMemo)(function () {
    return title && !content;
  }, [title, content]);
  var isNormal = (0, _react.useMemo)(function () {
    return title && content && !(0, _index.isArray)(content);
  }, [title, content]);
  var isMultiple = (0, _react.useMemo)(function () {
    return !title && (0, _index.isArray)(content);
  }, [title, content]);

  var renderInline = function renderInline() {
    if (!visible) return null;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]["yw-notice"] + " " + _indexModule["default"]["yw-notice-" + type] + " " + _indexModule["default"]["yw-notice-inline"] + " " + className,
      style: style
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]["yw-notice-container"]
    }, /*#__PURE__*/_react["default"].createElement("i", {
      className: _indexModule["default"]['yw-notice-icon']
    }, icon || _index.StatusTypeIcon[type]), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]['yw-notice-title']
    }, title))), renderButton(), renderCloseIcon());
  };

  var renderNormal = function renderNormal() {
    if (!visible) return null;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]["yw-notice"] + " " + _indexModule["default"]["yw-notice-" + type] + " " + className,
      style: style
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]["yw-notice-container"]
    }, /*#__PURE__*/_react["default"].createElement("i", {
      className: _indexModule["default"]['yw-notice-icon']
    }, icon || _index.StatusTypeIcon[type]), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]['yw-notice-title']
    }, title), /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]['yw-notice-content']
    }, content))), renderButton(), renderCloseIcon());
  };

  var renderMultiple = function renderMultiple() {
    if (!visible) return null;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]["yw-notice"] + " " + _indexModule["default"]["yw-notice-" + type] + " " + className,
      style: style
    }, /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        flex: 1
      }
    }, content.map(function (v) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        key: v,
        className: _indexModule["default"]['yw-notice-line']
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: _indexModule["default"]['yw-notice-icon']
      }, icon || _index.StatusTypeIcon[type]), /*#__PURE__*/_react["default"].createElement("div", {
        key: v,
        className: _indexModule["default"]['yw-notice-content']
      }, v));
    })), renderButton(), renderCloseIcon());
  };

  var renderCloseIcon = function renderCloseIcon() {
    return closeable && /*#__PURE__*/_react["default"].createElement(_icons.CloseOutlined, {
      style: {
        fontSize: '12px',
        color: '#ccc',
        marginLeft: '12px'
      },
      onClick: function onClick() {
        setVisible(false);
        onClose();
      }
    });
  };

  var renderButton = function renderButton() {
    if (!btnText) return null;
    return /*#__PURE__*/_react["default"].createElement(_antd.Button, {
      size: "small",
      type: "link",
      className: _indexModule["default"]['yw-notice-btn'],
      onClick: onClick
    }, btnText);
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, isInline && renderInline(), isNormal && renderNormal(), isMultiple && renderMultiple());
}

YwNotice.defaultProps = {
  type: 'notice',
  icon: null,
  content: '',
  title: '',
  closeable: false,
  btnText: '',
  onClick: function onClick() {},
  onClose: function onClose() {}
};