"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _indexModule2 = _interopRequireDefault(require("../common/index.module.less"));

var _lodash = require("lodash");

var _antd = require("antd");

var _modalSelector = _interopRequireDefault(require("../common/modalSelector"));

var _index = require("../../utils/index");

var _excluded = ["getDataSource", "visible"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var YwOrgSelector = function YwOrgSelector(_ref) {
  var _currentOrg$children, _currentOrg$children2;

  var getDataSource = _ref.getDataSource,
      visible = _ref.visible,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  // 部门树结构
  var _useState = (0, _react.useState)([]),
      orgTreeList = _useState[0],
      setOrgTreeList = _useState[1]; // 部门路径


  var _useState2 = (0, _react.useState)([]),
      orgPathList = _useState2[0],
      setOrgPathList = _useState2[1]; // 默认值


  var defaultValue = (0, _react.useMemo)(function () {
    return (0, _index.formatOptionsList)(props.defaultValue, props.fieldNames);
  }, [props.defaultValue, props.fieldNames]); // 受控值

  var value = (0, _react.useMemo)(function () {
    if (!props.value) return null;
    return (0, _index.formatOptionsList)(props.value, props.fieldNames);
  }, [props.fieldNames, props.value]); // select组件回显部门数据

  var _useState3 = (0, _react.useState)(defaultValue),
      selectValue = _useState3[0],
      setSelectValue = _useState3[1];

  (0, _react.useEffect)(function () {
    value && setSelectValue(value);
  }, [value]); // 选中部门id

  var selectIds = (0, _react.useMemo)(function () {
    return (selectValue === null || selectValue === void 0 ? void 0 : selectValue.map(function (v) {
      return v.value;
    })) || [];
  }, [selectValue]); // 当前节点

  var currentOrg = (0, _react.useMemo)(function () {
    return (0, _lodash.get)(orgTreeList, (0, _lodash.last)(orgPathList));
  }, [orgPathList, orgTreeList]); // 当前path

  var orgPath = (0, _react.useMemo)(function () {
    return (0, _lodash.last)(orgPathList);
  }, [orgPathList]); // 是否全选

  var isAll = (0, _react.useMemo)(function () {
    return (0, _lodash.every)(currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children, function (_ref2) {
      var value = _ref2.value;
      return selectIds.includes(value);
    });
  }, [selectIds, currentOrg]);

  var onCheckAllChange = function onCheckAllChange(e) {
    if (e.target.checked) {
      setSelectValue((0, _lodash.unionBy)(selectValue, currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children, 'value'));
    } else {
      setSelectValue([].concat((0, _lodash.pullAllBy)(selectValue, currentOrg === null || currentOrg === void 0 ? void 0 : currentOrg.children, 'value')));
    }
  };

  (0, _react.useEffect)(function () {
    if (visible) {
      setOrgPathList(['[0]']);

      if (orgTreeList !== null && orgTreeList !== void 0 && orgTreeList.length) {
        return;
      }

      getDataSource().then(function (data) {
        var res = (0, _index.formatOptionsList)(data, props.fieldNames);
        var _orgTreeList = res;
        setOrgTreeList(_orgTreeList);
      });
    }
  }, [visible]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['yw-org-selector']
  }, /*#__PURE__*/_react["default"].createElement(_modalSelector["default"], (0, _extends2["default"])({}, props, {
    visible: visible,
    labelInValue: true,
    autoFocus: false,
    showSearch: false,
    value: selectValue,
    placeholder: "\u8BF7\u9009\u62E9",
    onChange: function onChange(nextValue) {
      setSelectValue(nextValue);
    }
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule2["default"]['title'],
    onClick: function onClick() {
      setOrgPathList(['[0]']);
    }
  }, /*#__PURE__*/_react["default"].createElement("span", null, "\u676D\u5DDE\u9065\u671B\u79D1\u6280\u6709\u9650\u516C\u53F8")), orgPathList && /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule2["default"]['dept-list']
  }, /*#__PURE__*/_react["default"].createElement(_antd.Breadcrumb, null, orgPathList.map(function (v, i) {
    // if (i === 0) return;
    return /*#__PURE__*/_react["default"].createElement(_antd.Breadcrumb.Item, {
      className: _indexModule2["default"]['dept-list-path-item'],
      onClick: function onClick() {
        setOrgPathList(orgPathList.slice(0, i + 1));
      }
    }, (0, _lodash.get)(orgTreeList, v + ".label"));
  }))), !!(currentOrg !== null && currentOrg !== void 0 && (_currentOrg$children = currentOrg.children) !== null && _currentOrg$children !== void 0 && _currentOrg$children.length) && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_antd.Row, {
    style: {
      paddingLeft: '20px',
      height: '38px'
    }
  }, /*#__PURE__*/_react["default"].createElement(_antd.Col, null, /*#__PURE__*/_react["default"].createElement(_antd.Checkbox // indeterminate={
  //   !isAll && some(currentOrg.children, ({ value }) => selectIds.includes(value))
  // }
  , {
    onChange: onCheckAllChange,
    checked: isAll
  }, "\u5168\u9009"))), currentOrg === null || currentOrg === void 0 ? void 0 : (_currentOrg$children2 = currentOrg.children) === null || _currentOrg$children2 === void 0 ? void 0 : _currentOrg$children2.map(function (v, i) {
    return /*#__PURE__*/_react["default"].createElement(_antd.Row, {
      align: "middle",
      className: _indexModule2["default"]['item-row']
    }, /*#__PURE__*/_react["default"].createElement(_antd.Col, {
      span: 19
    }, /*#__PURE__*/_react["default"].createElement(_antd.Checkbox, {
      value: v.value,
      checked: selectIds.includes(v.value),
      disabled: v.disabled,
      onChange: function onChange(e) {
        if (e.target.checked) {
          setSelectValue((0, _lodash.uniqBy)([].concat(selectValue, [v]), 'value'));
        } else {
          setSelectValue((0, _lodash.filter)(selectValue, function (_ref3) {
            var value = _ref3.value;
            return value !== v.value;
          }));
        }
      }
    }, v.label)), /*#__PURE__*/_react["default"].createElement(_antd.Col, {
      span: 5,
      className: _indexModule2["default"]['item-row-right'],
      "data-disabled": selectIds.includes(v.value),
      onClick: function onClick() {
        if (!selectIds.includes(v.value)) {
          setOrgPathList([].concat(orgPathList, [orgPathList[orgPathList.length - 1] + ".children[" + i + "]"]));
        }
      }
    }, /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("img", {
      src: "https://yw-fed-static.oss-cn-hangzhou.aliyuncs.com/ywDesign/img/org_icon.png"
    }), /*#__PURE__*/_react["default"].createElement("span", {
      style: {
        marginLeft: '6px'
      }
    }, "\u4E0B\u7EA7"))));
  }))));
};

YwOrgSelector.defaultProps = {
  title: '请选择部门',
  fieldNames: {
    label: 'orgName',
    value: 'orgId',
    children: 'subOrgList'
  },
  defaultValue: []
};
var _default = YwOrgSelector;
exports["default"] = _default;