"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = YwTab;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _antd = require("antd");

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _excluded = ["shape", "dataSource", "type", "children", "style"];

var Count = function Count(_ref) {
  var count = _ref.count;
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: _indexModule["default"]['yw-tab-wrapped-item-count']
  }, count);
};

var renderTabTitle = function renderTabTitle(_ref2, shape) {
  var dot = _ref2.dot,
      tab = _ref2.tab,
      count = _ref2.count;
  if (shape === 'pure') return /*#__PURE__*/_react["default"].createElement(_antd.Badge, {
    count: count,
    dot: dot,
    size: "small",
    offset: [8, 0]
  }, tab);
  if (count !== undefined && shape === 'wrapped') return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, tab, " ", /*#__PURE__*/_react["default"].createElement(Count, {
    count: count
  }));
  return tab;
};

var renderWrappedTabBar = function renderWrappedTabBar(tabBarProps, DefaultTabBar) {
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['yw-tab-wrapped']
  }, /*#__PURE__*/_react["default"].createElement(DefaultTabBar, tabBarProps, function (node) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]['yw-tab-wrapped-item']
    }, node);
  }));
};

var renderCapsuleTabBar = function renderCapsuleTabBar(tabBarProps, DefaultTabBar) {
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['yw-tab-capsule']
  }, /*#__PURE__*/_react["default"].createElement(DefaultTabBar, tabBarProps, function (node) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"]['yw-tab-capsule-item']
    }, node);
  }));
};

var renderTabBar = {
  pure: null,
  wrapped: renderWrappedTabBar,
  capsule: renderCapsuleTabBar
};

function YwTab(props) {
  var shape = props.shape,
      dataSource = props.dataSource,
      type = props.type,
      children = props.children,
      style = props.style,
      others = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "" + _indexModule["default"]['yw-tab'],
    style: style
  }, /*#__PURE__*/_react["default"].createElement(_antd.Tabs, (0, _extends2["default"])({}, others, {
    renderTabBar: renderTabBar[shape],
    type: shape !== 'pure' ? 'card' : type
  }), children || (dataSource === null || dataSource === void 0 ? void 0 : dataSource.map(function (item) {
    return /*#__PURE__*/_react["default"].createElement(_antd.Tabs.TabPane, {
      key: item.key,
      tab: renderTabTitle(item, shape)
    }, item.content);
  }))));
}

YwTab.defaultProps = {
  shape: 'pure',
  dataSource: [],
  onChange: function onChange() {}
};