"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.TagsInfo = exports.Price = exports.LongText2Ellipsis = exports.GoodTitle = exports.DetailInfo = exports.Copy = void 0;

var _react = _interopRequireDefault(require("react"));

var _indexModule = _interopRequireDefault(require("../index.module.less"));

var _antd = require("antd");

var _reactCopyToClipboard = require("react-copy-to-clipboard");

var _index = require("../../../utils/index");

var _icon = require("../../common/icon");

var preCssFix = 'yw-table-cell';

var Copy = function Copy(_ref) {
  var text = _ref.text,
      _ref$onCopy = _ref.onCopy,
      _onCopy = _ref$onCopy === void 0 ? function () {} : _ref$onCopy;

  return /*#__PURE__*/_react["default"].createElement(_reactCopyToClipboard.CopyToClipboard, {
    text: text,
    onCopy: function onCopy() {
      _antd.message.success('复制成功');

      _onCopy();
    }
  }, /*#__PURE__*/_react["default"].createElement(_icon.CopyIcon, {
    style: {
      marginLeft: '4px'
    }
  }));
};

exports.Copy = Copy;

var LongText2Ellipsis = function LongText2Ellipsis(_ref2) {
  var value = _ref2.value,
      _ref2$tooltip = _ref2.tooltip,
      tooltip = _ref2$tooltip === void 0 ? false : _ref2$tooltip,
      _ref2$isCopy = _ref2.isCopy,
      isCopy = _ref2$isCopy === void 0 ? false : _ref2$isCopy,
      _ref2$row = _ref2.row,
      row = _ref2$row === void 0 ? 2 : _ref2$row,
      children = _ref2.children,
      _onClick = _ref2.onClick,
      record = _ref2.record,
      style = _ref2.style;
  var isClick = (0, _index.isFunction)(_onClick);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    style: style,
    className: _indexModule["default"][preCssFix + "-long-text"] + " " + (isClick && _indexModule["default"][preCssFix + "-long-text-link"]),
    onClick: function onClick() {
      isClick && _onClick(record);
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]["row-" + row],
    style: {
      flex: 1
    }
  }, tooltip ? /*#__PURE__*/_react["default"].createElement(_antd.Tooltip, {
    placement: "topLeft",
    title: value
  }, children || value) : children || value), isCopy && /*#__PURE__*/_react["default"].createElement(Copy, {
    text: value
  })));
};

exports.LongText2Ellipsis = LongText2Ellipsis;

var Price = function Price(_ref3) {
  var value = _ref3.value;
  if (!value) return null;

  var PriceItem = function PriceItem(_ref4) {
    var value = _ref4.value;
    if (!value) return null;
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
      className: _indexModule["default"].rmb
    }, "\xA5"), /*#__PURE__*/_react["default"].createElement("span", {
      className: _indexModule["default"].count
    }, value));
  };

  if (Array.isArray(value)) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"][preCssFix + "-detail-info-price"]
    }, /*#__PURE__*/_react["default"].createElement(PriceItem, {
      value: value[0]
    }), /*#__PURE__*/_react["default"].createElement("span", {
      className: _indexModule["default"].line
    }, "-"), /*#__PURE__*/_react["default"].createElement(PriceItem, {
      value: value[1]
    })));
  } else {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"][preCssFix + "-detail-info-price"]
    }, /*#__PURE__*/_react["default"].createElement(PriceItem, {
      value: value
    }));
  }
};

exports.Price = Price;

var ExtraInfo = function ExtraInfo(_ref5) {
  var items = _ref5.items;
  if (!items) return null;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-detail-info-row"]
  }, items.map(function (v) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _indexModule["default"].item
    }, v.label && /*#__PURE__*/_react["default"].createElement("span", {
      style: {
        whiteSpace: 'nowrap'
      }
    }, v.label, "\uFF1A"), /*#__PURE__*/_react["default"].createElement(LongText2Ellipsis, {
      value: v.value,
      tooltip: v.tooltip,
      row: v.row,
      onClick: v.onClick,
      isCopy: v.isCopy,
      style: {
        color: '#666'
      }
    }, /*#__PURE__*/_react["default"].createElement("span", null, v.value || '-')));
  }));
};

var TagsInfo = function TagsInfo(_ref6) {
  var tags = _ref6.tags,
      record = _ref6.record;
  if (!tags) return null;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-detail-info-tags"]
  }, tags === null || tags === void 0 ? void 0 : tags.map(function (v) {
    var visible = (0, _index.isVisible)(v.visible, record);
    return visible && /*#__PURE__*/_react["default"].createElement("span", {
      className: _indexModule["default"].tag,
      key: v.value
    }, v.value);
  }));
};

exports.TagsInfo = TagsInfo;

var GoodTitle = function GoodTitle(_ref7) {
  var _ref7$title = _ref7.title,
      title = _ref7$title === void 0 ? {} : _ref7$title;
  var value = title.value,
      tooltip = title.tooltip,
      row = title.row,
      onClick = title.onClick,
      icon = title.icon;
  if (!value) return null;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"].title
  }, /*#__PURE__*/_react["default"].createElement(LongText2Ellipsis, {
    value: value,
    tooltip: tooltip,
    row: row,
    onClick: onClick,
    style: {
      color: '#666'
    }
  }));
};

exports.GoodTitle = GoodTitle;

var TitleToolTip = function TitleToolTip(_ref8) {
  var _ref8$tooltip = _ref8.tooltip,
      tooltip = _ref8$tooltip === void 0 ? {} : _ref8$tooltip;
  var value = tooltip.value,
      label = tooltip.label,
      isCopy = tooltip.isCopy;
  if (!value) return null;

  var title = /*#__PURE__*/_react["default"].createElement("div", null, label && /*#__PURE__*/_react["default"].createElement("span", null, label, "\uFF1A"), value && /*#__PURE__*/_react["default"].createElement("span", null, value), isCopy && /*#__PURE__*/_react["default"].createElement(Copy, {
    text: value
  }));

  return /*#__PURE__*/_react["default"].createElement(_antd.Tooltip, {
    placement: "top",
    title: title
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-detail-info-tooltip"]
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: _indexModule["default"]['icon-id']
  }, "ID")));
};

var DetailInfo = function DetailInfo(_ref9) {
  var _ref9$value = _ref9.value,
      value = _ref9$value === void 0 ? {} : _ref9$value,
      record = _ref9.record;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-detail-info"]
  }, /*#__PURE__*/_react["default"].createElement("div", null, value !== null && value !== void 0 && value.renderImg ? /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-detail-info-img"]
  }, value.renderImg()) : value.imgUrl && /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-detail-info-img"]
  }, /*#__PURE__*/_react["default"].createElement("img", {
    src: value.imgUrl,
    alt: ""
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"][preCssFix + "-detail-info-text"]
  }, /*#__PURE__*/_react["default"].createElement(GoodTitle, {
    title: value.title
  }), /*#__PURE__*/_react["default"].createElement(ExtraInfo, {
    items: value.items
  }), /*#__PURE__*/_react["default"].createElement(Price, {
    value: value.price
  }), /*#__PURE__*/_react["default"].createElement(TagsInfo, {
    tags: value.tags,
    record: record
  })), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(TitleToolTip, {
    tooltip: value.tooltip
  })));
};

exports.DetailInfo = DetailInfo;