'use strict';

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

exports.__esModule = true;
exports.Operates = exports.Status = exports.Time = exports.Person = exports.MultipleCol = void 0;

var React = require('react');

var index_module_less_1 = require("../index.module.less");

var antd_1 = require('antd');

var antd_2 = require('@formily/antd');

var react_1 = require('@formily/react');

var YwJsonForm_1 = require("../../../YwJsonForm"); // import { Button, Tooltip } from 'antd';
// import YwJsonForm from '../../../YwJsonForm/src/index';
// export const Tooltip = (props) => {
//     console.log('LongText', props)
//     return <Tooltip placement="topLeft" title={props}>
//     {props}
//   </Tooltip>
// }


var confirm = antd_1.Modal.confirm;

var isFunction = function isFunction(value) {
  return typeof value === 'function';
};

var preCssFix = 'yw-table-cell';

exports.MultipleCol = function (_a) {
  var value = _a.value;
  return value.map(function (_a, idx) {
    var label = _a.label,
        value = _a.value,
        children = _a.children;
    return React.createElement('div', {
      key: idx,
      style: {
        color: '#666',
        marginTop: idx !== 0 ? '12px' : 0
      }
    }, React.createElement('span', null, label), "\uFF1A", React.createElement('span', null, children || value));
  });
};

exports.Person = function (_a) {
  var value = _a.value;
  return React.createElement('div', {
    className: index_module_less_1['default'][preCssFix + '-person']
  }, React.createElement('img', {
    className: index_module_less_1['default']['avator'],
    src: value.avator,
    alt: ''
  }), React.createElement('span', null, value.name));
};

exports.Time = function (_a) {
  var value = _a.value;
  return React.createElement('div', null, value || '/');
};

exports.Status = function (_a) {
  var value = _a.value,
      _b = _a.dataSource,
      dataSource = _b === void 0 ? [] : _b;
  var target = dataSource.find(function (v) {
    return v.value === value;
  });
  var colorMap = {
    primary: '#1890FF',
    success: '#23CBB7',
    error: '#F15A5A',
    warning: '#FAAD14',
    other: '#9C7AFF',
    info: '#666'
  };
  return React.createElement('div', {
    className: index_module_less_1['default'][preCssFix + '-status']
  }, React.createElement('span', {
    className: index_module_less_1['default']['dot'],
    style: {
      background: colorMap[target.color] || target.color
    }
  }), target.value);
};

var showDeleteConfirm = function showDeleteConfirm(props, data, reload) {
  confirm(__assign(__assign({
    okText: '确认',
    okType: 'primary',
    cancelText: '取消'
  }, props), {
    content: isFunction(props.content) ? props.content(data) : props.content,
    title: isFunction(props.title) ? props.title(data) : props.title,
    onOk: function onOk() {
      props.onOk(data, reload);
    },
    onCancel: function onCancel() {
      console.log('Cancel');
    }
  }));
};

var showFormDialog = function showFormDialog(_a, data, reload) {
  var jsonFormProps = _a.jsonFormProps,
      modalProps = _a.modalProps,
      onOpen = _a.onOpen,
      onConfirm = _a.onConfirm,
      onCancel = _a.onCancel;
  antd_2.FormDialog(__assign({
    okText: '确认',
    okType: 'primary',
    cancelText: '取消'
  }, modalProps), function () {
    var form = react_1.useForm();
    return React.createElement(YwJsonForm_1['default'], __assign({
      buttons: [],
      form: form
    }, jsonFormProps));
  }).forOpen(function (payload, next) {
    if (isFunction(onOpen)) {
      onOpen(data).then(function (initialValues) {
        next({
          initialValues: initialValues
        });
      });
    } else {
      next({
        initialValues: data
      });
    }
  }).forConfirm(function (payload, next) {
    if (isFunction(onConfirm)) {
      onConfirm(payload.values).then(function () {
        next(payload);
      });
    } else {
      next(payload);
    }
  }).forCancel(function (payload, next) {
    next(payload);
  }).open().then(reload());
};

var handleOperatesClick = function handleOperatesClick(component, componentProps, data, reload) {
  switch (component) {
    case 'ConfirmModal':
      showDeleteConfirm(componentProps, data, reload);
      break;

    case 'FormDialog':
      showFormDialog(componentProps, data, reload);
      break;

    default:
      break;
  }
};

exports.Operates = function (_a) {
  var _b = _a.value,
      value = _b === void 0 ? [] : _b,
      record = _a.record,
      reload = _a.reload;
  return value.map(function (v, i) {
    return React.createElement('span', {
      key: i,
      style: {
        marginRight: '8px'
      }
    }, React.createElement(antd_1.Button, {
      type: 'link',
      danger: v.type === 'danger',
      href: v.href,
      target: v.target,
      disabled: typeof v.disabled === 'function' ? v.disabled({
        record: record
      }) : v.disabled,
      onClick: function onClick(e) {
        if (v.component) {
          handleOperatesClick(v.component, v.componentProps, record, reload);
        } else {
          v.onClick && v.onClick(e, record, reload);
        }
      },
      style: {
        padding: '4px 0'
      }
    }, v.btnText));
  });
};