"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.Time = exports.Tags = exports.Status = exports.Person = exports.MultipleCol = exports.IndexCol = exports.CopyCol = void 0;

var React = _interopRequireWildcard(require("react"));

var _indexModule = _interopRequireDefault(require("../index.module.less"));

var _operates = _interopRequireDefault(require("./operates"));

exports.Operates = _operates["default"];

var _antd = require("antd");

var _utils = require("../../../utils");

var _detailInfo = require("./detailInfo");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var preCssFix = 'yw-table-cell';

var MultipleCol = function MultipleCol(_ref) {
  var value = _ref.value,
      record = _ref.record;
  return value.map(function (_ref2, idx) {
    var label = _ref2.label,
        value = _ref2.value,
        isCopy = _ref2.isCopy,
        tooltip = _ref2.tooltip,
        onClick = _ref2.onClick,
        children = _ref2.children;
    return /*#__PURE__*/React.createElement("div", {
      key: idx,
      style: {
        color: '#666',
        marginTop: idx !== 0 ? '12px' : 0
      },
      className: _indexModule["default"][preCssFix + "-multiple-col"]
    }, /*#__PURE__*/React.createElement("span", {
      className: _indexModule["default"].label
    }, label || '-'), "\uFF1A", /*#__PURE__*/React.createElement(_detailInfo.LongText2Ellipsis, {
      value: value,
      row: 1,
      isCopy: isCopy,
      tooltip: tooltip,
      record: record,
      onClick: onClick
    }, /*#__PURE__*/React.createElement("span", null, children || value || '-')));
  });
};

exports.MultipleCol = MultipleCol;

var IndexCol = function IndexCol(_ref3) {
  var value = _ref3.value,
      record = _ref3.record,
      index = _ref3.index;
  return /*#__PURE__*/React.createElement("div", {
    style: {
      color: '#666'
    },
    className: _indexModule["default"][preCssFix + "-index-col"]
  }, index + 1);
};

exports.IndexCol = IndexCol;

var CopyCol = function CopyCol(_ref4) {
  var value = _ref4.value,
      render = _ref4.render,
      record = _ref4.record;
  return /*#__PURE__*/React.createElement("div", {
    style: {
      color: '#666'
    },
    className: _indexModule["default"][preCssFix + "-copy-col"]
  }, /*#__PURE__*/React.createElement("div", {
    className: _indexModule["default"].content
  }, render(record)), /*#__PURE__*/React.createElement(_detailInfo.Copy, {
    text: value(record)
  }));
};

exports.CopyCol = CopyCol;

var Person = function Person(_ref5) {
  var value = _ref5.value,
      _onClick = _ref5.onClick;
  var canClick = (0, _utils.isFunction)(_onClick);
  return /*#__PURE__*/React.createElement("div", {
    className: _indexModule["default"][preCssFix + "-person"]
  }, /*#__PURE__*/React.createElement("img", {
    className: _indexModule["default"].avatar,
    src: value.avatar,
    alt: "",
    onClick: function onClick() {
      _onClick(value);
    },
    style: {
      cursor: canClick ? 'pointer' : ''
    }
  }), /*#__PURE__*/React.createElement("span", null, value.name));
};

exports.Person = Person;

var Time = function Time(_ref6) {
  var value = _ref6.value;
  return /*#__PURE__*/React.createElement("div", null, value || '/');
};

exports.Time = Time;

var Status = function Status(_ref7) {
  var value = _ref7.value,
      dataSource = _ref7.dataSource,
      _ref7$dict = _ref7.dict,
      dict = _ref7$dict === void 0 ? [] : _ref7$dict;
  var data = dataSource || (0, _utils.formatDictList)(dict) || [];
  var target = data.find(function (v) {
    return v.value === value;
  }) || {};
  return /*#__PURE__*/React.createElement("div", {
    className: _indexModule["default"][preCssFix + "-status"]
  }, /*#__PURE__*/React.createElement("span", {
    className: _indexModule["default"].dot,
    style: {
      background: _utils.COLORMAP[target.color || 'default'] || target.color
    }
  }), target.label || target.value);
};

exports.Status = Status;

var Tags = function Tags(_ref8) {
  var _ref8$value = _ref8.value,
      value = _ref8$value === void 0 ? [] : _ref8$value,
      _ref8$dataSource = _ref8.dataSource,
      dataSource = _ref8$dataSource === void 0 ? [] : _ref8$dataSource;

  var _v = Array.isArray(value) ? value : [value];

  return /*#__PURE__*/React.createElement("div", {
    className: _indexModule["default"][preCssFix + "-tag"]
  }, _v === null || _v === void 0 ? void 0 : _v.map(function (v) {
    var target = dataSource.find(function (data) {
      return data.value === v;
    }) || {};
    return /*#__PURE__*/React.createElement(_antd.Tag, {
      key: target.value,
      color: target.color
    }, target.value);
  }));
};

exports.Tags = Tags;