"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var React = _interopRequireWildcard(require("react"));

var _indexModule = _interopRequireDefault(require("../index.module.less"));

var _antd = require("antd");

var _YwFormDialog = _interopRequireDefault(require("../../YwFormDialog"));

var _YwTableDialog = _interopRequireDefault(require("../../YwTableDialog"));

var _utils = require("../../../utils");

var _YwButton = _interopRequireDefault(require("../../YwButton"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var confirm = _antd.Modal.confirm;
var preCssFix = 'yw-table-cell';

var showDeleteConfirm = function showDeleteConfirm(props, data, reload) {
  confirm((0, _extends2["default"])({
    okText: '确定',
    okType: 'primary',
    cancelText: '取消'
  }, props, {
    content: (0, _utils.isFunction)(props.content) ? props.content(data) : props.content,
    title: (0, _utils.isFunction)(props.title) ? props.title(data) : props.title || '提示',
    onOk: function onOk() {
      return props.onOk(data, reload);
    },
    onCancel: function onCancel() {
      console.log('Cancel');
    }
  }));
};

var handleOperatesClick = function handleOperatesClick(component, componentProps, data, reload) {
  switch (component) {
    case 'ConfirmModal':
      showDeleteConfirm(componentProps, data, reload);
      break;

    default:
      break;
  }
};

var Operates = function Operates(_ref) {
  var _ref$value = _ref.value,
      value = _ref$value === void 0 ? [] : _ref$value,
      record = _ref.record,
      reload = _ref.reload,
      index = _ref.index;
  var showValues = value.filter(function (_ref2) {
    var _ref2$visible = _ref2.visible,
        visible = _ref2$visible === void 0 ? true : _ref2$visible;
    return (0, _utils.isVisible)(visible, record);
  });

  var renderBtn = function renderBtn(_ref3) {
    var i = _ref3.i,
        v = _ref3.v,
        _ref3$btnProps = _ref3.btnProps,
        btnProps = _ref3$btnProps === void 0 ? {} : _ref3$btnProps;
    return /*#__PURE__*/React.createElement("span", {
      key: i,
      style: {
        marginRight: '8px'
      }
    }, /*#__PURE__*/React.createElement(_YwButton["default"], (0, _extends2["default"])({}, v, {
      visible: true,
      btnType: "link",
      danger: v.type === 'danger',
      style: {
        padding: '4px 0'
      },
      disabled: (0, _utils.isDisabled)(v.disabled, record)
    }, btnProps)));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: _indexModule["default"][preCssFix + "-operates"]
  }, showValues.map(function (v, i) {
    if (v.render) {
      return /*#__PURE__*/React.createElement("span", {
        key: i,
        style: {
          marginRight: '8px',
          marginBottom: '12px'
        }
      }, v.render(record, index, reload));
    }

    if (v.component === 'YwFormDialog') {
      return /*#__PURE__*/React.createElement(_YwFormDialog["default"], (0, _extends2["default"])({
        initialValues: record
      }, v.componentProps, {
        onConfirm: function onConfirm(values) {
          return (0, _utils.isFunction)(v.componentProps.onConfirm) && v.componentProps.onConfirm(values, reload);
        }
      }), renderBtn({
        v: v,
        i: i
      }));
    } else if (v.component === 'YwTableDialog') {
      return /*#__PURE__*/React.createElement(_YwTableDialog["default"], (0, _extends2["default"])({}, v.componentProps, {
        onConfirm: function onConfirm(values) {
          return (0, _utils.isFunction)(v.componentProps.onConfirm) && v.componentProps.onConfirm(values, reload);
        }
      }), renderBtn({
        v: v,
        i: i
      }));
    } else {
      return renderBtn({
        v: v,
        i: i,
        btnProps: {
          onClick: function onClick(e) {
            if (v.component) {
              handleOperatesClick(v.component, v.componentProps, record, reload);
            } else {
              v.onClick && v.onClick(e, record, reload);
            }
          }
        }
      });
    }
  }));
};

var _default = Operates;
exports["default"] = _default;