"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = require("react");

var _ahooks = require("ahooks");

var _excluded = ["defaultPageSize"];

var usePagination = function usePagination(service, options) {
  var _result$data;

  var _options$defaultPageS = options.defaultPageSize,
      defaultPageSize = _options$defaultPageS === void 0 ? 20 : _options$defaultPageS,
      rest = (0, _objectWithoutPropertiesLoose2["default"])(options, _excluded);
  var result = (0, _ahooks.useRequest)(service, (0, _extends2["default"])({
    defaultParams: [{
      pageIndex: 1,
      pageSize: defaultPageSize
    }],
    refreshDepsAction: function refreshDepsAction() {
      // eslint-disable-next-line @typescript-eslint/no-use-before-define
      changeCurrent(1);
    }
  }, rest));

  var _ref = result.params[0] || {},
      _ref$pageIndex = _ref.pageIndex,
      pageIndex = _ref$pageIndex === void 0 ? 1 : _ref$pageIndex,
      _ref$pageSize = _ref.pageSize,
      pageSize = _ref$pageSize === void 0 ? defaultPageSize : _ref$pageSize;

  var totalNumber = ((_result$data = result.data) === null || _result$data === void 0 ? void 0 : _result$data.totalNumber) || 0;
  var totalPage = (0, _react.useMemo)(function () {
    return Math.ceil(totalNumber / pageSize);
  }, [pageSize, totalNumber]);

  var onChange = function onChange(c, p) {
    var toCurrent = c <= 0 ? 1 : c;
    var toPageSize = p <= 0 ? 1 : p;
    var tempTotalPage = Math.ceil(totalNumber / toPageSize);

    if (toCurrent > tempTotalPage) {
      toCurrent = Math.max(1, tempTotalPage);
    }

    var _ref2 = result.params || [],
        _ref2$ = _ref2[0],
        oldPaginationParams = _ref2$ === void 0 ? {} : _ref2$,
        restParams = _ref2.slice(1);

    result.run.apply(result, [(0, _extends2["default"])({}, oldPaginationParams, {
      pageIndex: toCurrent,
      pageSize: toPageSize
    })].concat(restParams));
  };

  var changeCurrent = function changeCurrent(c) {
    onChange(c, pageSize);
  };

  var changePageSize = function changePageSize(p) {
    onChange(pageIndex, p);
  };

  return (0, _extends2["default"])({}, result, {
    pagination: {
      current: pageIndex,
      pageSize: pageSize,
      total: totalNumber,
      totalPage: totalPage,
      onChange: (0, _ahooks.useMemoizedFn)(onChange),
      changeCurrent: (0, _ahooks.useMemoizedFn)(changeCurrent),
      changePageSize: (0, _ahooks.useMemoizedFn)(changePageSize),
      showTotal: function showTotal(total) {
        return "\u5171 " + total + " \u6761";
      }
    }
  });
};

var _default = usePagination;
exports["default"] = _default;