"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _rcResizeObserver = _interopRequireDefault(require("rc-resize-observer"));

var _reactWindow = require("react-window");

var _antd = require("antd");

var _indexModule = _interopRequireDefault(require("./index.module.less"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var VirtualTable = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var columns = props.columns,
      scroll = props.scroll,
      _props$rowHeight = props.rowHeight,
      _rowHeight = _props$rowHeight === void 0 ? 100 : _props$rowHeight;

  var _useState = (0, _react.useState)(0),
      tableWidth = _useState[0],
      setTableWidth = _useState[1];

  var widthColumnCount = columns === null || columns === void 0 ? void 0 : columns.filter(function (_ref) {
    var width = _ref.width;
    return !width;
  }).length;
  var mergedColumns = columns === null || columns === void 0 ? void 0 : columns.map(function (column) {
    if (column.width) {
      return column;
    }

    return (0, _extends2["default"])({}, column, {
      width: Math.floor(tableWidth / widthColumnCount)
    });
  });
  var gridRef = (0, _react.useRef)();

  var _useState2 = (0, _react.useState)(function () {
    var obj = {};
    Object.defineProperty(obj, 'scrollLeft', {
      get: function get() {
        if (gridRef.current) {
          var _gridRef$current, _gridRef$current$stat;

          return (_gridRef$current = gridRef.current) === null || _gridRef$current === void 0 ? void 0 : (_gridRef$current$stat = _gridRef$current.state) === null || _gridRef$current$stat === void 0 ? void 0 : _gridRef$current$stat.scrollLeft;
        }

        return null;
      },
      set: function set(scrollLeft) {
        if (gridRef.current) {
          gridRef.current.scrollTo({
            scrollLeft: scrollLeft
          });
        }
      }
    });
    return obj;
  }),
      connectObject = _useState2[0];

  var resetVirtualGrid = function resetVirtualGrid() {
    var _gridRef$current2;

    (_gridRef$current2 = gridRef.current) === null || _gridRef$current2 === void 0 ? void 0 : _gridRef$current2.resetAfterIndices({
      columnIndex: 0,
      shouldForceUpdate: true
    });
  };

  var scrollTo = function scrollTo(props) {
    var _gridRef$current3;

    (_gridRef$current3 = gridRef.current) === null || _gridRef$current3 === void 0 ? void 0 : _gridRef$current3.scrollTo(props);
  };

  (0, _react.useImperativeHandle)(ref, function () {
    return {
      scrollTo: scrollTo
    };
  });
  (0, _react.useEffect)(function () {
    return resetVirtualGrid;
  }, [tableWidth]);

  var renderVirtualList = function renderVirtualList(rawData, _ref2) {
    var scrollbarSize = _ref2.scrollbarSize,
        ref = _ref2.ref,
        _onScroll = _ref2.onScroll;
    ref.current = connectObject;
    var totalHeight = rawData.length * _rowHeight;
    return /*#__PURE__*/_react["default"].createElement(_reactWindow.VariableSizeGrid, {
      ref: gridRef,
      className: "virtual-grid",
      columnCount: mergedColumns.length,
      columnWidth: function columnWidth(index) {
        var width = mergedColumns[index].width;
        return totalHeight > scroll.y && index === mergedColumns.length - 1 ? width - scrollbarSize - 1 : width;
      },
      height: scroll.y,
      rowCount: rawData.length,
      rowHeight: function rowHeight() {
        return _rowHeight;
      },
      width: tableWidth,
      onScroll: function onScroll(_ref3) {
        var scrollLeft = _ref3.scrollLeft,
            scrollTop = _ref3.scrollTop;

        _onScroll({
          scrollLeft: scrollLeft,
          scrollTop: scrollTop
        });

        props.onScroll && props.onScroll({
          scrollLeft: scrollLeft,
          scrollTop: scrollTop
        });
      }
    }, function (_ref4) {
      var columnIndex = _ref4.columnIndex,
          rowIndex = _ref4.rowIndex,
          style = _ref4.style;
      var render = mergedColumns[columnIndex].render;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: _indexModule["default"]['virtual-table-cell'] + " " + (columnIndex === mergedColumns.length - 1 ? 'virtual-table-cell-last' : '') // className={classNames('virtual-table-cell', {
        //   'virtual-table-cell-last': columnIndex === mergedColumns.length - 1,
        // })}
        ,
        style: style
      }, render ? render(rawData[rowIndex][mergedColumns[columnIndex].dataIndex], rawData[rowIndex], rowIndex) : rawData[rowIndex][mergedColumns[columnIndex].dataIndex]);
    });
  };

  return /*#__PURE__*/_react["default"].createElement(_rcResizeObserver["default"], {
    onResize: function onResize(_ref5) {
      var width = _ref5.width;
      setTableWidth(width);
    }
  }, /*#__PURE__*/_react["default"].createElement(_antd.Table, (0, _extends2["default"])({}, props, {
    className: "virtual-table",
    columns: mergedColumns,
    pagination: false,
    components: {
      body: renderVirtualList
    }
  })));
});

var _default = VirtualTable;
exports["default"] = _default;