"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _antd = require("antd");

var _utils = require("../../utils");

var _index = _interopRequireDefault(require("../YwFilter/index"));

var _index2 = _interopRequireDefault(require("../YwTable/index"));

var _index3 = _interopRequireDefault(require("../YwButton/index"));

var _excluded = ["title", "size", "btnText", "btnType", "filterItems", "columns", "getTableData", "initialValues", "btnDisabled", "children", "itemWidth", "buttons", "rowSelection", "rowKey", "pagination", "onClose", "onSubmit", "onOpen", "onTableInit", "okText", "onOk"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var widthMap = {
  s: 680,
  m: 920,
  l: 1200,
  full: '100vw'
};

var YwTableDialog = function YwTableDialog(_ref) {
  var title = _ref.title,
      size = _ref.size,
      btnText = _ref.btnText,
      btnType = _ref.btnType,
      filterItems = _ref.filterItems,
      columns = _ref.columns,
      getTableData = _ref.getTableData,
      initialValues = _ref.initialValues,
      btnDisabled = _ref.btnDisabled,
      children = _ref.children,
      itemWidth = _ref.itemWidth,
      buttons = _ref.buttons,
      rowSelection = _ref.rowSelection,
      rowKey = _ref.rowKey,
      pagination = _ref.pagination,
      onClose = _ref.onClose,
      onSubmit = _ref.onSubmit,
      onOpen = _ref.onOpen,
      onTableInit = _ref.onTableInit,
      okText = _ref.okText,
      onOk = _ref.onOk,
      others = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  var _useState = (0, _react.useState)(others.visible || false),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      spinning = _useState2[0],
      setSpinning = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      filterProps = _useState3[0],
      setFilterProps = _useState3[1];

  var _useState4 = (0, _react.useState)([]),
      selectKeys = _useState4[0],
      setSelectKeys = _useState4[1];

  var _useState5 = (0, _react.useState)([]),
      selectData = _useState5[0],
      setSelectData = _useState5[1];

  var _useState6 = (0, _react.useState)(null),
      selectInfo = _useState6[0],
      setSelectInfo = _useState6[1];

  var formRef = (0, _react.useRef)(null);
  var isControl = (0, _react.useMemo)(function () {
    return others.visible !== undefined;
  }, []);

  var showModal = function showModal() {
    if ((0, _utils.isFunction)(onOpen)) {
      setSpinning(true);
      onOpen().then(function (initialValues) {})["finally"](function () {
        setSpinning(false);
      });
    }
  };

  var handleCancel = function handleCancel() {
    onClose();
  }; //   const handleOk = () => {
  //     onConfirm(value).finally(() => {
  //       setVisible(false);
  //     });
  //   };


  var handleInit = function handleInit() {
    setFilterProps(initialValues || {});
    setSelectData([]);
    setSelectKeys([]);
    setSelectInfo(null);
    formRef.current && formRef.current.reset();
  };

  (0, _react.useEffect)(function () {
    setVisible(others.visible);
  }, [others.visible]);
  (0, _react.useEffect)(function () {
    if (visible) {
      handleInit();
    }
  }, [visible]);

  var SubmitButton = function SubmitButton() {
    if (rowSelection) {
      return /*#__PURE__*/_react["default"].createElement(_index3["default"], {
        btnType: "primary",
        onClick: function onClick() {
          onOk && onOk(selectKeys, selectData, selectInfo);
        }
      }, okText);
    }

    return null;
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, !isControl && /*#__PURE__*/_react["default"].createElement("div", {
    onClick: function onClick() {
      setVisible(true);
    },
    style: {
      display: 'inline-block'
    }
  }, children || /*#__PURE__*/_react["default"].createElement(_antd.Button, {
    type: btnType,
    disabled: btnDisabled
  }, btnText)), /*#__PURE__*/_react["default"].createElement(_antd.Modal, (0, _extends2["default"])({}, others, {
    wrapClassName: _indexModule["default"]['yw-table-dialog'],
    title: title,
    width: widthMap[size],
    visible: visible,
    onCancel: function onCancel() {
      !isControl ? setVisible(false) : onClose();
    },
    destroyOnClose: true,
    footer: [/*#__PURE__*/_react["default"].createElement(_index3["default"], {
      key: "back",
      onClick: function onClick() {
        !isControl ? setVisible(false) : onClose();
      }
    }, "\u5173\u95ED"), /*#__PURE__*/_react["default"].createElement(SubmitButton, null)]
  }), /*#__PURE__*/_react["default"].createElement(_antd.Spin, {
    spinning: spinning
  }, filterItems && visible && /*#__PURE__*/_react["default"].createElement(_index["default"], {
    items: filterItems,
    onCreate: function onCreate(_form) {
      formRef.current = _form;
    },
    itemWidth: itemWidth,
    initialValues: initialValues // onSubmit={setFilterProps}
    // hasSearchBtn={false}
    ,
    onSubmit: function onSubmit(data) {
      setFilterProps((0, _extends2["default"])({}, data));
    },
    maxColumns: 2
  }), /*#__PURE__*/_react["default"].createElement(_index2["default"], {
    filterProps: filterProps,
    ref: function ref(_ref2) {
      _ref2 && (0, _utils.isFunction)(onTableInit) && onTableInit(_ref2);
    },
    columns: columns,
    rowKey: rowKey,
    getTableData: getTableData,
    buttons: buttons,
    rowSelection: rowSelection ? (0, _extends2["default"])({
      onChange: function onChange(keys, data, info) {
        setSelectKeys(keys);
        setSelectData(data);
        setSelectInfo(info);
        rowSelection.onChange && rowSelection.onChange(keys, data, info);
      }
    }, rowSelection) : rowSelection,
    pagination: pagination ? (0, _extends2["default"])({
      size: 'small'
    }, pagination) : pagination
  }))));
};

YwTableDialog.defaultProps = {
  btnType: 'primary',
  size: 'm',
  btnDisabled: false,
  rowKey: 'id',
  rowSelection: null,
  pagination: {},
  okText: '确定',
  buttons: [],
  onClose: function onClose() {},
  onSubmit: function onSubmit() {}
};
var _default = YwTableDialog;
exports["default"] = _default;