"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _indexModule = _interopRequireDefault(require("./index.module.less"));

var _YwButton = _interopRequireDefault(require("../../components/YwButton"));

var _YSearchSelect = require("../YwJsonForm/YSearchSelect");

var _index = require("../../utils/index");

var _excluded = ["maxItems", "defaultValue", "fieldNames", "fetchOptions", "tagRender", "labelInValue", "children", "onOk", "value", "placeholder", "autoFocus", "showSearch"],
    _excluded2 = ["label", "value"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ModalSelector = function ModalSelector(_ref) {
  var maxItems = _ref.maxItems,
      _ref$defaultValue = _ref.defaultValue,
      defaultValue = _ref$defaultValue === void 0 ? [] : _ref$defaultValue,
      fieldNames = _ref.fieldNames,
      fetchOptions = _ref.fetchOptions,
      tagRender = _ref.tagRender,
      labelInValue = _ref.labelInValue,
      children = _ref.children,
      onOk = _ref.onOk,
      value = _ref.value,
      placeholder = _ref.placeholder,
      autoFocus = _ref.autoFocus,
      showSearch = _ref.showSearch,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);

  var _useState = (0, _react.useState)(false),
      confirmLoading = _useState[0],
      setConfirmLoading = _useState[1];

  var _useState2 = (0, _react.useState)(true),
      open = _useState2[0],
      setOpen = _useState2[1];

  var _selectRef = (0, _react.useRef)(null);

  var _useState3 = (0, _react.useState)(defaultValue),
      selectValue = _useState3[0],
      setSelectValue = _useState3[1];

  (0, _react.useEffect)(function () {
    value && setSelectValue(value);
  }, [value]); // useEffect(() => {
  //   if (selectValue?.length > maxItems) {
  //   }
  // }, [selectValue, maxItems]);

  return /*#__PURE__*/_react["default"].createElement(_antd.Modal, (0, _extends3["default"])({
    className: _indexModule["default"]['modal-selector'],
    maskClosable: false,
    keyboard: false,
    destroyOnClose: true,
    footer: null,
    width: 680
  }, props), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['modal-selector-left'],
    onClick: function onClick() {
      var _selectRef$current;

      !props.disabled && (_selectRef === null || _selectRef === void 0 ? void 0 : (_selectRef$current = _selectRef.current) === null || _selectRef$current === void 0 ? void 0 : _selectRef$current.focus());
    }
  }, /*#__PURE__*/_react["default"].createElement(_YSearchSelect.DebounceSelect, {
    bordered: false,
    selectRef: function selectRef(el) {
      if (el) {
        _selectRef.current = el.current;
      }
    },
    defaultValue: defaultValue,
    mode: "multiple",
    showArrow: false,
    style: {
      width: '100%'
    },
    placeholder: placeholder,
    value: selectValue !== null && selectValue !== void 0 && selectValue.length ? selectValue : null,
    labelInValue: labelInValue,
    autoFocus: true,
    showSearch: showSearch,
    onChange: function onChange(nextValue, data) {
      if ((nextValue === null || nextValue === void 0 ? void 0 : nextValue.length) > maxItems) {
        _antd.message.error('超过数量限制');

        setOpen(false);
        return;
      }

      props.onChange(nextValue, data);
      setOpen(false); // setSelectValue(nextValue);
    },
    onBlur: function onBlur() {
      setOpen(false);
    },
    onKeywordChange: function onKeywordChange() {
      setOpen(true);
    },
    open: open,
    disabled: props.disabled,
    tagRender: tagRender,
    fieldNames: fieldNames,
    dropdownClassName: _indexModule["default"]['dropdown-selector'],
    dropdownRender: function dropdownRender(menu) {
      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
        className: _indexModule["default"]['dropdown-selector-help']
      }, "\u60A8\u53EF\u80FD\u60F3\u627E"), menu);
    },
    allowClear: true,
    fetchOptions: fetchOptions
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['modal-selector-left-footer']
  }, /*#__PURE__*/_react["default"].createElement(_YwButton["default"], {
    loading: confirmLoading,
    disabled: (selectValue === null || selectValue === void 0 ? void 0 : selectValue.length) > maxItems,
    btnText: "\u786E\u5B9A (" + (selectValue === null || selectValue === void 0 ? void 0 : selectValue.length) + "/" + (maxItems || (selectValue === null || selectValue === void 0 ? void 0 : selectValue.length)) + ")",
    onClick: function onClick() {
      var value = selectValue === null || selectValue === void 0 ? void 0 : selectValue.map(function (_ref2) {
        var _extends2;

        var label = _ref2.label,
            value = _ref2.value,
            v = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded2);
        return (0, _extends3["default"])({}, v, (_extends2 = {}, _extends2[fieldNames.label] = label, _extends2[fieldNames.value] = value, _extends2));
      });

      if (_index.obj.isPromise(onOk)) {
        setConfirmLoading(true);
        onOk(value).then(function () {
          props.onCancel();
        })["finally"](function () {
          setConfirmLoading(false);
        });
      } else {
        onOk(value);
        props.onCancel();
      }
    },
    type: "primary"
  }), /*#__PURE__*/_react["default"].createElement(_YwButton["default"], {
    btnText: "\u53D6 \u6D88",
    onClick: props.onCancel
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: _indexModule["default"]['modal-selector-right']
  }, children));
};

ModalSelector.defaultProps = {
  onOk: function onOk() {},
  defaultValue: null,
  labelInValue: true,
  placeholder: '搜索...',
  onChange: function onChange() {},
  onCancel: function onCancel() {},
  fieldNames: {
    label: 'label',
    value: 'value'
  }
};
var _default = ModalSelector;
exports["default"] = _default;