"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.str = exports.obj = exports.isVisible = exports.isObject = exports.isFunction = exports.isDisabled = exports.isArray = exports.hoc = exports.func = exports.formatOptionsList = exports.formatDictList = exports.formatDataList = exports.StatusTypeIcon = exports.RANGES = exports.COLORMAP = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _icons = require("@ant-design/icons");

var _moment = _interopRequireDefault(require("moment"));

var React = _interopRequireWildcard(require("react"));

var _func = _interopRequireWildcard(require("./func"));

var _object = _interopRequireWildcard(require("./object"));

var _string = _interopRequireWildcard(require("./string"));

var _hoc = _interopRequireWildcard(require("./hoc"));

var _excluded = ["label", "value"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var isFunction = function isFunction(value) {
  return typeof value === 'function';
};

exports.isFunction = isFunction;

var isObject = function isObject(obj) {
  return Object.prototype.toString.call(obj) === '[object Object]';
};

exports.isObject = isObject;

var isArray = function isArray(arr) {
  return Object.prototype.toString.call(arr) === '[object Array]';
};

exports.isArray = isArray;
var COLORMAP = {
  primary: '#1890FF',
  success: '#23CBB7',
  error: '#F15A5A',
  warning: '#FAAD14',
  info: '#999',
  other: '#9C7AFF',
  "default": '#999'
};
exports.COLORMAP = COLORMAP;
var RANGES = {
  昨天: [(0, _moment["default"])().subtract(1, 'days'), (0, _moment["default"])().subtract(1, 'days')],
  今天: [(0, _moment["default"])(), (0, _moment["default"])()],
  '7天': [(0, _moment["default"])().subtract(6, 'days'), (0, _moment["default"])()],
  '15天': [(0, _moment["default"])().subtract(14, 'days'), (0, _moment["default"])()],
  '30天': [(0, _moment["default"])().subtract(29, 'days'), (0, _moment["default"])()],
  本月: [(0, _moment["default"])().startOf('month'), (0, _moment["default"])().endOf('month')],
  本周: [(0, _moment["default"])().startOf('week'), (0, _moment["default"])().endOf('week')],
  上月: [(0, _moment["default"])().subtract(1, 'months').startOf('month'), (0, _moment["default"])().subtract(1, 'months').endOf('month')],
  上周: [(0, _moment["default"])().subtract(1, 'week').startOf('week'), (0, _moment["default"])().subtract(1, 'week').endOf('week')]
};
exports.RANGES = RANGES;

var isVisible = function isVisible(visible, data) {
  if (visible === void 0) {
    visible = true;
  }

  return isFunction(visible) ? visible(data) : visible;
};

exports.isVisible = isVisible;

var isDisabled = function isDisabled(disabled, data) {
  return isFunction(disabled) ? disabled(data) : disabled;
};

exports.isDisabled = isDisabled;
var StatusTypeIcon = {
  success: /*#__PURE__*/React.createElement(_icons.CheckCircleFilled, null),
  warning: /*#__PURE__*/React.createElement(_icons.ExclamationCircleFilled, null),
  error: /*#__PURE__*/React.createElement(_icons.CloseCircleFilled, null),
  help: /*#__PURE__*/React.createElement(_icons.QuestionCircleFilled, null),
  notice: /*#__PURE__*/React.createElement(_icons.InfoCircleFilled, null)
};
exports.StatusTypeIcon = StatusTypeIcon;

var formatDictList = function formatDictList(dictList) {
  if (dictList === void 0) {
    dictList = [];
  }

  return dictList.map(function (dict) {
    return (0, _extends3["default"])({
      value: dict.dictValue,
      label: dict.dictName
    }, isObject(dict.extParams) ? dict.extParams : {});
  });
};

exports.formatDictList = formatDictList;

var formatOptionsList = function formatOptionsList(dataList, fieldNames) {
  if (fieldNames === void 0) {
    fieldNames = {
      label: 'label',
      value: 'value',
      children: 'children'
    };
  }

  if (!dataList) return null;
  return dataList.map(function (data) {
    return (0, _extends3["default"])({}, data, data[fieldNames.value] !== undefined ? {
      value: data[fieldNames.value]
    } : {}, data[fieldNames.label] !== undefined ? {
      label: data[fieldNames.label]
    } : {}, data[fieldNames.children] ? {
      children: formatOptionsList(data[fieldNames.children], fieldNames)
    } : {});
  });
};

exports.formatOptionsList = formatOptionsList;

var formatDataList = function formatDataList(dataList, fieldNames) {
  if (fieldNames === void 0) {
    fieldNames = {
      label: 'label',
      value: 'value',
      children: 'children'
    };
  }

  if (!dataList) return null;
  return dataList.map(function (_ref) {
    var _extends2;

    var label = _ref.label,
        value = _ref.value,
        data = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
    return (0, _extends3["default"])((_extends2 = {}, _extends2[fieldNames.value] = value, _extends2[fieldNames.label] = label, _extends2), data[fieldNames.children] ? {
      children: formatDataList(data[fieldNames.children], fieldNames)
    } : {}, data);
  });
};

exports.formatDataList = formatDataList;
var func = _func;
exports.func = func;
var obj = _object;
exports.obj = obj;
var str = _string;
exports.str = str;
var hoc = _hoc;
exports.hoc = hoc;